//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTCOLOR_H_
#define _GLGTCOLOR_H_

#include "GLGTBase.h"



//********************************************************************
/// \brief RGBAJ[NX
/// 
/// 
/// 
/// 
template <typename T> class GLGTColor4
{
    //---------- o ----------
public:
    T r;
    T g;
    T b;
    T a;
    //---------- RXgN^ ----------
public:
    //GLGTColor4(): r(0), g(0), b(0), a(0) {};
    GLGTColor4() {};
    GLGTColor4(T in_r, T in_g, T in_b, T in_a): r(in_r), g(in_g), b(in_b), a(in_a) {}
    GLGTColor4(const GLGTColor4& c): r(c.r), g(c.g), b(c.b), a(c.a) {}

    //---------- Iy[^ ----------  
public:
    //[]
    T& operator [] (unsigned int i) {
        GLGTASSERT(i<4);
        return( (i == 0) ? r : (i == 1) ? g : (i == 2) ? b : a );
    }
    const T& operator [] (unsigned int i) const {
        GLGTASSERT(i<4);
        return( (i == 0) ? r : (i == 1) ? g : (i == 2) ? b : a );
    }
    //+-
    GLGTColor4<T>& operator += (const GLGTColor4<T>& v) {
        r += v.r;
        g += v.g;
        b += v.b;
        a += v.a;
        return *this;
    }
    //-=
    GLGTColor4<T>& operator -= (const GLGTColor4<T>& v) {
        r -= v.r;
        g -= v.g;
        b -= v.b;
        a -= v.a;
        return *this;
    }
    //*=
    GLGTColor4<T>& operator *= (T t) {
        r *= t;
        g *= t;
        b *= t;
        a *= t;
        return *this;
    }
    ///=
    GLGTColor4<T>& operator /= (T t) {
        GLGTASSERT(t!=0);
        r /= t;
        g /= t;
        b /= t;
        a /= t;
        return *this;
    }
    //==
    friend bool operator == (const GLGTColor4<T>& a, const GLGTColor4<T>& b) {
        return((a.r == b.r)&&(a.g == b.g)&&(a.b == b.b)&&(a.a == b.a));
    }
    //!=
    friend bool operator != (const GLGTColor4<T>& a, const GLGTColor4<T>& b) {
        return((a.r != b.r)||(a.g != b.g)||(a.b != b.b)||(a.a != b.a));
    }
    //-
    friend GLGTColor4<T> operator -(const GLGTColor4<T>& a) {
        return GLGTColor4<T>(-a.r, -a.g, -a.b, -a.a);
    }
    //+
    friend GLGTColor4<T> operator +(const GLGTColor4<T>& a, const GLGTColor4<T>& b) {
        GLGTColor4<T> ret(a);
        ret += b;
        return ret;
    }
    // -
    friend GLGTColor4<T> operator -(const GLGTColor4<T>& a, const GLGTColor4<T>& b) {
        GLGTColor4<T> ret(a);
        ret -= b;
        return ret;
    }
    // *
    friend GLGTColor4<T> operator *(const GLGTColor4<T>& v, T t) {
        return GLGTColor4<T>(t*v.r, t* v.g, t*v.b, t*v.a);
    }
    // *
    friend GLGTColor4<T> operator *(T t, const GLGTColor4<T>& v) {
        return GLGTColor4<T>(t*v.r, t* v.g, t*v.b, t*v.w);
    }
    // /
    friend GLGTColor4<T> operator /(const GLGTColor4<T>& v, T t) {
        GLGTASSERT (t!=0);
        return GLGTColor4<T>(v.r/t, v.g/t, v.b/t, v.a/t);
    }
    //---------- \bh ----------  
public:
    void set(T in_r, T in_g, T in_b, T in_a) {
        r = in_r;
        g = in_g;
        b = in_b;
        a = in_a;
    }
    // 01͈̔͂Ɏ߂
    void adjust(void) {
        if     (r > 1.0) { r = 1.0; }
        else if(r < 0.0) { r = 0.0; }
        if     (g > 1.0) { g = 1.0; }
        else if(g < 0.0) { g = 0.0; }
        if     (b > 1.0) { b = 1.0; }
        else if(b < 0.0) { b = 0.0; }
        if     (a > 1.0) { a = 1.0; }
        else if(a < 0.0) { a = 0.0; }
    }
    //minmax͈̔͂Ɏ߂
    void adjust(T min, T max) {
        if     (r > max) { r = max; }
        else if(r < min) { r = min; }
        if     (g > max) { g = max; }
        else if(g < min) { g = min; }
        if     (b > max) { b = max; }
        else if(b < min) { b = min; }
        if     (a > max) { a = max; }
        else if(a < min) { a = min; }
    }


};




#endif
