//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTCONFIGFILE_H_
#define _GLGTCONFIGFILE_H_

#include <string>
#include <vector>
#include <fstream>

#include "GLGTBase.h"
#include "GLGTFlagArray.h"
#include "GLGTUtility.h"



//********************************************************************
/// \brief GLGTStringBox̃[h
/// 
enum GLGTConfigFileMode {
    GLGTCONFIGFILEMODE_LOADWITHOUTCOMMENT, ///< RtBOt@C[hɃRgǂݍ܂Ȃ
    GLGTCONFIGFILEMODE_SAVEWITHOUTCOMMENT, ///< RtBOt@CZ[uɃRg܂Ȃ

    SIZE_GLGTCONFIGFILEMODE
};


//********************************************************************
/// \brief RtBOt@C̊evfێNX
/// 
/// 
/// 
class GLGTConfigElement {
    // vpeB ****************************************
public:
    std::string key; ///< L[
    std::vector<std::string> value; ///< l
    std::string comment; ///< Rg


protected:
private:



    // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief ftHgRXgN^
    GLGTConfigElement(void) {
        key.erase();
        value.clear();
        comment.erase();
    }
    //////////////////////////////////////////////////
    /// \brief Rs[RXgN^
    GLGTConfigElement(const GLGTConfigElement& in) : key(in.key), value(in.value), comment(in.comment) {}
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTConfigElement(const std::string& in_key, const std::vector<std::string>& in_value, const std::string& in_comment)
        : key(in_key), value(in_value), comment(in_comment) 
    {}
    //////////////////////////////////////////////////
    /// \brief RXgN^
    /// 
    /// L[ƒlvectorɊi[Ăꍇ
    ///
    GLGTConfigElement(const std::vector<std::string>& in_keyandvalue, const std::string& in_comment) : comment(in_comment) {
        value.clear();

        if     (in_keyandvalue.size() == 0) {key.erase();}
        else if(in_keyandvalue.size() == 1) {key = in_keyandvalue[0];}
        else {
            key = in_keyandvalue[0];
            std::vector<std::string>::size_type valuesize = in_keyandvalue.size();
            for(std::vector<std::string>::size_type i = 1; i< valuesize; i++) {
                value.push_back(in_keyandvalue[i]);
            }
        }
    }
    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTConfigElement() {}



    //////////////////////////////////////////////////
    /// \brief configElementɃANZX
    const std::string& operator [](unsigned int i) const {
        GLGTASSERT(i<value.size());
        return value[i];
    }


    //////////////////////////////////////////////////
    /// \brief ̃f[^
    bool isEmpty(void) const {
        return ((key.size()==0)&&(value.size()==0)&&(comment.size()==0));
    }



    // J ****************************************
protected:



private:


};



//********************************************************************
/// \brief RtBOt@C(*.cfg)NX
/// 
/// 
/// 
/// 
class GLGTConfigFile {

    // vpeB ****************************************
public:
    GLGTFlagArray<GLGTConfigFileMode> configFileMode;       ///< [h
protected:
    std::string configFileName;                       ///< RtBOt@C
    std::vector<GLGTConfigElement> configElement;           ///< RtBO̗vf
    const static GLGTConfigElement emptyElement;
    std::string commentCommand;                             ///< Rg̃R}h(F//) ""ȂRg݂͑ȂƂ݂ȂB
    
    bool loaded;                                            ///< [hĂ邩
    



private:

public:
    //////////////////////////////////////////////////
    /// \brief ftHgRXgN^
     GLGTConfigFile(void);
    //////////////////////////////////////////////////
    /// \brief RXgN^
    /// 
    /// \param in_filename t@C
    explicit GLGTConfigFile(const std::string& in_filename);
    //////////////////////////////////////////////////
    /// \brief RXgN^
    /// 
    /// \param in_filename t@C
    /// \param in_commentcmd Rg̃R}h
    explicit GLGTConfigFile(const std::string& in_filename, const std::string& in_commentcmd);

    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTConfigFile();


    //////////////////////////////////////////////////
    /// \brief configElementɃANZX
    const GLGTConfigElement& operator [](unsigned int i) const {
        GLGTASSERT(i<configElement.size());
        return configElement[i];
    }


    //////////////////////////////////////////////////
    /// \brief j
    void destroy(void);
    
    //////////////////////////////////////////////////
    /// \brief is
    bool isLoaded(void) const {
        return loaded;
    }
    

    //////////////////////////////////////////////////
    /// \brief vf𐔂
    unsigned int getConfigElementCount(void) const {
        return (unsigned int)configElement.size();
    }
    
    //////////////////////////////////////////////////
    /// \brief configElementL[T
    ///
    /// ΂̗vfԂB
    /// Ȃ΋̗vfԂB(key,valuẽTCY0)
    ///
    /// \param in_key L[
    const GLGTConfigElement& getConfigElement(const std::string& in_key) const {
        if(in_key.size() == 0) {return emptyElement;}
        std::vector<std::string>::size_type size = configElement.size();
        for(std::vector<std::string>::size_type i = 0; i < size; i++) {
            if(configElement[i].key == in_key) {
                return configElement[i];
            }
        }
         return emptyElement;
     }



    //////////////////////////////////////////////////
    /// \brief configElementZbgB
    ///
    /// L[ɊYvf݂ꍇ͏㏑B݂Ȃꍇ͒ǉB
    ///
    ///
    void setConfigElement(const std::string& in_key, const std::vector<std::string>& in_value) {
        std::vector<std::string>::size_type size = configElement.size();
        for(std::vector<std::string>::size_type i = 0; i < size; i++) {
            if(configElement[i].key == in_key) {
                configElement[i].value = in_value;
                return;
            }
        }
        configElement.push_back(GLGTConfigElement(in_key,in_value,(std::string)""));
     }



    //////////////////////////////////////////////////
    /// \brief t@Cǂݍ
    /// 
    /// L[̗vf݂ꍇ͑O̗vfD悷B(͖̂̂B)
    /// <BR>
    /// 
    /// \retval true 
    /// \retval false s
    bool load(void);



    // getter/setter ****************************************
  
    //////////////////////////////////////////////////
    /// \brief getter of configFileMode
    const std::string& getConfigFileName(void) const {return configFileName;}  
    //////////////////////////////////////////////////
    /// \brief setter of configFileMode
    void setConfigFileName(const std::string& in_filename) {configFileName = in_filename;}


    //////////////////////////////////////////////////
    /// \brief getter of commentCommand
    const std::string& getCommentCommand(void) const {return commentCommand;}
    //////////////////////////////////////////////////
    /// \brief setter of commentCommand
    void setCommentCommand(const std::string& in_commentcmd) {commentCommand = in_commentcmd;}


    //////////////////////////////////////////////////
    /// \brief getter of 
    // get(void) const {}  
    //////////////////////////////////////////////////
    /// \brief setter of 
    //void set( in_) {}


    //////////////////////////////////////////////////
    /// \brief getter of 
    // get(void) const {}  
    //////////////////////////////////////////////////
    /// \brief setter of 
    //void set( in_) {}





    // J ****************************************
protected:
    



private:
    //////////////////////////////////////////////////
    /// \brief vpeB
    void clear(void);

    //////////////////////////////////////////////////
    /// \brief =
    ///
    /// ȂB
    /// 
    GLGTConfigFile& operator =(const GLGTConfigFile& in) const {}
    
    
    

};


#endif
