//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTCONSOLEBOX_H_
#define _GLGTCONSOLEBOX_H_


#include "GLGTBase.h"
#include "GLGTFlagArray.h"
#include "GLGTTextBox.h"
#include "GLGTStringBox.h"
#include "GLGTMath.h"
#include "GLGTColor.h"


//********************************************************************
/// \brief GLGTConsoleBox̃[h
/// 
enum GLGTConsoleModeBox {
    GLGTCONSOLEBOXMODE_AUTOINSERTION, ///< ͂ꂽŃOɒǉB

    GLGTCONSOLEMODE_LAST
} ;



//********************************************************************
/// \brief R\[{bNX
/// 
/// R\[V[p
/// 
/// 
class GLGTConsoleBox {

    // vpeB ****************************************
public:
    GLGTFlagArray<GLGTConsoleModeBox> consoleMode;     ///< [h
protected:
    static bool staticMemberInitialized;            ///< X^eBbNoꂽ

    static std::string inputtedString;              ///< ͂ꂽ

    static GLGTStringBox inputtingString;           ///< ͒̕
    static GLGTRectEXT inputtingStringRect;         ///< inputtingString̈ʒuETCY

    static GLGTTextBox logText;                     ///< R\[̃O
    static GLGTRectEXT logTextRect;                 ///< logTexẗʒuETCY


    // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTConsoleBox(void) : consoleMode(GLGTCONSOLEMODE_LAST) {
        consoleMode.clear();


    }


    //////////////////////////////////////////////////
    /// \brief fXgN^
    virtual ~GLGTConsoleBox() {}



    //////////////////////////////////////////////////
    /// \brief X^eBbNo
    /// 
    /// ĂȂꍇ͏B
    /// <BR>
    /// GLGTFontRendererꂽɌĂяoȂ΂ȂȂB
    /// 
    /// 
    void initStaticMember(unsigned int console_width, unsigned int console_height,
        unsigned int margin = 2, unsigned int fontscale = 1);



    //////////////////////////////////////////////////
    /// \brief m肵͍ςݕ擾B
    /// 
    /// ͂AEnterL[ꂽꍇɊm肷B
    /// ̊֐ĂяoƁAŕێĂm͕폜B
    /// m͍ςݕ񂪑݂ĂƂ́A
    /// ̊֐ĂяoŃNA܂ŐVȓ͂󂯕tȂB
    /// 
    /// \param str m肵͍ςݕ񂪂ꍇɃRs[
    /// \return m肵͍ςݕ񂪑݂邩
    /// 
    bool getInputtedString(std::string& str) {
        if(inputtedString == "") {return false;}
        str = inputtedString;
        inputtedString = "";
        inputtingString.clearString();

        if(consoleMode[GLGTCONSOLEBOXMODE_AUTOINSERTION] == true) {
            insertLineToLogText(str);
        }


        return true;
    }



    //////////////////////////////////////////////////
    /// \brief inputtingStringɕǉ
    ///
    /// m肵͍ςݕ񂪑݂ꍇ͉ȂB<BR>
    /// \\n̏ꍇ͕m肷B<BR>͒̕񂪋̏ꍇ͉ȂB
    /// \\b̏ꍇ͈ꕶ炷B
    ///̑̐䕶͖B
    ///
    void inputChar(char in_char);


    //////////////////////////////////////////////////
    /// \brief OɍsǉB(FdefaultTextColor)
    ///
    ///
    ///
    void insertLineToLogText(const std::string& in_line) {
        if(logText.getLineCount() != 0) {
            logText.printFmt("\n");
        }
        logText.printFmt("%s",in_line.c_str());
        logText.pageReset();
    }
    //////////////////////////////////////////////////
    /// \brief OɍsǉB(FdefaultTextColor)
    ///
    ///
    ///
    void insertLineToLogText(const char* in_line) {
        if(logText.getLineCount() != 0) {
            logText.printFmt("\n");
        }
        logText.printFmt("%s",in_line);
        logText.pageReset();
    }

    //////////////////////////////////////////////////
    /// \brief Fw肵ăOɍsǉB
    ///
    ///
    ///
    void insertLineToLogText(const std::string& in_line, const GLGTColor4<unsigned char>& in_color) {
        if(logText.getLineCount() != 0) {
            logText.printFmt("\n");
        }
        logText.setTextColor(in_color);
        logText.printFmt("%s",in_line.c_str());
        logText.setTextColor(logText.getDefaultTextColor());
        logText.pageReset();
    }
    //////////////////////////////////////////////////
    /// \brief Fw肵ăOɍsǉB
    ///
    ///
    ///
    void insertLineToLogText(const char* in_line, const GLGTColor4<unsigned char>& in_color) {
        if(logText.getLineCount() != 0) {
            logText.printFmt("\n");
        }
        logText.setTextColor(in_color);
        logText.printFmt("%s",in_line);
        logText.setTextColor(logText.getDefaultTextColor());
        logText.pageReset();
    }



    //////////////////////////////////////////////////
    /// \brief pageUp
    void pageUpLogText() {logText.pageUp();}
    //////////////////////////////////////////////////
    /// \brief pageDown
    void pageDownLogText() {logText.pageDown();}
    //////////////////////////////////////////////////
    /// \brief pageTop
    void pageTopLogText() {logText.pageTop();}
    //////////////////////////////////////////////////
    /// \brief pageBottom
    void pageBottomLogText() {logText.pageBottom();}
    //////////////////////////////////////////////////
    /// \brief pageReset
    void pageResetLogText() {logText.pageReset();}



    //////////////////////////////////////////////////
    /// \brief R\[̃TCYύXB
    void resizeConsoleBox(unsigned int width, unsigned int height,
        unsigned int margin = 2, unsigned int fontscale = 1);



    //////////////////////////////////////////////////
    /// \brief R\[`
    void drawConsoleBox(unsigned int projectionwidth, unsigned int projectionheight) {
        logText.drawTextBox(projectionwidth,projectionheight);
        inputtingString.drawStringBox(projectionwidth,projectionheight);
    }
















    // getter/setter ****************************************

    //////////////////////////////////////////////////
    /// \brief get
    // get(void) {}  
    //////////////////////////////////////////////////
    /// \brief O̍ős
    void setMaxLogLineCount(unsigned int in_max) {
        logText.setMaxLineCount(in_max);
    }


    //////////////////////////////////////////////////
    /// \brief getter of 
    const GLGTColor4<unsigned char>& getDefaultInputtingStringColor(void) const {
        return inputtingString.getDefaultStringColor();
    }  
    //////////////////////////////////////////////////
    /// \brief setter of 
    void setDefaultInputtingStringColor(const GLGTColor4<unsigned char>& in_color) {
        inputtingString.setDefaultStringColor(in_color);
    }

    //////////////////////////////////////////////////
    /// \brief getter of 
    const GLGTColor4<unsigned char>& getDefaultLogTextColor(void) const {
        return logText.getDefaultTextColor();
    }  
    //////////////////////////////////////////////////
    /// \brief setter of 
    void setDefaultLogTextColor(const GLGTColor4<unsigned char>& in_color) {
        logText.setDefaultTextColor(in_color);
        logText.setTextColor(in_color);
    }

    //////////////////////////////////////////////////
    /// \brief getter of 
    // get(void) const {}  
    //////////////////////////////////////////////////
    /// \brief setter of 
    //void set( in_) {}

    //////////////////////////////////////////////////
    /// \brief getter of 
    // get(void) const {}  
    //////////////////////////////////////////////////
    /// \brief setter of 
    //void set( in_) {}



protected:


private:

};


#endif
