//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTFLAGARRAY_H_
#define _GLGTFLAGARRAY_H_

#include <iostream>
#include <string>
#include "GLGTBase.h"



//********************************************************************
/// \brief boolzNX
/// 
/// ̃tOێEǗBrbgtOɑウĎgpB
/// <BR>
/// \zflaglȂB
/// 
/// 
template <typename T=unsigned int> class GLGTFlagArray {

protected:
    bool* flagArray;
    unsigned int arraySize;










public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    explicit GLGTFlagArray(unsigned int size) {
        arraySize = 0;
        create(size);
    }

    //////////////////////////////////////////////////
    /// \brief Rs[RXgN^
    GLGTFlagArray(const GLGTFlagArray<T>& in) {
        create(in.getSize());
        for(unsigned int i = 0; i < arraySize; i++) {flagArray[i] = in[i];}
    }

    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTFlagArray() {
        if(arraySize != 0) {destroy();}
    }

private:
    //////////////////////////////////////////////////
    /// \brief IuWFNg
    void create(unsigned int size) {
        GLGTASSERT((arraySize == 0)&&(size != 0));
        arraySize = size;
        flagArray = new bool[size];
    }

    //////////////////////////////////////////////////
    /// \brief j
    void destroy(void) {
        GLGTASSERT(arraySize != 0);
            delete [] flagArray;
            arraySize = 0;
    }




public:
    //////////////////////////////////////////////////
    /// \brief StOtrue
    bool isAllFlagTrue(void) const {
        for(unsigned int i = 0; i < arraySize; i++) {
            if(flagArray == false) {return false;}
        }
        return true;
    }

    //////////////////////////////////////////////////
    /// \brief StOfalse
    bool isAllFlagFalse(void) const {
        for(unsigned int i = 0; i < arraySize; i++) {
            if(flagArray == true) {return false;}
        }
        return true;
    }





    //////////////////////////////////////////////////
    /// \brief getSize
    unsigned int getSize(void) const {return arraySize;}

    //////////////////////////////////////////////////
    /// \brief getFlag
    bool getFlag(T pos) const  {
        GLGTASSERT((pos >= 0)&&((unsigned int)pos < arraySize));
        return flagArray[pos];
    }





    //////////////////////////////////////////////////
    /// \brief tOZbg
    void setFlag(T pos, bool in_flag) {
        GLGTASSERT((pos >= 0)&&((unsigned int)pos < arraySize));
        flagArray[pos] = in_flag;
    }

    //////////////////////////////////////////////////
    /// \brief StOZbg
    void setAllFlag(bool in_flag) {
        for(unsigned int i = 0; i < arraySize; i++) {flagArray[i] = in_flag;}
    }

    //////////////////////////////////////////////////
    /// \brief truetOZbg
    void setFlagTrue(T pos) {
        GLGTASSERT((pos >= 0)&&((unsigned int)pos < arraySize));
        flagArray[pos] = true;
    }

    //////////////////////////////////////////////////
    /// \brief falsetOZbg
    void setFlagFalse(T pos) {
        GLGTASSERT((pos >= 0)&&((unsigned int)pos < arraySize));
        flagArray[pos] = false;
    }





    //////////////////////////////////////////////////
    /// \brief tO𔽓]
    void flipFlag(T pos) {
        GLGTASSERT((pos >= 0)&&((unsigned int)pos < arraySize));
        if(flagArray[pos] == true) {flagArray[pos] = false;}
        else {flagArray[pos] = true;}
    }

    //////////////////////////////////////////////////
    /// \brief StO𔽓]
    void flipAllFlag(void) {
        for(unsigned int i = 0; i < arraySize; i++) {
        if(flagArray[i] == true) {flagArray[i] = false;}
        else {flagArray[i] = true;}
        }
    }





    //////////////////////////////////////////////////
    /// \brief SfalseɂB
    void clear(void) {
        for(unsigned int i = 0; i < arraySize; i++) {flagArray[i] = false;}
    }

    //////////////////////////////////////////////////
    /// \brief Rs[
    void copy(const GLGTFlagArray<T>& in) {
        *this = in;
    }





    //////////////////////////////////////////////////
    /// \brief [] Iy[^
    bool& operator[](T pos) {
        GLGTASSERT(((unsigned int)pos < arraySize)&&(pos >= 0));
        return flagArray[pos];
    }

    //////////////////////////////////////////////////
    /// \brief [] Iy[^ (constIuWFNgp)
    const bool& operator[](T pos) const {
        GLGTASSERT((pos >= 0)&&((unsigned int)pos < arraySize));
        return flagArray[pos];
    }

    //////////////////////////////////////////////////
    /// \brief = Iy[^
    ///
    /// gꍇlB
    GLGTFlagArray<T>& operator=(const GLGTFlagArray<T>& in) {
        if(arraySize == in.getSize()) {
            for(unsigned int i = 0; i < arraySize; i++) {flagArray[i] = in.flagArray[i];}
        }
        else {
            arraySize = in.getSize();
            bool *new_flagarray = new bool[arraySize];
            for(unsigned int i = 0; i < arraySize; i++) {new_flagarray[i] = in.flagArray[i];}
            destroy();
            flagArray = new_flagarray;
        }
        return *this;
    }

    //////////////////////////////////////////////////
    /// \brief == Iy[^
    bool operator==(const GLGTFlagArray<T>& in) const {
        if(arraySize != in.getSize()) {return false};

        for(unsigned int i = 0; i < size; i++) {
            if(flagArray[i] != in.flagArray[i]) {return false;}
        }

        return true;
    }

    //////////////////////////////////////////////////
    /// \brief != Iy[^
    bool operator!=(const GLGTFlagArray<T>& in) const {
        return !(*this == in);
    }

    //////////////////////////////////////////////////
    /// \brief ~ Iy[^
    GLGTFlagArray<T> operator~() const {
        GLGTFlagArray ret(*this);
        ret.flipAllFlag();
        return ret;
    }


    //////////////////////////////////////////////////
    /// \brief &= Iy[^
    GLGTFlagArray<T>& operator&=(const GLGTFlagArray<T>& in)  {
        GLGTASSERT(arraySize == in.arraySize);
        for(unsigned int i = 0; i < arraySize; i++) {
            if(flagArray[i] && in.flagArray[i]) {flagArray[i] = true;}
            else {flagArray[i] = false;}
        }

        return *this;
    }

    //////////////////////////////////////////////////
    /// \brief |= Iy[^
    GLGTFlagArray<T>& operator|=(const GLGTFlagArray<T>& in)  {
        GLGTASSERT(arraySize == in.arraySize);
        for(unsigned int i = 0; i < arraySize; i++) {
            if(flagArray[i] || in.flagArray[i]) {flagArray[i] = true;}
            else {flagArray[i] = false;}
        }

        return *this;
    }

    //////////////////////////////////////////////////
    /// \brief ^= Iy[^
    GLGTFlagArray<T>& operator^=(const GLGTFlagArray<T>& in)  {
        GLGTASSERT(arraySize == in.arraySize);
        for(unsigned int i = 0; i < arraySize; i++) {
            if(flagArray[i] != in.flagArray[i]) {flagArray[i] = true;}
            else {flagArray[i] = false;}
        }

        return *this;
    }

    //////////////////////////////////////////////////
    /// \brief & Iy[^
    friend GLGTFlagArray<T> operator&(const GLGTFlagArray<T>& in_a, const GLGTFlagArray<T>& in_b)  {
        GLGTFlagArray ret(in_a);
        return (ret &= in_b);        
    }

    //////////////////////////////////////////////////
    /// \brief | Iy[^
    friend GLGTFlagArray<T> operator|(const GLGTFlagArray<T>& in_a, const GLGTFlagArray<T>& in_b)  {
        GLGTFlagArray ret(in_a);
        return (ret |= in_b);        
    }

    //////////////////////////////////////////////////
    /// \brief ^ Iy[^
    friend GLGTFlagArray<T> operator^(const GLGTFlagArray<T>& in_a, const GLGTFlagArray<T>& in_b)  {
        GLGTFlagArray ret(in_a);
        return (ret ^= in_b);        
    }


    //////////////////////////////////////////////////
    /// \brief << Iy[^ ()
    friend GLGTFlagArray<T>&  operator<< (GLGTFlagArray<T>& flag, T in) {
        flag[in] = true;
        return flag;
    }

    //////////////////////////////////////////////////
    /// \brief << Iy[^ (o)
    ///
    /// eXgp
    friend std::ostream&  operator<< (std::ostream& out, const GLGTFlagArray<T>& flag) {
        for(unsigned int i = flag.arraySize; i > 0; i--) {
            if(flag.flagArray[i-1] == true) {std::cout << '1';}
            else {std::cout << '0';}
        }

        return out;
    }




};


#endif
