//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTFONTRENDERER_H_
#define _GLGTFONTRENDERER_H_

#include <vector>
#include <deque>
#include <string>
#include "GLGTBase.h"
#include "GLGTSingleton.h"
#include "GLGTFlagArray.h"
#include "GLGTColor.h"

#define GLGTFontRenderer    GLGTFontRenderer_Singleton::getSingleton() ///< CX^XɃANZX
#define ptrGLGTFontRenderer    GLGTFontRenderer_Singleton::getSingletonPtr()  ///< CX^X̃|C^ɃANZX



//********************************************************************
/// \brief eLXg̐F
/// 
/// eLXg̐FƐFύX|CgL
/// <BR>
///
struct GLGTFontColor {
    GLGTColor4<unsigned char> color; ///< F
    unsigned int column; ///< CfbNX(FύX|Cg)
} ;

//********************************************************************
/// \brief eLXg̍s
/// 
/// s̕ƐFێ
/// <BR>
/// s̍̕Ō\\ntĂ΁AIɉsꂽꍇłB
/// \\nȂ΃tH[̕Ɏ܂悤sꂽꍇłB
/// 
struct GLGTFontString {
    std::string stringBuffer; ///< s̕
    std::deque<GLGTFontColor> fontColor; ///< eLXg̐Fƈʒuێ
} ;

//********************************************************************
/// \brieftHg`悷B
/// 
/// ɃRgȂꍇ͑OE㏈ȂB(glPushMatrix,glOrtho,glPushAttribȂ)
/// <BR>
/// GAME PROGRAMING GEMSt̃\[XR[hQlɂĂB
/// <BR>
/// tHg̃f[^gݍł̂60KB炢st@C傫ȂĂ܂B
/// <BR>
/// {͎gȂBOpenGLœ{\@ɂĂ͈ȉ̃N悪QlɂȂB
///     - d i v i n e  r e l i c s  <http://i-saint.abz.jp/>
///     - Entangled Space <http://user.ecc.u-tokyo.ac.jp/~s31552/wp/>
/// 
///
/// 
/// \image html textbox_font.png "tHg (M+ fonts̃tHggĂ܂B <http://mplus-fonts.sourceforge.jp/>)"
/// 
class GLGTFontRenderer_Singleton : public GLGTSingleton <GLGTFontRenderer_Singleton> {

    // vpeB ****************************************
protected:
    unsigned int textureID; ///< eNX`ID

    const int char_first; ///< ʂ̍̕ŏ
    const int char_end; ///< ʂ̍̕Ō

     unsigned int fontWidth;
     unsigned int fontHeight;
     unsigned int fontTextureWidth;
     unsigned int fontTextureHeight;
     unsigned int fontPerRow;

    bool created; ///< ꂽ


    // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTFontRenderer_Singleton(void);

    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTFontRenderer_Singleton();



    //////////////////////////////////////////////////
    /// \brief =
    ///
    /// ȂB
    /// 
    GLGTFontRenderer_Singleton& operator =(const GLGTFontRenderer_Singleton& in) const {}



    //////////////////////////////////////////////////
    /// \brief 
    void create();



    //////////////////////////////////////////////////
    /// \brief tHg𓾂
    unsigned int getFontWidth(void) {return fontWidth;}

    //////////////////////////////////////////////////
    /// \brief tHg𓾂
    unsigned int getFontHeight(void) {return fontHeight;}



    //////////////////////////////////////////////////
    /// \brief LN^̃|STu~bgB
    ///
    /// 
    ///
    /// \param in_char `悷LN^
    /// \param in_left [xW
    /// \param in_top [yW
    /// \param in_scale ̃XP[({)
    void submitCharPolygon(int in_char, int in_left, int in_top, unsigned int in_scale = 1) {
        GLGTASSERT(in_scale > 0);
        if((in_char<char_first)||(char_end<in_char)) {return;}

        int s =                   (in_char % fontPerRow)*fontWidth;
        int t = fontTextureHeight-(in_char / fontPerRow)*fontHeight;

        glTexCoord2f((float)(s          )/fontTextureWidth,(float)(t           )/fontTextureHeight);
        glVertex3i(in_left                   , in_top                    , 0);

        glTexCoord2f((float)(s          )/fontTextureWidth,(float)(t-fontHeight)/fontTextureHeight);
        glVertex3i(in_left                   , in_top+fontHeight*in_scale, 0);

        glTexCoord2f((float)(s+fontWidth)/fontTextureWidth,(float)(t-fontHeight)/fontTextureHeight);
        glVertex3i(in_left+fontWidth*in_scale, in_top+fontHeight*in_scale, 0);

        glTexCoord2f((float)(s+fontWidth)/fontTextureWidth,(float)(t           )/fontTextureHeight);
        glVertex3i(in_left+fontWidth*in_scale, in_top                    , 0);


    }


    //////////////////////////////////////////////////
    /// \brief ̍s`悷B
    ///
    /// 
    ///
    /// \param in_line `悷镶̍s
    /// \param in_color F
    /// \param in_left [xW
    /// \param in_top [yW
    /// \param in_scale ̃XP[({)
    void drawLine(std::string& in_line, GLGTColor4<unsigned char>& in_color,
        int in_left, int in_top, unsigned int in_scale = 1);

    //////////////////////////////////////////////////
    /// \brief ̍̕s`悷B
    /// 
    /// 
    /// 
    /// \param in_lines `悷镶̍s
    /// \param in_color F
    /// \param in_left [xW
    /// \param in_top [yW
    /// \param in_scale ̃XP[({)
    void drawLines(std::vector<std::string>& in_lines, GLGTColor4<unsigned char>& in_color,
        int in_left, int in_top, unsigned int in_scale = 1);



    //////////////////////////////////////////////////
    /// \brief Ft`
    ///
    /// 
    ///
    /// \param in_fontstring `悷Ft
    /// \param in_left [xW
    /// \param in_top [yW
    /// \param in_scale ̃XP[({)
    void drawFontString(GLGTFontString& in_fontstring, int in_left, int in_top, unsigned int in_scale = 1);







    //////////////////////////////////////////////////
    /// \brief eLXg`
    ///
    /// OA㏈ȂB(GLGTTextBoxp)
    ///
    /// \param text `悷dequeɊi[ꂽGLGTFontString
    /// \param scale ̃XP[({)
    /// \param start Jns
    /// \param end Ō̍s
    /// \param left eLXg̍[ʒu
    /// \param top eLXg̏[ʒu
    void drawTextForGLGTTextBox(std::deque<GLGTFontString>& text, unsigned int scale,
        unsigned int start, unsigned int end, int left, int top);


    //////////////////////////////////////////////////
    /// \brief eLXgs`
    ///
    /// OA㏈ȂB(GLGTStringBoxp)
    ///tH[ĂяoꍇȂǂŁAˉes̐ݒȂǂKvȂƂɁB
    ///
    /// \param textline `悷GLGTFontString
    /// \param scale ̃XP[({)
    /// \param left eLXg̍[ʒu
    /// \param top eLXg̏[ʒu
    void drawStringForGLGTStringBox(GLGTFontString& textline, unsigned int scale,  int left, int top);




    // J ****************************************


    //////////////////////////////////////////////////
    /// \brief 
    /// \param 
    /// \return 
    /// \retval 
    //void (void);





};




#endif
