//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTFORM_H_
#define _GLGTFORM_H_

#include "GLGTBase.h"
#include "GLGTFlagArray.h"
#include "GLGTKey.h"
#include "GLGTMouse.h"
#include "GLGTMath.h"
#include "GLGTColor.h"
#include "GLGTWindowProperty.h"

#define MAXFORMSIZE 128 //tH[̍ő吔


//********************************************************************
/// \brief tH[ǗNX
///
/// ܂܂ȃtH[̊ƂȂNXB
/// <BR>
/// 
/// <BR>
/// : vpeB⃁\bhɃtH[̈ʒuA傫Ɋւ鍀ڂ邪A
/// ͂܂ŃC^[tF[X𓝈ꂷ邽߂̂̂łB
/// ʒuA傫𖳎`惋[`ł͂ȂB
/// <BR>
/// 
class GLGTForm {
    friend class GLGTScene;
    // vpeB ****************************************
public:
    GLGTFlagArray<GLGTEventType> eventFilter; ///< 󂯎Cxg
protected:
    GLGTWindowPropertyPtr windowProperty; ///< EChE֘ÃvpeB
    GLGTRectEXT formRect; ///< tH[̈ʒu(オ_)ETCY


private:
    unsigned int formIndex; ///< V[猩CfbNX


    // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTForm(void);

    //////////////////////////////////////////////////
    /// \brief fXgN^
    virtual ~GLGTForm();

    //////////////////////////////////////////////////
    /// \brief }EXJ[\tH[̓ɂ邩
    /// 
    bool isMouseCursorInside(void) const {
        return formRect.isPointInside(windowProperty.getMouseCursor().getPosition());
    }



    //////////////////////////////////////////////////
    /// \brief getFormIndex
    unsigned int getFormIndex(void) const {return formIndex;}

    //////////////////////////////////////////////////
    /// \brief getFormRect
    const GLGTRectEXT& getFormRect(void) {return formRect;}

    //////////////////////////////////////////////////
    /// \brief getFormX
    int getFormX(void) const {return formRect.position.x;}

    //////////////////////////////////////////////////
    /// \brief getFormX
    int getFormY(void) const {return formRect.position.y;}

    //////////////////////////////////////////////////
    /// \brief getFormWidth
    unsigned int getFormWidth(void) const {return formRect.dimension.x;}

    //////////////////////////////////////////////////
    /// \brief getFormHeight
    unsigned int getFormHeight(void) const {return formRect.dimension.y;}






    //////////////////////////////////////////////////
    /// \brief setFormRect
    void setFormRect(const GLGTRectEXT& in_rect) {
        formRect = in_rect;
        onMoveForm(formRect.position.x,formRect.position.y);
        onResizeForm(formRect.dimension.x,formRect.dimension.y);
    }


    //////////////////////////////////////////////////
    /// \brief tH[ړ
    /// \param x xW
    /// \param y yW
    void moveForm(int x, int y) {
        formRect.position.x = x;
        formRect.position.y = y;
        onMoveForm(formRect.position.x,formRect.position.y);
    }

    //////////////////////////////////////////////////
    /// \brief tH[TCYύX
    /// \param width 
    /// \param height 
    void resizeForm(unsigned int width, unsigned int height) {
        formRect.dimension.x = width;
        formRect.dimension.y = height;
        onResizeForm(formRect.dimension.x,formRect.dimension.y);
    }





    //////////////////////////////////////////////////
    /// \brief [Cxg] EChËʒuύXꂽƂ
    /// \param x xW
    /// \param y yW
    virtual void onMoveWindow(int x, int y) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] EChẼTCYύXꂽƂ
    /// \param width 
    /// \param height 
    virtual void onResizeWindow(unsigned int width, unsigned int height) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] L[{[hꂽƂ
    /// \param keycode L[R[h
    /// \param repeat s[gȂtrue
    /// \param keychar ̏ꍇ͕BȊONULL
    virtual void onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar) {
    }
    //////////////////////////////////////////////////
    // onKeyUp ( <L[R[h>, <s[gȂtrue>, <̏ꍇ͕BȊONULL> )
    /// \brief [Cxg] L[{[hꂽƂ
    /// \param keycode L[R[h
    /// \param repeat false
    /// \param keychar ̏ꍇ͕BȊONULL
    virtual void onKeyUp(GLGTKeyCode keycode, bool repeat, char keychar) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] }EX{^ꂽƂ
    ///
    /// last_x,last_y̓{^ƂɋLĂB
    /// Ōɂ̃{^(UP or DOWN)ꂽƂ̍WĂB
    ///
    /// \param button }EX{^
    /// \param x xW
    /// \param y yW
    /// \param last_x OxW
    /// \param last_y OyW
    virtual void onMouseDown(GLGTMouseButton button, int x, int y, int last_x, int last_y) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] }EX{^ꂽƂ
    ///
    /// last_x,last_y̓{^ƂɋLĂB
    /// Ōɂ̃{^(UP or DOWN)ꂽƂ̍WĂB
    ///
    /// \param button }EX{^
    /// \param x xW
    /// \param y yW
    /// \param last_x OxW
    /// \param last_y OyW
    virtual void onMouseUp(GLGTMouseButton button, int x, int y, int last_x, int last_y) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] }EXꂽƂ
    /// \param x xW
    /// \param y yW
    /// \param last_x OxW
    /// \param last_y OyW
    virtual void onMouseMove(int x, int y, int last_x, int last_y) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] tH[쐬Ƃ
    ///
    virtual void onCreateForm(void) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] tH[jƂ
    virtual void onDestroyForm(void) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] tH[̈ʒuύXꂽƂ
    /// \param x xW
    /// \param y yW
    virtual void onMoveForm(int x, int y) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] tH[̃TCYύXꂽƂ
    /// \param width 
    /// \param height 
    virtual void onResizeForm(unsigned int width, unsigned int height) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] `悷悤wꂽƂ
    virtual void onDraw(void) {
    }








};


#endif
