//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTMATH_H_
#define _GLGTMATH_H_

#include <cmath>

#include "GLGTBase.h"
#include "GLGTSingleton.h"

#define GLGTMath    GLGTMath_Singleton::getSingleton() ///< CX^XɃANZX
#define ptrGLGTMath    GLGTMath_Singleton::getSingletonPtr() ///< CX^X̃|C^ɃANZX

template <typename T> class GLGTVector3;
template <typename T> class GLGTVector4;
template <typename T> class GLGTMatrix44;
template <typename T> class GLGTColor4;


//********************************************************************
/// \brief w֌W̃VOgNX
///
/// GLGTMath_SingletonGLGTInitŃRXgNgA
/// GLGTQuitŃfXgNgB<BR>
/// GLGTMathŃCX^XɃANZX (FGLGTMath.getPi())
/// 
/// 
class GLGTMath_Singleton : public GLGTSingleton <GLGTMath_Singleton> {

    // vpeB ****************************************
public:



protected:
    double pi; ///<~
    double degToRadCoefficient; ///< x烉WAւ̕ϊW
    double radToDegCoefficient; ///< WAxւ̕ϊW



private:


  // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTMath_Singleton(void);

    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTMath_Singleton();



    //////////////////////////////////////////////////
    /// \brief destroy
    void destroy(void);

    //////////////////////////////////////////////////
    /// \brief vpeB
    void clear(void);

    //////////////////////////////////////////////////
    /// \brief ~𓾂
    double getPi(void) {return pi;}

    //////////////////////////////////////////////////
    /// \brief ~Zbg
    ///
    /// ɃWA<->x̕ϊWvZ
    void setPi(double in_pi) {
        GLGTASSERT(in_pi > 0);
        pi = in_pi;
        degToRadCoefficient = pi/180.0;
        radToDegCoefficient = 180.0/pi;

    }




  // ȉw֌W ****************************************

    //////////////////////////////////////////////////
    /// \brief x烉WA
    /// \param a x
    /// \return WA
    template <typename T> T convertDegToRad(T a)
    {
        return a*degToRadCoefficient;
    }

    //////////////////////////////////////////////////
    /// \brief WAx
    /// \param a WA
    /// \return x
    template <typename T> T convertRadToDeg(T a)
    {
        return a*radToDegCoefficient;
    }

    //////////////////////////////////////////////////
    /// \brief ς߂
    /// \param a xNg
    /// \param b xNg
    /// \return 
    template <typename T> T getDotProduct(const GLGTVector3<T>& a, const GLGTVector3<T>& b) 
    {
        return(a.x*b.x + a.y*b.y + a.z*b.z);
    }
    //////////////////////////////////////////////////
    /// \brief ς߂
    /// \param a xNg
    /// \param b xNg
    /// \return 
    template <typename T> T getDotProduct(const GLGTVector4<T>& a, const GLGTVector4<T>& b) 
    {
        return(a.x*b.x + a.y*b.y + a.z*b.z);
    }

    //////////////////////////////////////////////////
    /// \brief Oς߂
    /// \param a xNg
    /// \param b xNg
    /// \return O
    template <typename T> GLGTVector3<T> getCrossProduct(GLGTVector3<T>& a, GLGTVector3<T>& b)
    {
        return(GLGTVector3(a.y*b.z - a.z*b.y,
            a.z*b.x - a.x*b.z,
            a.x*b.y - a.y*b.x));
    };
    //////////////////////////////////////////////////
    /// \brief Oς߂
    /// \param a xNg
    /// \param b xNg
    /// \return O
    template <typename T> GLGTVector4<T> getCrossProduct(GLGTVector4<T>& a, GLGTVector4<T>& b)
    {
        return(GLGTVector4(a.y*b.z - a.z*b.y,
            a.z*b.x - a.x*b.z,
            a.x*b.y - a.y*b.x));
    };

    //////////////////////////////////////////////////
    /// \brief @߂
    /// \param a xNg
    /// \param b xNg
    /// \param c xNg
    /// \return @
    template <typename T> GLGTVector3<T> getNormal(GLGTVector3<T>& a, GLGTVector3<T>& b, GLGTVector3<T>& c)
    {
        GLGTVector3<T> ret((b.y-a.y)*(c.z-a.z) - (b.z-a.z)*(c.y-a.y),
            (b.z-a.z)*(c.x-a.x) - (b.x-a.x)*(c.z-a.z),
            (b.x-a.x)*(c.y-a.y) - (b.y-a.y)*(c.x-a.x));
        ret.normalize();
        return(ret);
    };
    //////////////////////////////////////////////////
    /// \brief @߂
    /// \param a xNg
    /// \param b xNg
    /// \param c xNg
    /// \return @
    template <typename T> GLGTVector4<T> getNormal(GLGTVector4<T>& a, GLGTVector4<T>& b, GLGTVector4<T>& c)
    {
        GLGTVector4<T> ret((b.y-a.y)*(c.z-a.z) - (b.z-a.z)*(c.y-a.y),
            (b.z-a.z)*(c.x-a.x) - (b.x-a.x)*(c.z-a.z),
            (b.x-a.x)*(c.y-a.y) - (b.y-a.y)*(c.x-a.x));
        ret.normalize();
        return(ret);
    };

    //////////////////////////////////////////////////
    /// \brief px߂
    /// 
    /// 0xNgɂꍇ0Ԃ
    ///
    /// \param a xNg
    /// \param b xNg
    /// \return px(x)
    template <typename T> double getVectorAngle(GLGTVector3<T>& a, GLGTVector3<T>& b)
    {
        if(a.LengthSqr()*b.LengthSqr() == 0.0)
        {
            return (0.0);
        }
        return(convertRadToDeg( acos( (double)getDotProduct(a,b)/(a.Length()*b.Length()) ) ));
    };
    //////////////////////////////////////////////////
    /// \brief px߂B
    /// 
    /// 0xNgɂꍇ0ԂB(debug̓AT[g)
    ///
    /// \param a xNg
    /// \param b xNg
    /// \return px(x)
    template <typename T> double getVectorAngle(GLGTVector4<T>& a, GLGTVector4<T>& b)
    {
        if(a.LengthSqr()*b.LengthSqr() == 0.0)
        {
            return (0.0);
        }
        return(convertRadToDeg( acos( (double)getDotProduct(a,b)/(a.Length()*b.Length()) ) ));
    };




    // J ****************************************
protected:



private:
    //////////////////////////////////////////////////
    /// \brief =
    ///
    /// ȂB
    /// 
    GLGTMath_Singleton& operator =(const GLGTMath_Singleton& in) const {}








};



//********************************************************************
/// \brief 2xNgNX
/// 
/// 
/// 
/// 
template <typename T> class GLGTVector2
{
public:
    T x; ///< x
    T y; ///< y

public:
    //////////////////////////////////////////////////
    /// \brief RXgN^()
    ///
    /// ͂Ȃ
    GLGTVector2() {}
    //////////////////////////////////////////////////
    /// \brief RXgN^()
    GLGTVector2(T in_x, T in_y): x(in_x), y(in_y) {}
    //////////////////////////////////////////////////
    /// \brief RXgN^()
    GLGTVector2(const GLGTVector2& v): x(v.x), y(v.y) {}

    //////////////////////////////////////////////////
    /// \brief vfɃANZX
    T& operator [] (unsigned int i) {
        GLGTASSERT(i<2);
        return((i == 0) ? x : y);
    }
    //////////////////////////////////////////////////
    /// \brief vfɃANZX
    const T& operator [] (unsigned int i) const {
        GLGTASSERT(i<2);
        return((i == 0) ? x : y);
    }
    //////////////////////////////////////////////////
    /// \brief +=
    GLGTVector2<T>& operator +=(const GLGTVector2<T>& v) {
        x += v.x;
        y += v.y;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief +=
    GLGTVector2<T>& operator +=(T t) {
        x += t;
        y += t;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief -=
    GLGTVector2<T>& operator -=(const GLGTVector2<T>& v) {
        x -= v.x;
        y -= v.y;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief -=
    GLGTVector2<T>& operator -=(T t) {
        x -= t;
        y -= t;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief *=
    GLGTVector2<T>& operator *=(T t) {
        x *= t;
        y *= t;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief /=
    GLGTVector2<T>& operator /=(T t) {
        GLGTASSERT(t!=0);
        x /= t;
        y /= t;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector2 == GLGTVector2
    friend bool operator == (const GLGTVector2<T>& a, const GLGTVector2<T>& b) {
        return((a.x == b.x)&&(a.y == b.y));
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector2 != GLGTVector2
    friend bool operator != (const GLGTVector2<T>& a, const GLGTVector2<T>& b) {
        return((a.x != b.x)||(a.y != b.y));
    }
    //////////////////////////////////////////////////
    /// \brief -GLGTVector2
    friend GLGTVector2<T> operator -(const GLGTVector2<T>& a)
    {
        return GLGTVector2<T>(-a.x, -a.y);
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector2 + GLGTVector2
    friend GLGTVector2<T> operator +(const GLGTVector2<T>& a, const GLGTVector2<T>& b) {
        GLGTVector2 ret(a);
        ret += b;
        return ret;
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector2 - GLGTVector2
    friend GLGTVector2<T> operator -(const GLGTVector2<T>& a, const GLGTVector2<T>& b) {
        GLGTVector2 ret(a);
        ret -= b;
        return ret;
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector2 * T
    friend GLGTVector2<T> operator *(const GLGTVector2<T>& v, T t) {
        return GLGTVector2<T>(t*v.x, t* v.y);
    }
    //////////////////////////////////////////////////
    /// \brief T * GLGTVector2
    friend GLGTVector2<T> operator *(T t, const GLGTVector2<T>& v) {
        return GLGTVector2<T>(t*v.x, t* v.y);
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector2 / T
    friend GLGTVector2<T> operator /(const GLGTVector2<T>& v, T t) {
        GLGTASSERT(t!=0);
        return GLGTVector2<T>(v.x/t, v.y/t);
    }

    //////////////////////////////////////////////////
    /// \brief Zbg
    void set(T in_x, T in_y) {
        x = in_x;
        y = in_y;
    }
    //////////////////////////////////////////////////
    /// \brief 𓾂( = getNorm)
    /// 
    double getLength() const {
        return (sqrt((double)(x*x + y*y)));
    }
    //////////////////////////////////////////////////
    /// \brief ^2 𓾂( = getNormSqr)
    /// 
    T getLengthSqr() const {
        return(x*x + y*y);
    }
    //////////////////////////////////////////////////
    /// \brief m𓾂( = getLength)
    /// 
    double getNorm() const {
        return (sqrt((double)(x*x + y*y)));
    }
    //////////////////////////////////////////////////
    /// \brief m^2 𓾂( = getLengthSqr)
    /// 
    T getNormSqr() const {
        return(x*x + y*y);
    }
    //////////////////////////////////////////////////
    /// \brief vf(0, 0, 0)
    /// 
    bool isZero() const {
        return((x == 0.0) && (y == 0.0));
    }
    //////////////////////////////////////////////////
    /// \brief K
    /// 
    /// \return IuWFNg
    GLGTVector2<T>& normalize() {
        T m = getLength();
        if (m > 0.0) {
            x /= m;
            y /= m;
        }

        return *this;
    }


};





//********************************************************************
/// \brief 3xNgNX
/// 
/// w=1ƌȂ
/// 
/// 
template <typename T> class GLGTVector3
{
public:
    T x; ///< x
    T y; ///< y
    T z; ///< z

public:
    //////////////////////////////////////////////////
    /// \brief RXgN^()
    ///
    /// ͂Ȃ
    GLGTVector3() {}
    //////////////////////////////////////////////////
    /// \brief RXgN^()
    GLGTVector3(T in_x, T in_y, T in_z): x(in_x), y(in_y), z(in_z) {}
    //////////////////////////////////////////////////
    /// \brief RXgN^()
    GLGTVector3(const GLGTVector3& v): x(v.x), y(v.y), z(v.z) {}
    //////////////////////////////////////////////////
    /// \brief RXgN^()
    GLGTVector3(const GLGTVector4& v): x(v.x), y(v.y), z(v.z) {}

    //////////////////////////////////////////////////
    /// \brief vfɃANZX
    T& operator [] (unsigned int i) {
        GLGTASSERT(i<3);
        return( (i == 0) ? x : (i == 1) ? y : z );
    }
    //////////////////////////////////////////////////
    /// \brief vfɃANZX
    const T& operator [] (unsigned int i) const {
        GLGTASSERT(i<3);
        return( (i == 0) ? x : (i == 1) ? y : z );
    }
    //////////////////////////////////////////////////
    /// \brief = 
    GLGTVector3<T>& operator =(const GLGTVector4<T>& v4) {
        x = v4.x;
        y = v4.y;
        z = v4.z;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief +-
    GLGTVector3<T>& operator +=(const GLGTVector3<T>& v) {
        x += v.x;
        y += v.y;
        z += v.z;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief +=
    GLGTVector3<T>& operator +=(T t) {
        x += t;
        y += t;
        z += t;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief -=
    GLGTVector3<T>& operator -=(const GLGTVector3<T>& v) {
        x -= v.x;
        y -= v.y;
        z -= v.z;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief -=
    GLGTVector3<T>& operator -=(T t) {
        x -= t;
        y -= t;
        z -= t;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief *=
    GLGTVector3<T>& operator *=(T t) {
        x *= t;
        y *= t;
        z *= t;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief /=
    GLGTVector3<T>& operator /=(T t) {
        GLGTASSERT(t!=0);
        x /= t;
        y /= t;
        z /= t;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector3 == GLGTVector3
    friend bool operator == (const GLGTVector3<T>& a, const GLGTVector3<T>& b) {
        return((a.x == b.x)&&(a.y == b.y)&&(a.z == b.z));
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector3 != GLGTVector3
    friend bool operator != (const GLGTVector3<T>& a, const GLGTVector3<T>& b) {
        return((a.x != b.x)||(a.y != b.y)||(a.z != b.z));
    }
    //////////////////////////////////////////////////
    /// \brief -GLGTVector3
    friend GLGTVector3<T> operator -(const GLGTVector3<T>& a)
    {
        return GLGTVector3<T>(-a.x, -a.y, -a.z);
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector3 + GLGTVector3
    friend GLGTVector3<T> operator +(const GLGTVector3<T>& a, const GLGTVector3<T>& b) {
        GLGTVector3 ret(a);
        ret += b;
        return ret;
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector3 - GLGTVector3
    friend GLGTVector3<T> operator -(const GLGTVector3<T>& a, const GLGTVector3<T>& b) {
        GLGTVector3 ret(a);
        ret -= b;
        return ret;
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector3 * T
    friend GLGTVector3<T> operator *(const GLGTVector3<T>& v, T t) {
        return GLGTVector3<T>(t*v.x, t* v.y, t*v.z);
    }
    //////////////////////////////////////////////////
    /// \brief T * GLGTVector3
    friend GLGTVector3<T> operator *(T t, const GLGTVector3<T>& v) {
        return GLGTVector3<T>(t*v.x, t* v.y, t*v.z);
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector3 / T
    friend GLGTVector3<T> operator /(const GLGTVector3<T>& v, T t) {
        GLGTASSERT(t!=0);
        return GLGTVector3<T>(v.x/t, v.y/t, v.z/t);
    }

    //////////////////////////////////////////////////
    /// \brief Zbg
    void set(T in_x, T in_y, T in_z) {
        x = in_x;
        y = in_y;
        z = in_z;
    }
    //////////////////////////////////////////////////
    /// \brief 𓾂( = getNorm)
    /// 
    double getLength() const {
        return (sqrt((double)(x*x + y*y + z*z)));
    }
    //////////////////////////////////////////////////
    /// \brief ^2 𓾂( = getNormSqr)
    /// 
    T getLengthSqr() const {
        return(x*x + y*y + z*z);
    }
    //////////////////////////////////////////////////
    /// \brief m𓾂( = getLength)
    /// 
    double getNorm() const {
        return (sqrt((double)(x*x + y*y + z*z)));
    }
    //////////////////////////////////////////////////
    /// \brief m^2 𓾂( = getLengthSqr)
    /// 
    T getNormSqr() const {
        return(x*x + y*y + z*z);
    }
    //////////////////////////////////////////////////
    /// \brief vf(0, 0, 0)
    /// 
    bool isZero() const {
        return((x == 0.0) && (y == 0.0) && (z == 0.0));
    }
    //////////////////////////////////////////////////
    /// \brief K
    /// 
    /// \return IuWFNg
    GLGTVector3<T>& normalize() {
        T m = getLength();
        if (m > 0.0) {
            x /= m;
            y /= m;
            z /= m;
        }

        return *this;
    }


};





//********************************************************************
/// \brief 4xNgNX
/// 
/// wgȂ̂łGLGTVector3gׂB
/// 
/// 

template <typename T> class GLGTVector4
{
public:
    T x; ///< x
    T y; ///< y
    T z; ///< z
    T w; ///< w

public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTVector4(): w(1.0) {}
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTVector4(T in_x, T in_y, T in_z): x(in_x), y(in_y), z(in_z), w(1.0) {}
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTVector4(T in_x, T in_y, T in_z, T in_w): x(in_x), y(in_y), z(in_z), w(in_w) {}
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTVector4(const GLGTVector4& v): x(v.x), y(v.y), z(v.z), w(v.w) {}
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTVector4(const GLGTVector3& v): x(v.x), y(v.y), z(v.z), w(1.0) {}

    //////////////////////////////////////////////////
    /// \brief vfɃANZX
    T& operator [] (unsigned int i) {
        GLGTASSERT(i<4);
        return( (i == 0) ? x : (i == 1) ? y : (i == 2) ? z : w );
    }
    //////////////////////////////////////////////////
    /// \brief vfɃANZX
    const T& operator [] (unsigned int i) const {
        GLGTASSERT(i<4);
        return( (i == 0) ? x : (i == 1) ? y : (i == 2) ? z : w );
    }
    //////////////////////////////////////////////////
    /// \brief =
    GLGTVector4<T>& operator =(const GLGTVector3<T>& v3) {
        x = v3.x;
        y = v3.y;
        z = v3.z;
        w = 1.0;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief +=
    GLGTVector4<T>& operator +=(const GLGTVector4<T>& v) {
        x += v.x;
        y += v.y;
        z += v.z;
        w += v.w;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief +=
    GLGTVector4<T>& operator +=(T t) {
        x += t;
        y += t;
        z += t;
        w += t;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief -=
    GLGTVector4<T>& operator -=(const GLGTVector4<T>& v) {
        x -= v.x;
        y -= v.y;
        z -= v.z;
        w -= v.w;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief -=
    GLGTVector4<T>& operator -=(T t) {
        x -= t;
        y -= t;
        z -= t;
        w -= t;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief *=
    GLGTVector4<T>& operator *=(T t) {
        x *= t;
        y *= t;
        z *= t;
        w *= t;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief /=
    GLGTVector4<T>& operator /=(T t) {
        GLGTASSERT(t!=0);
        x /= t;
        y /= t;
        z /= t;
        w /= t;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector4 == GLGTVector4
    friend bool operator ==(const GLGTVector4<T>& a, const GLGTVector4<T>& b) {
        return((a.x == b.x)&&(a.y == b.y)&&(a.z == b.z)&&(a.w == b.w));
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector4 != GLGTVector4
    friend bool operator !=(const GLGTVector4<T>& a, const GLGTVector4<T>& b) {
        return((a.x != b.x)||(a.y != b.y)||(a.z != b.z)||(a.w != b.w));
    }
    //////////////////////////////////////////////////
    /// \brief  -GLGTVector4
    friend GLGTVector4<T> operator -(const GLGTVector4<T>& a) {
        return GLGTVector4<T>(-a.x, -a.y, -a.z, -a.w);
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector4 + GLGTVector4
    friend GLGTVector4<T> operator +(const GLGTVector4<T>& a, const GLGTVector4<T>& b) {
        GLGTVector4 ret(a);
        ret += b;
        return ret;
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector4 - GLGTVector4
    friend GLGTVector4<T> operator -(const GLGTVector4<T>& a, const GLGTVector4<T>& b) {
        GLGTVector4 ret(a);
        ret -= b;
        return ret;
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector4 * T
    friend GLGTVector4<T> operator *(const GLGTVector4<T>& v, T t) {
        return GLGTVector4<T>(t*v.x, t* v.y, t*v.z, t*v.w);
    }
    //////////////////////////////////////////////////
    /// \brief T * GLGTVector4
    friend GLGTVector4<T> operator *(T t, const GLGTVector4<T>& v) {
        return GLGTVector4<T>(t*v.x, t* v.y, t*v.z, t*v.w);
    }
    //////////////////////////////////////////////////
    /// \brief GLGTVector4 / T
    friend GLGTVector4<T> operator /(const GLGTVector4<T>& v, T t) {
        GLGTASSERT(t!=0);
        return GLGTVector4<T>(v.x/t, v.y/t, v.z/t, v.w/t);
    }

    //////////////////////////////////////////////////
    /// \brief Zbg
    void set(T in_x, T in_y, T in_z) {
        x = in_x;
        y = in_y;
        z = in_z;
    }
    //////////////////////////////////////////////////
    /// \brief Zbg
    void set(T in_x, T in_y, T in_z, T in_w) {
        x = in_x;
        y = in_y;
        z = in_z;
        w = in_w;
    }
    //////////////////////////////////////////////////
    /// \brief 𓾂
    ///
    /// \note lengthnorm̈Ⴂw܂߂邩ǂB
    /// 
    double getLength() const {
        return (sqrt((double)(x*x + y*y + z*z)));
    }
    //////////////////////////////////////////////////
    /// \brief ^2 𓾂
    ///
    /// \note lengthnorm̈Ⴂw܂߂邩ǂB
    /// 
    T getLengthSqr() const {
        return(x*x + y*y + z*z);
    }
    //////////////////////////////////////////////////
    /// \brief m𓾂
    ///
    /// \note lengthnorm̈Ⴂw܂߂邩ǂB
    /// 
    double getNorm() const {
        return (sqrt((double)(x*x + y*y + z*z + w*w)));
    }
    //////////////////////////////////////////////////
    /// \brief m^2 𓾂
    ///
    /// \note lengthnorm̈Ⴂw܂߂邩ǂB
    /// 
    T getNormSqr() const {
        return(x*x + y*y + z*z + w*w);
    }
    //////////////////////////////////////////////////
    /// \brief vf(0, 0, 0, 0)ǂB
    /// 
    bool isZero() const {
        return((x == 0.0) && (y == 0.0) && (z == 0.0) && (w == 0.0));
    }
    //////////////////////////////////////////////////
    /// \brief KB
    /// 
    GLGTVector4<T>& normalize(void) {
        if(w != 1.0) {
            if(w == 0.0) {
                w = 1;
            }
            else {
                x /= w;
                y /= w;
                z /= w;
                w =  1;
            }
        }
        T m = getLength();
        if (m != 0.0) {
            x /= m;
            y /= m;
            z /= m;
        }

        return *this;
    }


};





//********************************************************************
/// \brief 4x4sNX
/// 
/// <PRE>
///                   (1)       (2)       (3)       (4)          
///                 | col[0].x   col[1].x   col[2].x   col[3].x  | (1s) 
///  GLGTMatrix44 = | col[0].y   col[1].y   col[2].y   col[3].y  | (2s) 
///  ([][s])     | col[0].z   col[1].z   col[2].z   col[3].z  | (3s) 
///                 | col[0].w   col[1].w   col[2].w   col[3].w  | (4s) 
///                                                                      
///                 | col[0][0]  col[1][0]  col[2][0]  col[3][0] | (1s) 
///               = | col[0][1]  col[1][1]  col[2][1]  col[3][1] | (2s) 
///                 | col[0][2]  col[1][2]  col[2][2]  col[3][2] | (3s) 
///                 | col[0][3]  col[1][3]  col[2][3]  col[3][3] | (4s) 
/// </PRE>
/// 
/// 
/// \bug eXgsEEE
/// 
template <typename T> class GLGTMatrix44
{
public:
    GLGTVector4<T> col[4];




public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTMatrix44() {
        col[0].w = 0.0;
        col[1].w = 0.0;
        col[2].w = 0.0;
        col[3].w = 1.0;
    };
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTMatrix44(const GLGTMatrix44& m) {
        col[0] = m[0];
        col[1] = m[1];
        col[2] = m[2];
        col[3] = m[3];
    }
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTMatrix44(const GLGTVector3<T>& v0, const GLGTVector3<T>& v1, const GLGTVector3<T>& v2, const GLGTVector3<T>& v3) {
        col[0] = v0;
        col[1] = v1;
        col[2] = v2;
        col[3] = v3;
        col[0].w = 0.0;
        col[1].w = 0.0;
        col[2].w = 0.0;
        col[3].w = 1.0;
    }
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTMatrix44(const GLGTVector4<T>& v0, const GLGTVector4<T>& v1, const GLGTVector4<T>& v2, const GLGTVector4<T>& v3) {
        col[0] = v0;
        col[1] = v1;
        col[2] = v2;
        col[3] = v3;
    }

    //////////////////////////////////////////////////
    /// \brief vfɃANZX
    GLGTVector4<T>& operator [](unsigned int i) {
        GLGTASSERT(i<4);
        return col[i];
    }
    //////////////////////////////////////////////////
    /// \brief vfɃANZX
    const GLGTVector4<T>& operator [](unsigned int i) const {
        GLGTASSERT(i<4);
        return col[i];
    }
    //////////////////////////////////////////////////
    /// \brief =
    GLGTMatrix44<T>& operator =  (const GLGTMatrix44<T>& m) {
        col[0] = m[0];
        col[1] = m[1];
        col[2] = m[2];
        col[3] = m[3];
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief +=
    GLGTMatrix44<T>& operator += (const GLGTMatrix44<T>& m) {
        col[0] += m[0];
        col[1] += m[1];
        col[2] += m[2];
        col[3] += m[3];
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief -=
    GLGTMatrix44<T>& operator -= (const GLGTMatrix44<T>& m) {
        col[0] -= m[0];
        col[1] -= m[1];
        col[2] -= m[2];
        col[3] -= m[3];
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief *=
    GLGTMatrix44<T>& operator *=(const GLGTMatrix44<T>& m) {
        GLGTMatrix44<T> temp;
        for (unsigned int r = 0; r < 4; r++) {
            for (unsigned int c = 0; c < 4; c++) {
                T t = 0;

                t += (col[0][r] * m[c][0]);
                t += (col[1][r] * m[c][1]);
                t += (col[2][r] * m[c][2]);
                t += (col[3][r] * m[c][3]);

                temp[c][r] = t;
            }
        }
        *this = temp;
        return *this;
    }

    GLGTMatrix44<T>& operator *=(T t) {
        col[0] *= t;
        col[1] *= t;
        col[2] *= t;
        col[3] *= t;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief /=
    GLGTMatrix44<T>& operator /=(T t) {
        GLGTASSERT(t!=0);
        col[0] /= t;
        col[1] /= t;
        col[2] /= t;
        col[3] /= t;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief GLGTMatrix44 == GLGTMatrix44
    friend bool operator ==(const GLGTMatrix44<T>& a, const GLGTMatrix44<T>& b) {
        return((a[0] == b[0])&&(a[1] == b[1])&&(a[2] == b[2])&&(a[3] == b[3]));
    }
    //////////////////////////////////////////////////
    /// \brief GLGTMatrix44 != GLGTMatrix44
    friend bool operator !=(const GLGTMatrix44<T>& a, const GLGTMatrix44<T>& b) {
        return((a[0] != b[0])||(a[1] != b[1])||(a[2] != b[2])||(a[3] != b[3]));
    }
    //////////////////////////////////////////////////
    /// \brief GLGTMatrix44 + GLGTMatrix44
    friend GLGTMatrix44<T> operator +(const GLGTMatrix44<T>& a, const GLGTMatrix44<T>& b) {
        GLGTMatrix44<T> ret(a);
        ret += b;
        return ret;
    }
    //////////////////////////////////////////////////
    /// \brief GLGTMatrix44 - GLGTMatrix44
    friend GLGTMatrix44<T> operator -(const GLGTMatrix44<T>& a, const GLGTMatrix44<T>& b) {
        GLGTMatrix44<T> ret(a);
        ret -= b;
        return ret;
    }
    //////////////////////////////////////////////////
    /// \brief GLGTMatrix44 * GLGTMatrix44
    friend GLGTMatrix44<T> operator *(const GLGTMatrix44<T>& a, const GLGTMatrix44<T>& b) {
        GLGTMatrix44<T> ret(a);
        ret *= b;
        return ret;
    }
    //////////////////////////////////////////////////
    /// \brief GLGTMatrix44 * GLGTVector4
    friend GLGTVector4<T> operator *(const GLGTMatrix44<T>& m, const GLGTVector4<T>& v) {
        GLGTVector4<T> ret;
        ret.x = v.x * m[0][0] + v.y * m[1][0] + v.z * m[2][0] + v.w * m[3][0];
        ret.y = v.x * m[0][1] + v.y * m[1][1] + v.z * m[2][1] + v.w * m[3][1];
        ret.z = v.x * m[0][2] + v.y * m[1][2] + v.z * m[2][2] + v.w * m[3][2];
        ret.w = v.x * m[0][3] + v.y * m[1][3] + v.z * m[2][3] + v.w * m[3][3];
        return ret;
    }
    //////////////////////////////////////////////////
    /// \brief GLGTMatrix44 * GLGTVector3
    friend GLGTVector3<T> operator *(const GLGTMatrix44<T>& m, const GLGTVector3<T>& v) {
        GLGTVector3<T> ret;
        ret.x = v.x * m[0][0] + v.y * m[1][0] + v.z * m[2][0] + 1.0 * m[3][0];
        ret.y = v.x * m[0][1] + v.y * m[1][1] + v.z * m[2][1] + 1.0 * m[3][1];
        ret.z = v.x * m[0][2] + v.y * m[1][2] + v.z * m[2][2] + 1.0 * m[3][2];
        return ret;
    }
    //////////////////////////////////////////////////
    /// \brief GLGTMatrix44 * T
    friend GLGTMatrix44<T> operator *(const GLGTMatrix44<T>& m, T t) {
        GLGTMatrix44<T> ret(m);
        ret *= t;
        return ret;
    }
    //////////////////////////////////////////////////
    /// \brief T * GLGTMatrix44
    friend GLGTMatrix44<T> operator *(T t, const GLGTMatrix44<T>& m) {
        GLGTMatrix44<T> ret(m);
        ret *= t;
        return ret;
    }

    //////////////////////////////////////////////////
    /// \brief PʍsZbg
    /// 
    /// \return IuWFNg
    GLGTMatrix44<T>& setIdentityMatrix(void) {
        col[0].Set(1.0, 0.0, 0.0, 0.0);
        col[1].Set(0.0, 1.0, 0.0, 0.0);
        col[2].Set(0.0, 0.0, 1.0, 0.0);
        col[3].Set(0.0, 0.0, 0.0, 1.0);
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief x]sZbg
    /// 
    /// _S̉]
    /// 
    /// \param deg ]
    /// \return IuWFNg
    GLGTMatrix44<T>& setXRotationMatrix(T deg) { //_S̉]
        deg = GLGTConvertDegToRad(deg);//WAɕϊ
        T s = sin((double)deg);
        T c = cos((double)deg);
        col[0].Set(1.0, 0.0, 0.0, 0.0);
        col[1].Set(0.0,   c,   s, 0.0);
        col[2].Set(0.0,  -s,   c, 0.0);
        col[3].Set(0.0, 0.0, 0.0, 1.0);
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief x]sZbg
    /// 
    /// Cӓ_(center)S̉]
    /// 
    /// \param deg ]
    /// \param center ]̒S
    /// \return IuWFNg
    GLGTMatrix44<T>& setRotationMatrix(T deg, GLGTVector3<T>& center) { //centerS̉]
        deg = GLGTConvertDegToRad(deg);//WAɕϊ
        T s = sin((double)deg);
        T c = cos((double)deg);
        col[0].Set(1.0,                            0.0,                            0.0, 0.0);
        col[1].Set(0.0,                              c,                              s, 0.0);
        col[2].Set(0.0,                             -s,                              c, 0.0);
        col[3].Set(0.0, center.y-c*center.y+s*center.z, center.z-s*center.y-c*center.z, 1.0);
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief y]sZbg
    /// 
    /// _S̉]
    /// 
    /// \param deg ]
    /// \return IuWFNg
    GLGTMatrix44<T>& setYRotationMatrix(T deg) {//_S̉]
        deg = GLGTConvertDegToRad(deg);//WAɕϊ
        T s = sin((double)deg);
        T c = cos((double)deg);
        col[0].Set(  c, 0.0,  -s, 0.0);
        col[1].Set(0.0, 1.0, 0.0, 0.0);
        col[2].Set(  s, 0.0,   c, 0.0);
        col[3].Set(0.0, 0.0, 0.0, 1.0);
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief y]sZbg
    /// 
    /// Cӓ_(center)S̉]
    /// 
    /// \param deg ]
    /// \param center ]̒S
    /// \return IuWFNg
    GLGTMatrix44<T>& setYRotationMatrix(T deg, GLGTVector3<T>& center) {//centerS̉]
        deg = GLGTConvertDegToRad(deg);//WAɕϊ
        T s = sin((double)deg);
        T c = cos((double)deg);
        col[0].Set(  c, 0.0,  -s, 0.0);
        col[1].Set(0.0, 1.0, 0.0, 0.0);
        col[2].Set(  s, 0.0,   c, 0.0);
        col[3].Set(center.x-c*center.x-s*center.z, 0.0, center.z+s*center.x-c*center.z, 1.0);
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief z]sZbg
    /// 
    /// _S̉]
    /// 
    /// \param deg ]
    /// \return IuWFNg
    GLGTMatrix44<T>& setZRotationMatrix(T deg) {//_S̉]
        deg = GLGTConvertDegToRad(deg);//WAɕϊ
        T s = sin((double)deg);
        T c = cos((double)deg);
        col[0].Set(  c,   s, 0.0, 0.0);
        col[1].Set( -s,   c, 0.0, 0.0);
        col[2].Set(0.0, 0.0, 1.0, 0.0);
        col[3].Set(0.0, 0.0, 0.0, 1.0);
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief z]sZbg
    /// 
    /// Cӓ_(center)S̉]
    /// 
    /// \param deg ]
    /// \param center ]̒S
    /// \return IuWFNg
    GLGTMatrix44<T>& setZRotationMatrix(T deg, GLGTVector3<T>& center) {//centerS̉]
        deg = GLGTConvertDegToRad(deg);//WAɕϊ
        T s = sin((double)deg);
        T c = cos((double)deg);
        col[0].Set(  c,   s, 0.0, 0.0);
        col[1].Set( -s,   c, 0.0, 0.0);
        col[2].Set(0.0, 0.0, 1.0, 0.0);
        col[3].Set(center.x-c*center.x+s*center.y, center.y-s*center.x-c*center.y, 0.0, 1.0);
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief ړsZbg
    ///
    ///
    /// 
    /// \param v ړ
    /// \return IuWFNg
    GLGTMatrix44<T>& setTranslationMatrix (GLGTVector3<T>& v) {
        col[0].Set(1.0, 0.0, 0.0, v.x);
        col[1].Set(0.0, 1.0, 0.0, v.y);
        col[2].Set(0.0, 0.0, 1.0, v.z);
        col[3].Set(0.0, 0.0, 0.0, 1.0);
        return *this;
    }

    //////////////////////////////////////////////////
    /// \brief ]usɕϊ
    /// 
    /// \return IuWFNg
    GLGTMatrix44<T>& transpose(void) {
        T t;
        for (unsigned int c = 0; c < 4; c++) {
            for (unsigned int r = c + 1; r < 4; r++) {
                t = col[c][r];
                col[c][r] = col[r][c];
                col[r][c] = t;
            } 
        } 
        return *this;
    }


    //////////////////////////////////////////////////
    /// \brief tsɕϊ
    /// 
    /// \return IuWFNg
    GLGTMatrix44<T>& invert(void) {
        GLGTMatrix44<T> a(*this);
        GLGTMatrix44<T> b;
        b.SetIdentity();//PʍsZbg

        unsigned int r, c;
        unsigned int cc;
        unsigned int row_max; // ̒ŐΒlő̍s̃CfbNX 0`3
        unsigned int row;
        T temp_t;

        // Go through columns
        for (c=0; c<4; c++) {
            // ̒ŐΒlő̍s̃CfbNXT
            row_max = c;
            for (r=c+1; r<4; r++) {
                if (fabs(a[c][r]) > fabs(a[c][row_max])) {
                    row_max = r;
                }
            }

            // row_max̏ꏊ̒l0̏ꍇts͋߂ȂBPʍsԂ
            if (a[row_max][c] == 0.0)
                return(Identity());

            // Swap row "row_max" with row "c"
            for (cc=0; cc<4; cc++) {
                temp_t = a[cc][c];
                a[cc][c] = a[cc][row_max];
                a[cc][row_max] = temp_t;
                temp_t = b[cc][c];
                b[cc][c] = b[cc][row_max];
                b[cc][row_max] = temp_t;
            }

            // Now everything we do is on row "c".
            // Set the max cell to 1 by dividing the entire row by that value
            temp_t = a[c][c];
            for (cc=0; cc<4; cc++) {
                a[cc][c] /= temp_t;
                b[cc][c] /= temp_t;
            }

            // Now do the other rows, so that this column only has a 1 and 0's
            for (row = 0; row < 4; row++) {
                if (row != c) {
                    temp_t = a[c][row];
                    for (cc=0; cc<4; cc++) {
                        a[cc][row] -= a[cc][c] * temp_t;
                        b[cc][row] -= b[cc][c] * temp_t;
                    }
                }
            }

        }
        *this = b;
        return *this;
    }

};










//********************************************************************
/// \brief 3Op`NX
/// 
/// 
/// 
/// 
template <typename T> class GLGTTriangle3
{
public:
    GLGTVector3<T> vertices[3]; ///<_

public:
    //////////////////////////////////////////////////
    /// \brief ftHgRXgN^
    ///
    /// ͂Ȃ
    GLGTTriangle3() {}
    //////////////////////////////////////////////////
    /// \brief Rs[RXgN^
    GLGTTriangle3(const GLGTTriangle3<T>& in_tri) {
        vertices[0] = in_tri.vertices[0];
        vertices[1] = in_tri.vertices[1];
        vertices[2] = in_tri.vertices[2];
    }
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTTriangle3(const GLGTVector3<T>& in_v0, const GLGTVector3<T>& in_v1, const GLGTVector3<T>& in_v2){
        vertices[0] = in_v0;
        vertices[1] = in_v1;
        vertices[2] = in_v2;
    }

    //////////////////////////////////////////////////
    /// \brief vfɃANZX
    GLGTVector3<T>& operator [](unsigned int i) {
        GLGTASSERT(i<3);
        return verticies[i];
    }
    //////////////////////////////////////////////////
    /// \brief vfɃANZX
    const GLGTVector3<T>& operator [](unsigned int i) const {
        GLGTASSERT(i<3);
        return verticies[i];
    }


    //////////////////////////////////////////////////
    /// \brief =
    GLGTTriangle3<T>& operator =(const GLGTTriangle3<T>& in_tri) {
        vertices[0] = in_tri.vertices[0];
        vertices[1] = in_tri.vertices[1];
        vertices[2] = in_tri.vertices[2];
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief +=
    GLGTTriangle3<T>& operator +=(const GLGTVector3<T>& in_v) {
        vertices[0] += in_v;
        vertices[1] += in_v;
        vertices[2] += in_v;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief -=
    GLGTTriangle3<T>& operator -=(const GLGTVector3<T>& in_v) {
        vertices[0] -= in_v;
        vertices[1] -= in_v;
        vertices[2] -= in_v;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief *=
    GLGTTriangle3<T>& operator *=(T in) {
        vertices[0] *= in;
        vertices[1] *= in;
        vertices[2] *= in;
        return *this;
    }
    //////////////////////////////////////////////////
    /// \brief /=
    GLGTTriangle3<T>& operator /=(T in) {
        vertices[0] /= in;
        vertices[1] /= in;
        vertices[2] /= in;
        return *this;
    }


    //////////////////////////////////////////////////
    /// \brief == 
    friend bool operator ==(const GLGTTriangle3<T>& a, const GLGTTriangle3<T>& b) {
        return((a[0] == b[0])&&(a[1] == b[1])&&(a[2] == b[2]));
    }
    //////////////////////////////////////////////////
    /// \brief != 
    friend bool operator !=(const GLGTTriangle3<T>& a, const GLGTTriangle3<T>& b) {
        return((a[0] != b[0])||(a[1] != b[1])||(a[2] != b[2]));
    }


};







//********************************************************************
/// \brief `NX
/// 
/// 
/// 
/// 
template <typename T> class GLGTRect
{
public:
    T left;     ///< 
    T right;    ///< E
    T top;      ///< 
    T bottom;   ///< 
public:
    //////////////////////////////////////////////////
    /// \brief ftHgRXgN^
    ///
    /// ͂Ȃ
    GLGTRect() {}
    //////////////////////////////////////////////////
    /// \brief Rs[RXgN^
    GLGTRect(const GLGTRect<T>& in_rect): left(in_rect.left), right(in_rect.right), bottom(in_rect.bottom), top(in_rect.top){}
    //////////////////////////////////////////////////
    /// \brief RXgN^
    ///
    /// ̏Ԃɒ
    ///
    GLGTRect(T in_left, T in_right, T in_top, T in_bottom): left(in_left), right(in_right), top(in_top), bottom(in_bottom){}


    //////////////////////////////////////////////////
    /// \brief =
    GLGTRect<T>& operator =(const GLGTRect<T>& in_rect) {
        left   = in_rect.left;
        right  = in_rect.right;
        bottom = in_rect.bottom;
        top    = in_rect.top;
        return *this;
    }


    //////////////////////////////////////////////////
    /// \brief == 
    friend bool operator ==(const GLGTRect<T>& a, const GLGTRect<T>& b) {
        return((a.left == b.left)&&(a.right == b.right)&&(a.bottom == b.bottom)&&(a.top == b.top));
    }
    //////////////////////////////////////////////////
    /// \brief != 
    friend bool operator !=(const GLGTRect<T>& a, const GLGTRect<T>& b) {
        return((a.left != b.left)||(a.right != b.right)||(a.bottom != b.bottom)||(a.top != b.top));
    }

    //////////////////////////////////////////////////
    /// \brief set
    ///
    /// ̏Ԃɒ
    ///
    void set(T in_left, T in_right, T in_top, T in_bottom) {
        left   = in_left;
        right  = in_right;
        top    = in_top;
        bottom = in_bottom;
    }



};






//********************************************************************
/// \brief EBhEEtH[p̒`NX
/// 
/// 
/// 
/// 
class GLGTRectEXT
{
public:

    GLGTVector2<int> position; ///< ʒu (̍W)
    GLGTVector2<unsigned int> dimension; ///< TCY (x:width, y:height)

public:
    //////////////////////////////////////////////////
    /// \brief ftHgRXgN^
    ///
    /// ͂Ȃ
    GLGTRectEXT() {}
    //////////////////////////////////////////////////
    /// \brief Rs[RXgN^
    GLGTRectEXT(const GLGTRectEXT& in_rect) : position(in_rect.position), dimension(in_rect.dimension) {}
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTRectEXT(const GLGTVector2<int>& in_pos, const GLGTVector2<unsigned int>& in_dim) : position(in_pos), dimension(in_dim) {}


    //////////////////////////////////////////////////
    /// \brief =
    GLGTRectEXT& operator =(const GLGTRectEXT& in_rect) {
        position = in_rect.position;
        dimension = in_rect.dimension;
        return *this;
    }

    //////////////////////////////////////////////////
    /// \brief == 
    friend bool operator ==(const GLGTRectEXT& a, const GLGTRectEXT& b) {
        return((a.position == b.position)&&(a.dimension == b.dimension));
    }
    //////////////////////////////////////////////////
    /// \brief != 
    friend bool operator !=(const GLGTRectEXT& a, const GLGTRectEXT& b) {
        return((a.position != b.position)||(a.dimension != b.dimension));
    }


    //////////////////////////////////////////////////
    /// \brief _Rect̓ɂ邩
    bool isPointInside(int in_pointx, int in_pointy) const {
        if((position.x <= in_pointx)&&(in_pointx < position.x+(int)dimension.x)&&
            (position.y <= in_pointy)&&(in_pointy < position.y+(int)dimension.y)) {
                return true;
            }
            return false;
    }

    //////////////////////////////////////////////////
    /// \brief _Rect̓ɂ邩
    bool isPointInside(const GLGTVector2<int>& in_point) const {
        if((position.x <= in_point.x)&&(in_point.x < position.x+(int)dimension.x)&&
            (position.y <= in_point.y)&&(in_point.y < position.y+(int)dimension.y)) {
                return true;
            }
            return false;
    }


    //////////////////////////////////////////////////
    /// \brief set 
    void set(const GLGTVector2<int>& in_pos, const GLGTVector2<unsigned int>& in_dim) {
        position = in_pos;
        dimension = in_dim;
    }
    //////////////////////////////////////////////////
    /// \brief set 
    void set(int in_posx, int in_posy, unsigned int in_dimx, unsigned int in_dimy) {
        position.set(in_posx,in_posy);
        dimension.set(in_dimx,in_dimy);
    }





};








#endif
