//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTMODEL_H_
#define _GLGTMODEL_H_

#include <vector>
#include <string>

#include "GLGTBase.h"
#include "GLGTFlagArray.h"
#include "GLGTMath.h"
#include "GLGTColor.h"
#include "GLGTTextureManager.h"

#define MAX_MODEL 131072 ///< ێł郂ff[^ő吔(K)
#define NO_MODEL MAX_MODEL+1 ///< ݂Ȃꍇ̖߂l

//********************************************************************
/// \brief f̃^Cv
/// 
/// 
/// 
/// 
enum GLGTModelType {
    MODEL_UNKNOWN,
    MODEL_MQO
    //MODEL_MCL,
    //MODEL_3DS
};





//********************************************************************
/// \brief Op|Sf[^
/// 
/// 
/// 
/// 
template <typename T> struct GLGTTriangle {
    unsigned int vertexindex[3]; ///< _̃CfbNX
    unsigned int materialindex; ///< }eÃCfbNX
    GLGTVector2<T> uv[3]; //UVW
};





//********************************************************************
/// \brief f̃IuWFNgNX
/// 
/// \attention typename͕t_^łׂB(float,double)
/// \note Op|Sf[^eNX`LƖŕĂ̂glEnable(),glDisable()xĂяoȂĂ悤ɂ邽߁B
/// 
template <typename T> class GLGTModelObject {

    friend class GLGTModelManager_Singleton;

protected:
    std::string name; ///< IuWFNg̖O

    std::vector<GLGTVector3<T> > origVertex; ///< _
    std::vector<GLGTVector3<T> > origNormal; ///< @
    GLGTVector3<T> origCenter; ///< ]̒S_

    std::vector<T> weight; ///< EFCg(IuWFNg̉])

    std::vector<GLGTTriangle<T> > nonTextureTriangle; ///< }eAeNX`ȂOp|S
    std::vector<GLGTTriangle<T> > textureTriangle; ///< }eAeNX`Op|S

    std::vector<GLGTModelObject<T>*> childObject; ///< qIuWFNg

public:
    std::vector<GLGTVector3<T> > vertex; ///< ϊ̒_(`̑Ώ)
    std::vector<GLGTVector3<T> > normal; ///< ϊ̖@(`̑Ώ)
    GLGTVector3<T> center; ///< ϊ̉]̒S_










public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTModelObject(void);

    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTModelObject();


    //////////////////////////////////////////////////
    /// \brief j
    void destroy(void);

    //////////////////////////////////////////////////
    /// \brief vpeB
    void clear(void);





    //////////////////////////////////////////////////
    /// \brief getName
    const std::string& getName(void) const {return name;}

    //////////////////////////////////////////////////
    /// \brief getVertex
    const GLGTVector3<T>& getVertex(unsigned int index) const {
        GLGTASSERT(vertex.size() > index);
        return vertex[index];
    }

    //////////////////////////////////////////////////
    /// \brief getNormal
    const GLGTVector3<T>& getNormal(unsigned int index) const {
        GLGTASSERT(normal.size() > index);
        return normal[index];
    }

    //////////////////////////////////////////////////
    /// \brief getWeight
    T getWeight(unsigned int index) const {
        GLGTASSERT(weight.size() > index);
        return weight[index];
    }

    //////////////////////////////////////////////////
    /// \brief getNonTextureTriangle
    const GLGTTriangle<T>& getNonTextureTriangle(unsigned int index) const {
        GLGTASSERT(nonTextureTriangle.size() > index);
        return nonTextureTriangle[index];
    }

    //////////////////////////////////////////////////
    /// \brief getTextureTriangle
    const GLGTTriangle<T>& getTextureTriangle(unsigned int index) const {
        GLGTASSERT(textureTriangle.size() > index);
        return textureTriangle[index];
    }

    //////////////////////////////////////////////////
    /// \brief getCenter
    const GLGTVector3<T>& getCenter(void) const {return center;}


    //////////////////////////////////////////////////
    /// \brief nonTextureTriangle̐𓾂B
    unsigned int getNonTextureTriangleCount(void) const {return (unsigned int)nonTextureTriangle.size();}

    //////////////////////////////////////////////////
    /// \brief textureTriangle̐𓾂B
    unsigned int getTextureTriangleCount(void) const {return (unsigned int)textureTriangle.size();}




    //////////////////////////////////////////////////
    /// \brief @߂
    ///
    /// |S̖@߁A\钸_ɑΉnormalɂ̒l𑫂ĂB
    /// ŌɑSĂ̖@𐳋KB
    void genVertexNormal(void);




    //////////////////////////////////////////////////
    /// \brief eNX`Op|STu~bg
    /// \param i Op|S̃CfbNX
    void submitNonTextureTriangle(unsigned int i);

    //////////////////////////////////////////////////
    /// \brief eNX`LOp|STu~bg
    /// \param i Op|S̃CfbNX
    void submitTextureTriangle(unsigned int i);


    //////////////////////////////////////////////////
    /// \brief 
    /// \param 
    /// \return 
    /// \retval 
    //void (void);


    //////////////////////////////////////////////////
    /// \brief 
    /// \param 
    /// \return 
    /// \retval 
    //void (void);





};

//**************************************************
// o֐̒`
//////////////////////////////////////////////////
template <typename T> GLGTModelObject<T>::GLGTModelObject(void) {
    clear();
}

//////////////////////////////////////////////////
template <typename T> GLGTModelObject<T>::~GLGTModelObject() {
    destroy();
}

//////////////////////////////////////////////////
template <typename T> void GLGTModelObject<T>::destroy(void) {

    clear();
}

//////////////////////////////////////////////////
template <typename T> void GLGTModelObject<T>::clear(void) {

}

//////////////////////////////////////////////////
template <> inline void GLGTModelObject<double>::submitNonTextureTriangle(unsigned int i) {
    GLGTASSERT(i < nonTextureTriangle.size());

    glNormal3dv(&(normal[nonTextureTriangle[i].vertexindex[0]][0]));
    glVertex3dv(&(vertex[nonTextureTriangle[i].vertexindex[0]][0]));

    glNormal3dv(&(normal[nonTextureTriangle[i].vertexindex[1]][0]));
    glVertex3dv(&(vertex[nonTextureTriangle[i].vertexindex[1]][0]));

    glNormal3dv(&(normal[nonTextureTriangle[i].vertexindex[2]][0]));
    glVertex3dv(&(vertex[nonTextureTriangle[i].vertexindex[2]][0]));
}

//////////////////////////////////////////////////
template <> inline void GLGTModelObject<double>::submitTextureTriangle(unsigned int i) {
    GLGTASSERT(i < textureTriangle.size());

    glNormal3dv(&(normal[textureTriangle[i].vertexindex[0]][0]));
    glTexCoord2dv(&(textureTriangle[i].uv[0][0]));
    glVertex3dv(&(vertex[textureTriangle[i].vertexindex[0]][0]));

    glNormal3dv(&(normal[textureTriangle[i].vertexindex[1]][0]));
    glTexCoord2dv(&(textureTriangle[i].uv[1][0]));
    glVertex3dv(&(vertex[textureTriangle[i].vertexindex[1]][0]));

    glNormal3dv(&(normal[textureTriangle[i].vertexindex[2]][0]));
    glTexCoord2dv(&(textureTriangle[i].uv[2][0]));
    glVertex3dv(&(vertex[textureTriangle[i].vertexindex[2]][0]));
}


//********************************************************************
/// \brief f̃}eANX
/// 
/// 
/// 
template <typename T> class GLGTModelMaterial {

    friend class GLGTModelManager_Singleton;

protected:
    std::string name;
    GLGTColor4<T> color;
    GLGTTexture texture;
    unsigned int textureID;










public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTModelMaterial(void);

    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTModelMaterial();


    //////////////////////////////////////////////////
    /// \brief j
    void destroy(void);

    //////////////////////////////////////////////////
    /// \brief vpeB
    void clear(void);





    //////////////////////////////////////////////////
    /// \brief eNX`L肩ǂ
    bool isTexture(void) const {
        return (texture.isReferring());
    }

    //////////////////////////////////////////////////
    /// \brief 
    unsigned int getTextureID(void) const {
        return textureID;
    }





    //////////////////////////////////////////////////
    /// \brief }eÃf[^ꊇăZbg 
    /// 
    /// eNX`L̏ꍇ͂łɃ[hĂGLGTTexturenȂ΂ȂȂB
    /// 
    /// \param in_name }eA̖O
    /// \param in_color }eA̐F
    /// \param in_tex }eÃeNX`
    void set(const std::string& in_name, const GLGTColor4<T>& in_color, GLGTTexture in_tex);





    //////////////////////////////////////////////////
    /// \brief FTu~bg
    void submitColor(void);

    //////////////////////////////////////////////////
    /// \brief 
    /// \param 
    /// \return 
    /// \retval 
    //void (void);











};

//**************************************************
// o֐̒`
//////////////////////////////////////////////////
template <typename T> GLGTModelMaterial<T>::GLGTModelMaterial(void) {
    clear();
}

//////////////////////////////////////////////////
template <typename T> GLGTModelMaterial<T>::~GLGTModelMaterial() {
    destroy();
}

//////////////////////////////////////////////////
template <typename T> void GLGTModelMaterial<T>::destroy(void) {

    clear();
}

//////////////////////////////////////////////////
template <typename T> void GLGTModelMaterial<T>::clear(void) {
    name = "";
    color.set(1.0,1.0,1.0,1.0);
    //eNX`L̏ꍇ͉
    if(isTexture()) {
        glDeleteTextures(1,&textureID);
    }
}

//////////////////////////////////////////////////
template <typename T> void GLGTModelMaterial<T>::set(const std::string& in_name, const GLGTColor4<T>& in_color, GLGTTexture in_tex) {
    name = in_name;
    color = in_color;
    texture = in_tex;
    //eNX`L̏ꍇ͎g悤ɂB
    if(isTexture()) {
        glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
        glGenTextures(1, &textureID);
        glBindTexture(GL_TEXTURE_2D, textureID);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
        glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA4,
            texture.getWidth(), texture.getHeight(),
            0, GL_RGBA, GL_UNSIGNED_BYTE, texture.getPixels());
    }
}

//////////////////////////////////////////////////
template <> inline void GLGTModelMaterial<double>::submitColor(void) {
    glColor4dv(&(color[0]));
}



//********************************************************************
/// \brief ff[^ێNX
///
/// \attention eXgiKȂ̂Ń`N`łB
///
/// `A[VȂǂB
/// ʃf[^͂Ƃ肠Op`ŕێB(lp`͎Op`ɕB)
/// 
/// ff[^[ĥGLGTModelManager_SingletonŁB
/// 
/// 
/// \param TObj IuWFNg(_)̌^
/// \param TMat }eA(F)̌^
template <typename TObj=double, typename TMat=double> class GLGTModel {

    friend class GLGTModelManager_Singleton;

protected:
    unsigned int modelIndex; ///< f}l[W猩CfbNX
    bool loaded;
    std::vector<GLGTModelObject<TObj> > modelObject; ///< IuWFNg
    std::vector<GLGTModelMaterial<TMat> > modelMaterial; ///< }eA
    std::string name; ///< O(t@C)
    GLGTModelType type; ///<f̃^Cv









public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTModel(void);
    GLGTModel(std::string in_name, GLGTModelType in_type);
    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTModel();

    //////////////////////////////////////////////////
    /// \brief j
    void destroy(void);

    //////////////////////////////////////////////////
    /// \brief vpeB
    void clear(void);




    //////////////////////////////////////////////////
    /// \brief ǂݍ܂Ă邩
    bool isLoaded(void) const {return loaded;}



    //////////////////////////////////////////////////
    /// \brief getModelIndex
    unsigned int getModelIndex(void) const {return modelIndex;}


    //////////////////////////////////////////////////
    /// \brief getName
    const std::string& getName(void) const {return name;}

    //////////////////////////////////////////////////
    /// \brief getType
    GLGTModelType getType(void) const {return type;}

    //////////////////////////////////////////////////
    /// \brief 
    GLGTModelObject<TObj>& getObject(unsigned int i) {
        GLGTASSERT((i < modelObject.size())&&(loaded == true));
        return modelObject[i];
    }

    //////////////////////////////////////////////////
    /// \brief 
    GLGTModelMaterial<TMat>& getMaterial(unsigned int i) {
        GLGTASSERT((i < modelMaterial.size())&&(loaded == true));
        return modelMaterial[i];
    }





    //////////////////////////////////////////////////
    /// \brief setModelIndex
    void setModelIndex(unsigned int in_modelindex) {modelIndex = in_modelindex;}


    //////////////////////////////////////////////////
    /// \brief f̃f[^ꊇZbg 
    /// 
    /// \note zŜ̃Rs[
    /// 
    /// \param in_modelobject f̃IuWFNg
    /// \param in_modelmaterial f̃}eA
    /// 
    void setModelData(const std::vector<GLGTModelObject<TObj> >& in_modelobject, const std::vector<GLGTModelMaterial<TMat> >& in_modelmaterial) {
        modelObject = in_modelobject;
        modelMaterial = in_modelmaterial;
        loaded = true;
    }



    //////////////////////////////////////////////////
    /// \brief ێ郂f̃f[^
    ///
    void initModelData(const std::string& in_name, GLGTModelType in_type) {
        deleteModelData();
        name = in_name;
        type = in_type;
    }


    //////////////////////////////////////////////////
    /// \brief ff[^j
    ///
    /// objectmaterial̒gj
    void deleteModelData(void);


    //////////////////////////////////////////////////
    /// \brief IuWFNg`
    /// \param index IuWFNg̃CfbNX
    void drawModelObject(unsigned int index) {
        GLGTASSERT(index < modelObject.size());

        unsigned int tri_size = modelObject[index].getNonTextureTriangleCount();
        glDisable(GL_TEXTURE_2D);
        glBegin(GL_TRIANGLES);
        for(unsigned int i = 0; i < tri_size; i++) {
            modelMaterial[modelObject[index].getNonTextureTriangle(i).materialindex].submitColor();
            modelObject[index].submitNonTextureTriangle(i);
        }
        glEnd();

        tri_size = modelObject[index].getTextureTriangleCount();
        glEnable(GL_TEXTURE_2D);
        for(unsigned int i = 0; i < tri_size; i++) {
            glBindTexture(GL_TEXTURE_2D,modelMaterial[modelObject[index].getTextureTriangle(i).materialindex].getTextureID());
            glBegin(GL_TRIANGLES);
            modelMaterial[modelObject[index].getTextureTriangle(i).materialindex].submitColor();
            modelObject[index].submitTextureTriangle(i);
            glEnd();

        }
    }

    //////////////////////////////////////////////////
    /// \brief f`
    void drawModel(void) {
        unsigned int obj_size = (unsigned int)modelObject.size();
        for(unsigned int i = 0; i < obj_size; i++) {
            drawModelObject(i);
        }
    }



    //////////////////////////////////////////////////
    /// \brief 
    /// \param 
    /// \return 
    /// \retval 
    //void (void);


    //////////////////////////////////////////////////
    /// \brief 
    /// \param 
    /// \return 
    /// \retval 
    //void (void);





};

//**************************************************
// o֐̒`
//////////////////////////////////////////////////
template <typename TObj, typename TMat> GLGTModel<TObj,TMat>::GLGTModel(void) {
    clear();
}

template <typename TObj, typename TMat> GLGTModel<TObj,TMat>::GLGTModel(std::string in_name, GLGTModelType in_type) {
    clear();
    initModelData(in_name, in_type);
}

//////////////////////////////////////////////////
template <typename TObj, typename TMat> GLGTModel<TObj,TMat>::~GLGTModel() {
    destroy();
}

//////////////////////////////////////////////////
template <typename TObj, typename TMat> void GLGTModel<TObj,TMat>::destroy(void) {
    modelObject.clear();
    modelMaterial.clear();

    clear();
}
//////////////////////////////////////////////////
template <typename TObj, typename TMat> void GLGTModel<TObj,TMat>::clear(void) {
    modelIndex = NO_MODEL;
    loaded = false;
    name = "";
    type = MODEL_UNKNOWN;

}


//////////////////////////////////////////////////
template <typename TObj, typename TMat> void GLGTModel<TObj,TMat>::deleteModelData(void) {
    modelObject.clear();
    modelMaterial.clear();
    loaded = false;
}



#endif
