//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTPROFILER_H_
#define _GLGTPROFILER_H_

#include <string>

#include "GLGTBase.h"
#include "GLGTSingleton.h"
#include "GLGTFlagArray.h"
#include "GLGTTime.h"
#include "GLGTFontRenderer.h"

#define GLGTProfiler    GLGTProfiler_Singleton::getSingleton()    ///< CX^XɃANZX
#define ptrGLGTProfiler GLGTProfiler_Singleton::getSingletonPtr() ///< CX^X̃|C^ɃANZX

#define GLGTPROFILER_SAMPLEDATASIZE 64 ///< vt@C̍őTv
#define GLGTPROFILER_INVALID GLGTPROFILER_SAMPLEDATASIZE+1 ///< ȃvt@C̃Tv

//********************************************************************
/// \brief GLGTProfiler̃[h
/// 
enum GLGTProfilerMode {
    GLGTPROFILERMODE_ENABLE,            ///< LɂB



    GLGTFLAGARRAYSIZE_GLGTPROFILERMODE
} ;



//********************************************************************
/// \brief vt@C̃Tv
/// 
/// 
/// 
/// 
struct GLGTProfileSample {
    bool valid; ///< L
    std::string name; ///< Tv̖O
    unsigned int openCount; ///< Jꂽ
    bool locked; ///< bN

    unsigned int beginTime; ///< Jn
    unsigned int totalProfilingTime; ///< Tv

    unsigned int totalChildrenProfilingTime; ///< qvt@C̑Tv

    unsigned int parentsCount; ///< evt@C̐

    float avgRate; ///< t[Pʂ̕ώ(p[Zg)
    float minRate; ///< t[Pʂ̍ŏ(p[Zg)
    float maxRate; ///< t[Pʂ̍ő厞(p[Zg)
};


//********************************************************************
/// \brief ȈՃA^Cvt@C̃VOgNX
///
/// GLGTProfiler_SingletonGLGTInitŃRXgNgA
/// GLGTQuitŃfXgNgB
/// GLGTProfilerŃCX^XɃANZXB
/// 
/// 
class GLGTProfiler_Singleton : public GLGTSingleton<GLGTProfiler_Singleton> {

    // vpeB ****************************************
public:
    GLGTFlagArray<GLGTProfilerMode> profilerMode; ///< [h
protected:
    GLGTProfileSample profileSamples[GLGTPROFILER_SAMPLEDATASIZE]; ///< vt@C̃Tv
    unsigned int validSampleDataCount; ///<LȃTvf[^

    unsigned int profilingBeginTime; ///< vt@COJn
    unsigned int profilingEndTime;   ///< vt@COI

private:

    // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief ftHgRXgN^
    GLGTProfiler_Singleton(void);

    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTProfiler_Singleton();


    //////////////////////////////////////////////////
    /// \brief vt@C̃Tvf[^NA
    void clearProfileSamples(void) {
        if(profilerMode[GLGTPROFILERMODE_ENABLE] == false) {return;}
        for(unsigned int i = 0; i < validSampleDataCount; i++) {
            //
            profileSamples[i].openCount = 0;
            profileSamples[i].totalProfilingTime = 0;
            profileSamples[i].totalChildrenProfilingTime = 0;
            profileSamples[i].locked = false;
        }





    }

    //////////////////////////////////////////////////
    /// \brief vt@CvXV
    void updateProfileStatistics(void);




    //////////////////////////////////////////////////
    /// \brief Tṽvt@COJn
    unsigned int  beginSampleProfiling(const char* in_samplename);
    //////////////////////////////////////////////////
    /// \brief Tṽvt@COJn
    unsigned int beginSampleProfiling(const std::string& in_samplename) {
        return beginSampleProfiling(in_samplename.c_str());
    }

    //////////////////////////////////////////////////
    /// \brief Tṽvt@COI
    void endSampleProfiling(const char* in_samplename) {
        if(profilerMode[GLGTPROFILERMODE_ENABLE] == false) {return;}
        unsigned int i;
        GLGTASSERT(0 < validSampleDataCount);
        for(i = 0;profileSamples[i].name != in_samplename; i++) {
            GLGTASSERT(i+1 < validSampleDataCount);
        }
        endSampleProfiling(i);
    }
    //////////////////////////////////////////////////
    /// \brief Tṽvt@COI
    void endSampleProfiling(const std::string& in_samplename) {
        endSampleProfiling(in_samplename.c_str());
    }
    //////////////////////////////////////////////////
    /// \brief Tṽvt@COI
    void endSampleProfiling(unsigned int in_sampleindex);



    //////////////////////////////////////////////////
    /// \brief 
    void drawProfile(int in_left, int in_top, unsigned int in_viewportwidth, unsigned int in_viewportheight);



    //////////////////////////////////////////////////
    /// \brief 
    void outputToStdout(unsigned int interval = 0);




    // getter/setter ****************************************

    //////////////////////////////////////////////////
    /// \brief getter of 
    // get(void) const {}  
    //////////////////////////////////////////////////
    /// \brief setter of 
    //void set( in_) {}





    // J ****************************************
protected:



private:
    //////////////////////////////////////////////////
    /// \brief vpeB
    //void clear(void);




    //////////////////////////////////////////////////
    /// \brief 
    /// \param 
    /// \return 
    /// \retval 
    //void (void);


};








#endif
