//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTPUSHBUTTONFORM_H_
#define _GLGTPUSHBUTTONFORM_H_

#include <string>

#include "GLGTBase.h"
#include "GLGTFlagArray.h"
#include "GLGTFontRenderer.h"
#include "GLGTStringBoxForm.h"
#include "GLGTForm.h"
#include "GLGTColor.h"





//********************************************************************
/// \brief vbV{^tH[
/// 
/// 
/// 
/// 
class GLGTPushButtonForm : public GLGTStringBoxForm {

    // vpeB ****************************************
protected:

    GLGTColor4<unsigned char> focusedDefaultStringColor; ///tH[JXꂽƂ̃ftHg̕F

    GLGTColor4<unsigned char> pushedRectColor; ///< ꂽƂ̃{^̐F


    bool beingPushed; ///< Ă
    bool beingFocused; ///< tH[JXĂ

    bool pushed; ///< ꂽ
    bool focused; ///< tH[JXꂽ
    bool pushedAndReleased; ///< ėꂽ
    
    // C^[tFCX ****************************************
public:

    //////////////////////////////////////////////////
    /// \brief {^ꂽ
    ///
    /// tH[ŉꂽꍇB
    /// <BR>
    /// ̊֐Ă΂ꂽƂɓŃtONA
    ///
    bool isPushed(void) {
        bool ret = pushed;
        pushed= false;
        return ret;
    }

    //////////////////////////////////////////////////
    /// \brief {^tH[JXꂽ
    ///
    /// tH[Ƀ}EXꍇB
    /// <BR>
    /// ̊֐Ă΂ꂽƂɓŃtONA
    ///
    bool isFocused(void) {
        bool ret = focused;

        if(isMouseCursorInside() == true) {
            focused = true;
        }
        else {
            focused = false;
        }

        return ret;
    }

    //////////////////////////////////////////////////
    /// \brief {^ėꂽ
    ///
    /// tH[ŉAtH[ŗꂽꍇB
    /// <BR>
    /// ̊֐Ă΂ꂽƂɓŃtONA
    ///
    bool isPushedAndReleased(void) {
        bool ret = pushedAndReleased;
        pushedAndReleased = false;
        return ret;
    }



    //////////////////////////////////////////////////
    /// \brief setFocusedDefaultStringColor
    void setFocusedDefaultStringColor(GLGTColor4<unsigned char>& in_color) {
        focusedDefaultStringColor = in_color;
    }

    //////////////////////////////////////////////////
    /// \brief setPushedRectColor
    void setPushedRectColor(GLGTColor4<unsigned char>& in_color) {
        pushedRectColor = in_color;
    }



    //////////////////////////////////////////////////
    /// \brief [Cxg] tH[쐬Ƃ
    void onCreateForm(void);

    //////////////////////////////////////////////////
    /// \brief [Cxg] }EX{^ꂽƂ
    void onMouseDown(GLGTMouseButton button, int x, int y, int last_x, int last_y) {
        if((button == MOUSE_LEFTBUTTON)&&(isMouseCursorInside() == true)) {
            setBeingPushed(true);
            pushed = true;
        }
        else {
            setBeingPushed(false);
        }
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] }EX{^ꂽƂ
    void onMouseUp(GLGTMouseButton button, int x, int y, int last_x, int last_y) {
        if((button == MOUSE_LEFTBUTTON)&&(isMouseCursorInside() == true)&&(beingPushed == true)) {
            pushedAndReleased = true;
        }
        setBeingPushed(false);
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] }EXꂽƂ
    void onMouseMove(int x, int y, int last_x, int last_y) {
        if(isMouseCursorInside() == true) {
            focused = true;
            setBeingFocused(true);
        }
        else {
            setBeingFocused(false);
        }
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] `悷悤wꂽƂ
    void onDraw(void) {
        GLGTStringBoxForm::onDraw();
    }


    // J ****************************************
protected:
    //////////////////////////////////////////////////
    /// \brief 
    void setBeingFocused(bool in_flag) {
        static GLGTColor4<unsigned char> defaultStringColor_backup(defaultStringColor);

        if      ((in_flag == true )&&(beingFocused == false)) {
            defaultStringColor_backup = defaultStringColor;
            defaultStringColor = focusedDefaultStringColor;
            beingFocused = true;
        }
        else if ((in_flag == false)&&(beingFocused == true )) {
            defaultStringColor = defaultStringColor_backup;
            beingFocused = false;
        }



    }

    //////////////////////////////////////////////////
    /// \brief 
    void setBeingPushed(bool in_flag) {
        static GLGTColor4<unsigned char> rectColor_backup(rectColor);

        if      ((in_flag == true )&&(beingPushed == false)) {
            rectColor_backup = rectColor;
            rectColor = pushedRectColor;
            beingPushed = true;
        }
        else if ((in_flag == false)&&(beingPushed == true )) {
            rectColor = rectColor_backup;
            beingPushed = false;
        }


    }


};


#endif
