//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTSCENE_H_
#define _GLGTSCENE_H_

#include <vector>

#include "GLGTBase.h"
#include "GLGTFlagArray.h"
#include "GLGTProfiler.h"
#include "GLGTKey.h"
#include "GLGTMouse.h"
#include "GLGTWindowProperty.h"
#include "GLGTForm.h"

#define MAXCHILDSCENESIZE 128 //qScene̍ő吔
#define OWNSCENE MAXCHILDSCENESIZE //Scenew



class GLGTScene;

//********************************************************************
/// \brief V[ǗNX
/// 
/// ܂܂ȃV[̊ƂȂNXB
/// <BR>
/// eventFilter̓Cxg󂯎Ƃɏs(Cxg֐Ăяo)Cxg
/// <BR>
/// eventHooktrue̍ڂ́A܂eV[Ŏ󂯎肻̂ƎV[Ŏ󂯎B
/// eV[eventFilterł̍ڂfalsȅꍇ͎󂯎Ă͍sȂB
/// <BR>
/// colorDepth̓tXN[ɂ̂ݔfB
/// 
/// 
class GLGTScene {
protected:

    GLGTWindowPropertyPtr windowProperty;           ///< EChE֘ÃvpeB

    unsigned int sceneIndex;                        ///< eV[猩CfbNX
    unsigned int activeScene;                       ///< ݃ANeBuȃV[(IuWFNgANeBuȏꍇOWNSCENE)
    bool sceneDone;                                 ///< V[𔲂tO
    std::vector<GLGTScene*> childScene;             ///< qSceneIuWFNgւ̃|C^

    std::vector<GLGTForm*> forms;                   ///< ێtH[IuWFNgւ̃|C^

public:
    GLGTFlagArray<GLGTEventType> eventFilter;       ///< 󂯎Cxg(RXgN^őStrue)
    GLGTFlagArray<GLGTEventType> eventHook;         ///< eV[ł󂯎Cxg(RXgN^őSfalse)




public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTScene(void);

    //////////////////////////////////////////////////
    /// \brief fXgN^
    virtual ~GLGTScene();

    //////////////////////////////////////////////////
    /// \brief V[͏Iǂ
    ///
    /// qV[ItO𗧂Ăǂ𒲂ׂ邽߂
    /// eV[ĂяoB
    ///
    /// \retval true I
    /// \retval false ܂ANeBu
    bool isSceneDone(void) {return sceneDone;}

    //////////////////////////////////////////////////
    /// \brief V[ANeBuǂ
    ///
    ///
    ///
    /// \retval true ANeBu
    /// \retval false ANeBułȂ
    bool isActive(void) {
        return (activeScene == OWNSCENE);
    }

    //////////////////////////////////////////////////
    /// \brief V[ANeBuǂׂB
    ///
    ///
    ///
    /// \param in_scene ANeBuǂׂV[̃|C^
    /// \retval true ANeBu
    /// \retval false ANeBułȂ
    bool isActiveScene(GLGTScene* in_scene) {
        return (in_scene->getSceneIndex() == activeScene);
    }




    //////////////////////////////////////////////////
    /// \brief sceneIndexvpeBQbg
    unsigned int getSceneIndex(void) {return sceneIndex;}

    //////////////////////////////////////////////////
    /// \brief activeScenevpeBQbg
    /// \return ݃ANeBuȃV[
    unsigned int getActiveScene(void) {return activeScene;}

    //////////////////////////////////////////////////
    /// \brief ݃ANeBuȃV[̃|C^𓾂
    /// \return ݃ANeBuȃV[̃|C^
    GLGTScene* getActiveScenePtr(void) {return childScene[activeScene];}








    //////////////////////////////////////////////////
    /// \brief GLGTChildScene\̂ĎqSceneǉ
    ///
    /// \<typename T\>childSceneɓV[̌^w肷B (GLGTScenepĂNX̂)
    /// <BR>
    /// : pushChildScene<MyScene>();
    ///
    /// \return ǉqV[̃|C^
    /// \retval NULL ǉs(ȏǉłȂꍇȂ)
    template<typename T> T* pushChildScene(void) {
        if(childScene.size() >= MAXCHILDSCENESIZE) {return NULL;}
        //qV[ǉ
        T* temp_scene = new T;
        childScene.push_back((GLGTScene*)temp_scene); 
        //
        ((GLGTScene*)temp_scene)->windowProperty = windowProperty;
        ((GLGTScene*)temp_scene)->sceneIndex = (unsigned int)childScene.size()-1;
        ((GLGTScene*)temp_scene)->onCreateScene();

        return temp_scene;

    }

    //////////////////////////////////////////////////
    /// \brief Ō̎qScene폜
    /// \return 폜qScenẽCfbNX (̏ꍇ0Ԃ)
    unsigned int popChildScene(void);

    //////////////////////////////////////////////////
    /// \brief ANeBuȃV[ς
    /// \param in_activescene ANeBuɂV[̃CfbNX
    void activateScene(unsigned int in_activescene = OWNSCENE);

    //////////////////////////////////////////////////
    /// \brief ANeBuȃV[ς
    /// \param in_activescene_ptr ANeBuɂV[̃|C^
    void activateScene(GLGTScene* in_activescene_ptr);

    //////////////////////////////////////////////////
    /// \brief V[𔲂ĐeV[ɖ߂
    ///
    /// qV[ANeBuȏꍇ́AqV[leaveSceneĂюV[ANeBuɂȂ܂Ń[v܂킷B
    ///
    ///
    /// GLGTMainWindow̏ꍇruñ[v𔲂
    void leaveScene(void) {
        if(isActive() == false) {
            getActiveScenePtr()->leaveScene();
        }
        sceneDone = true;
    }


    //////////////////////////////////////////////////
    /// \brief tH[ǉ
    ///
    /// \<typename T\>̓tH[̌^w肷B (GLGTFormpĂNX̂)<BR>
    /// : pushForm<MyForm>();
    ///
    /// \return ǉtH[̃|C^
    /// \retval NULL ǉs(ȏǉłȂꍇ)
    template<typename T> T* pushForm(void) {
        if(forms.size() >= MAXFORMSIZE) {return NULL;}

        //tH[ǉ
        T* temp_form = new T;
        forms.push_back((GLGTForm*)temp_form);
        //
        temp_form->GLGTForm::windowProperty = windowProperty;
        temp_form->GLGTForm::formIndex = (unsigned int)forms.size()-1;
        temp_form->onCreateForm();

        return temp_form;
    }

    //////////////////////////////////////////////////
    /// \brief Ō̃tH[폜B
    /// 
    /// \return 폜tH[̃CfbNX (̏ꍇ0Ԃ)
    unsigned int popForm(void);

    //////////////////////////////////////////////////
    /// \brief w肳ꂽtH[`悷B
    void drawForm(unsigned int index) {
        GLGTASSERT(index < forms.size());
        if(forms[index]->eventFilter[GLGTEVENT_DRAW]) {
            unsigned int prof_drawform;
            if(GLGTProfiler.profilerMode[GLGTPROFILERMODE_ENABLE] == true) {
                prof_drawform = GLGTProfiler.beginSampleProfiling("[GLGT]Draw Form");//Tṽvt@CJn
                forms[index]->onDraw();
                GLGTProfiler.endSampleProfiling(prof_drawform);//Tṽvt@CI
            }
            else {
                forms[index]->onDraw();
            }
        }
    }

    //////////////////////////////////////////////////
    /// \brief SẴtH[`悷B
    void drawAllForm(void) {
        for(unsigned int i = 0; i<forms.size(); i++) {
            drawForm(i);
        }
    }



    //////////////////////////////////////////////////
    /// \brief }EXJ[\ړ(W̓EBhENCAg̈̍W)
    /// \param x }EXxW
    /// \param y }EXyW
    ///
    /// warpMouseCursorłonMouseMove͌ĂяoȂ
    /// [vɃ}EX𓮂ꍇonMouseMoveőĂlast_x,last_y
    /// [v̍WɂȂĂ
    void warpMouseCursor(int x, int y) {
        POINT mp;
        mp.x = x;
        mp.y = y;
        //NCAgWXN[Wɕϊ
        ClientToScreen(windowProperty.ptr->hWnd,&mp);
        //J[\ړ
        SetCursorPos(mp.x, mp.y);
        windowProperty.ptr->mouseCursor.position.x = x;
        windowProperty.ptr->mouseCursor.position.y = y;
        (windowProperty.ptr->mainWindowFlag)[GLGTMAINWINDOWFLAG_MOUSEWARPED] = true;

    }

    //////////////////////////////////////////////////
    /// \brief }EXJ[\\
    ///
    /// }EXJ[\ƕ`͂ƑȂB
    ///
    /// \param in_flag J[\̕\/\
    ///                - GLGT_ENABLE \
    ///                - GLGT_DISABLE \ɂ
    ///                - GLGT_TOGGLE ؂ւ
    void changeMouseCursorVisible(GLGTEnum in_flag);

    //////////////////////////////////////////////////
    /// \brief JX^}EXJ[\gp邩
    ///
    /// 
    ///
    /// \param in_flag JX^}EXJ[\gp/gpȂ
    ///                - GLGT_ENABLE gp
    ///                - GLGT_DISABLE gpȂ
    ///                - GLGT_TOGGLE ؂ւ
    void changeCustomMouseCursor(GLGTEnum in_flag);

    //////////////////////////////////////////////////
    /// \brief EBhẼTCYύX
    /// \param width EBhE̕
    /// \param height EBhE̍
    void resizeWindow(int width, int height);

    //////////////////////////////////////////////////
    /// \brief EBhËʒuύX
    /// \param x xW
    /// \param y yW
    void moveWindow(int x, int y);

    //////////////////////////////////////////////////
    /// \brief obt@ւ (+ }EXJ[\`)
    ///
    /// JX^}EXJ[\gpꍇ͕`悷B
    ///
    void swapBuffers(void) {
        if((windowProperty.ptr->mainWindowFlag[GLGTMAINWINDOWFLAG_MOUSECURSORVISIBLE] == true)&&
            (windowProperty.ptr->mainWindowFlag[GLGTMAINWINDOWFLAG_CUSTOMMOUSECURSOR] == true))
        {
            (windowProperty.ptr->mouseCursor).drawMouseCursor(
                windowProperty.ptr->windowRect.dimension.x,windowProperty.ptr->windowRect.dimension.y);
        }

        static unsigned int prof_swapbuffers;
        if(GLGTProfiler.profilerMode[GLGTPROFILERMODE_ENABLE] == true) {
            prof_swapbuffers = GLGTProfiler.beginSampleProfiling("[GLGT]Swap Buffers");//Tṽvt@CJn
            SwapBuffers(windowProperty.ptr->hDC);
            GLGTProfiler.endSampleProfiling(prof_swapbuffers);//Tṽvt@CI
        }
        else {
            SwapBuffers(windowProperty.ptr->hDC);
        }
    }






    //////////////////////////////////////////////////
    /// \brief [Cxg蓖] 
    void assignEnterSceneEvent(unsigned int lastscene) {
        //SceneANeBûƂ
        if(activeScene == OWNSCENE) {
            //Cxg邩
            if(eventFilter[GLGTEVENT_ENTERSCENE]) {
                onEnterScene(lastscene);
            }
        }
        //qSceneANeBûƂ
        else {
            GLGTASSERT(activeScene < childScene.size());
            //ScenełCxg󂯎邩
            if(childScene[activeScene]->eventHook[GLGTEVENT_ENTERSCENE] && eventFilter[GLGTEVENT_ENTERSCENE]) {
                onEnterScene(lastscene);
            }
            //qV[ɃCxg𑗂
            childScene[activeScene]->assignEnterSceneEvent(lastscene);
            //V[𔲂邩
            if(childScene[activeScene]->isSceneDone()) {
                childScene[activeScene]->setSceneDone(false);
                activateScene();//V[ANeBuɂ
            }
        }
    }

    //////////////////////////////////////////////////
    /// \brief [Cxg蓖] 
    void assignLeaveSceneEvent(unsigned int nextscene) {
        //SceneANeBûƂ
        if(activeScene == OWNSCENE) {
            //Cxg邩
            if(eventFilter[GLGTEVENT_LEAVESCENE]) {
                onLeaveScene(nextscene);
            }
        }
        //qSceneANeBûƂ
        else {
            GLGTASSERT(activeScene < childScene.size());
            //ScenełCxg󂯎邩
            if(childScene[activeScene]->eventHook[GLGTEVENT_LEAVESCENE] && eventFilter[GLGTEVENT_LEAVESCENE]) {
                onLeaveScene(nextscene);
            }
            //qV[ɃCxg𑗂
            childScene[activeScene]->assignEnterSceneEvent(nextscene);
            //V[𔲂邩
            if(childScene[activeScene]->isSceneDone()) {
                childScene[activeScene]->setSceneDone(false);
                activateScene();//V[ANeBuɂ
            }
        }
    }

    //////////////////////////////////////////////////
    /// \brief [Cxg蓖] 
    void assignMoveWindowEvent(int x, int y) {
        //SceneANeBûƂ
        if(activeScene == OWNSCENE) {
            //Cxg邩
            if(eventFilter[GLGTEVENT_MOVEWINDOW]) {
                //tH[ɃCxg𑗂
                for(unsigned int i = 0; i < forms.size(); i++) {
                    if(forms[i]->eventFilter[GLGTEVENT_MOVEWINDOW]) {forms[i]->onMoveWindow(x,y);}
                }
                onMoveWindow(x,y);
            }
        }
        //qSceneANeBûƂ
        else {
            GLGTASSERT(activeScene < childScene.size());
            //ScenełCxg󂯎邩
            if(childScene[activeScene]->eventHook[GLGTEVENT_MOVEWINDOW] && eventFilter[GLGTEVENT_MOVEWINDOW]) {
                //tH[ɃCxg𑗂
                for(unsigned int i = 0; i < forms.size(); i++) {
                    if(forms[i]->eventFilter[GLGTEVENT_MOVEWINDOW]) {forms[i]->onMoveWindow(x,y);}
                }
                onMoveWindow(x,y);
            }
            //qV[ɃCxg𑗂
            childScene[activeScene]->assignMoveWindowEvent(x,y);
            //V[𔲂邩
            if(childScene[activeScene]->isSceneDone()) {
                childScene[activeScene]->setSceneDone(false);
                activateScene();//V[ANeBuɂ
            }
        }

    }

    //////////////////////////////////////////////////
    /// \brief [Cxg蓖] 
    void assignResizeWindowEvent(unsigned int width, unsigned int height) {
        //SceneANeBûƂ
        if(activeScene == OWNSCENE) {
            //Cxg邩
            if(eventFilter[GLGTEVENT_RESIZEWINDOW]) {
                //tH[ɃCxg𑗂
                for(unsigned int i = 0; i < forms.size(); i++) {
                    if(forms[i]->eventFilter[GLGTEVENT_RESIZEWINDOW]) {forms[i]->onResizeWindow(width,height);}
                }
                onResizeWindow(width,height);
            }
        }
        //qSceneANeBûƂ
        else {
            GLGTASSERT(activeScene < childScene.size());
            //ScenełCxg󂯎邩
            if(childScene[activeScene]->eventHook[GLGTEVENT_RESIZEWINDOW] && eventFilter[GLGTEVENT_RESIZEWINDOW]) {
                //tH[ɃCxg𑗂
                for(unsigned int i = 0; i < forms.size(); i++) {
                    if(forms[i]->eventFilter[GLGTEVENT_RESIZEWINDOW]) {forms[i]->onResizeWindow(width,height);}
                }
                onResizeWindow(width,height);
            }
            //qV[ɃCxg𑗂
            childScene[activeScene]->assignResizeWindowEvent(width,height);
            //V[𔲂邩
            if(childScene[activeScene]->isSceneDone()) {
                childScene[activeScene]->setSceneDone(false);
                activateScene();//V[ANeBuɂ
            }
        }

    }

    //////////////////////////////////////////////////
    /// \brief [Cxg蓖] 
    void assignKeyDownEvent(GLGTKeyCode keycode, bool repeat, char keychar) {
        //SceneANeBûƂ
        if(activeScene == OWNSCENE) {
            //Cxg邩
            if(eventFilter[GLGTEVENT_KEYDOWN]) {
                //tH[ɃCxg𑗂
                for(unsigned int i = 0; i < forms.size(); i++) {
                    if(forms[i]->eventFilter[GLGTEVENT_KEYDOWN]) {forms[i]->onKeyDown(keycode, repeat, keychar);}
                }
                onKeyDown(keycode, repeat, keychar);
            }
        }
        //qSceneANeBûƂ
        else {
            GLGTASSERT(activeScene < childScene.size());
            //ScenełCxg󂯎邩
            if(childScene[activeScene]->eventHook[GLGTEVENT_KEYDOWN] && eventFilter[GLGTEVENT_KEYDOWN]) {
                //tH[ɃCxg𑗂
                for(unsigned int i = 0; i < forms.size(); i++) {
                    if(forms[i]->eventFilter[GLGTEVENT_KEYDOWN]) {forms[i]->onKeyDown(keycode, repeat, keychar);}
                }
                onKeyDown(keycode, repeat, keychar);
            }
            //qV[ɃCxg𑗂
            childScene[activeScene]->assignKeyDownEvent(keycode, repeat, keychar);
            //V[𔲂邩
            if(childScene[activeScene]->isSceneDone()) {
                childScene[activeScene]->setSceneDone(false);
                activateScene();//V[ANeBuɂ
            }
        }

    }

    //////////////////////////////////////////////////
    /// \brief [Cxg蓖] 
    void assignKeyUpEvent(GLGTKeyCode keycode, bool repeat, char keychar) {
        //SceneANeBûƂ
        if(activeScene == OWNSCENE) {
            //Cxg邩
            if(eventFilter[GLGTEVENT_KEYUP]) {
                //tH[ɃCxg𑗂
                for(unsigned int i = 0; i < forms.size(); i++) {
                    if(forms[i]->eventFilter[GLGTEVENT_KEYUP]) {forms[i]->onKeyUp(keycode, repeat, keychar);}
                }
                onKeyUp(keycode, repeat, keychar);
            }
        }
        //qSceneANeBûƂ
        else {
            GLGTASSERT(activeScene < childScene.size());
            //ScenełCxg󂯎邩
            if(childScene[activeScene]->eventHook[GLGTEVENT_KEYUP] && eventFilter[GLGTEVENT_KEYUP]) {
                //tH[ɃCxg𑗂
                for(unsigned int i = 0; i < forms.size(); i++) {
                    if(forms[i]->eventFilter[GLGTEVENT_KEYUP]) {forms[i]->onKeyUp(keycode, repeat, keychar);}
                }
                onKeyUp(keycode, repeat, keychar);
            }
            //qV[ɃCxg𑗂
            childScene[activeScene]->assignKeyUpEvent(keycode, repeat, keychar);
            //V[𔲂邩
            if(childScene[activeScene]->isSceneDone()) {
                childScene[activeScene]->setSceneDone(false);
                activateScene();//V[ANeBuɂ
            }
        }

    }

    //////////////////////////////////////////////////
    /// \brief [Cxg蓖] 
    void assignMouseDownEvent(GLGTMouseButton button, int x, int y, int last_x, int last_y) {
        //SceneANeBûƂ
        if(activeScene == OWNSCENE) {
            //Cxg邩
            if(eventFilter[GLGTEVENT_MOUSEDOWN]) {
                //tH[ɃCxg𑗂
                for(unsigned int i = 0; i < forms.size(); i++) {
                    if(forms[i]->eventFilter[GLGTEVENT_MOUSEDOWN]) {forms[i]->onMouseDown(button, x, y, last_x, last_y);}
                }
                onMouseDown(button, x, y, last_x, last_y);
            }
        }
        //qSceneANeBûƂ
        else {
            GLGTASSERT(activeScene < childScene.size());
            //ScenełCxg󂯎邩
            if(childScene[activeScene]->eventHook[GLGTEVENT_MOUSEDOWN] && eventFilter[GLGTEVENT_MOUSEDOWN]) {
                //tH[ɃCxg𑗂
                for(unsigned int i = 0; i < forms.size(); i++) {
                    if(forms[i]->eventFilter[GLGTEVENT_MOUSEDOWN]) {forms[i]->onMouseDown(button, x, y, last_x, last_y);}
                }
                onMouseDown(button, x, y, last_x, last_y);
            }
            //qV[ɃCxg𑗂
            childScene[activeScene]->assignMouseDownEvent(button, x, y, last_x, last_y);
            //V[𔲂邩
            if(childScene[activeScene]->isSceneDone()) {
                childScene[activeScene]->setSceneDone(false);
                activateScene();//V[ANeBuɂ
            }
        }

    }

    //////////////////////////////////////////////////
    /// \brief [Cxg蓖] 
    void assignMouseUpEvent(GLGTMouseButton button, int x, int y, int last_x, int last_y) {
        //SceneANeBûƂ
        if(activeScene == OWNSCENE) {
            //Cxg邩
            if(eventFilter[GLGTEVENT_MOUSEUP]) {
                //tH[ɃCxg𑗂
                for(unsigned int i = 0; i < forms.size(); i++) {
                    if(forms[i]->eventFilter[GLGTEVENT_MOUSEUP]) {forms[i]->onMouseUp(button, x, y, last_x, last_y);}
                }
                onMouseUp(button, x, y, last_x, last_y);
            }
        }
        //qSceneANeBûƂ
        else {
            GLGTASSERT(activeScene < childScene.size());
            //ScenełCxg󂯎邩
            if(childScene[activeScene]->eventHook[GLGTEVENT_MOUSEUP] && eventFilter[GLGTEVENT_MOUSEUP]) {
                //tH[ɃCxg𑗂
                for(unsigned int i = 0; i < forms.size(); i++) {
                    if(forms[i]->eventFilter[GLGTEVENT_MOUSEUP]) {forms[i]->onMouseUp(button, x, y, last_x, last_y);}
                }
                onMouseUp(button, x, y, last_x, last_y);
            }
            //qV[ɃCxg𑗂
            childScene[activeScene]->assignMouseUpEvent(button, x, y, last_x, last_y);
            //V[𔲂邩
            if(childScene[activeScene]->isSceneDone()) {
                childScene[activeScene]->setSceneDone(false);
                activateScene();//V[ANeBuɂ
            }
        }

    }

    //////////////////////////////////////////////////
    /// \brief [Cxg蓖] 
    void assignMouseMoveEvent(int x, int y, int last_x, int last_y) {
        //SceneANeBûƂ
        if(activeScene == OWNSCENE) {
            //Cxg邩
            if(eventFilter[GLGTEVENT_MOUSEMOVE]) {
                //tH[ɃCxg𑗂
                for(unsigned int i = 0; i < forms.size(); i++) {
                    if(forms[i]->eventFilter[GLGTEVENT_MOUSEMOVE]) {forms[i]->onMouseMove(x, y, last_x, last_y);}
                }
                onMouseMove(x, y, last_x, last_y);
            }
        }
        //qSceneANeBûƂ
        else {
            GLGTASSERT(activeScene < childScene.size());
            //ScenełCxg󂯎邩
            if(childScene[activeScene]->eventHook[GLGTEVENT_MOUSEMOVE] && eventFilter[GLGTEVENT_MOUSEMOVE]) {
                //tH[ɃCxg𑗂
                for(unsigned int i = 0; i < forms.size(); i++) {
                    if(forms[i]->eventFilter[GLGTEVENT_MOUSEMOVE]) {forms[i]->onMouseMove(x, y, last_x, last_y);}
                }
                onMouseMove(x, y, last_x, last_y);
            }
            //qV[ɃCxg𑗂
            childScene[activeScene]->assignMouseMoveEvent(x, y, last_x, last_y);
            //V[𔲂邩
            if(childScene[activeScene]->isSceneDone()) {
                childScene[activeScene]->setSceneDone(false);
                activateScene();//V[ANeBuɂ
            }
        }
    }

    //////////////////////////////////////////////////
    /// \brief [Cxg蓖] 
    void assignIdleEvent(void) {
        //SceneANeBûƂ
        if(activeScene == OWNSCENE){
            //Cxg邩
            if(eventFilter[GLGTEVENT_IDLE]) {
                onIdle();
                if((windowProperty.ptr->mainWindowMode)[GLGTMAINWINDOWMODE_AUTODRAWALLFORM] == true) {
                    drawAllForm();
                }
            }
        }
        //qSceneANeBûƂ
        else {
            GLGTASSERT(activeScene < childScene.size());
            //ScenełCxg󂯎邩
            if(childScene[activeScene]->eventHook[GLGTEVENT_IDLE] &&  eventFilter[GLGTEVENT_IDLE]) {
                onIdle();
                if((windowProperty.ptr->mainWindowMode)[GLGTMAINWINDOWMODE_AUTODRAWALLFORM] == true) {
                    drawAllForm();
                }
            }
            //qV[ɃCxg𑗂
            childScene[activeScene]->assignIdleEvent(); //qSceneɃCxg𑗂
            //V[𔲂邩
            if(childScene[activeScene]->isSceneDone()) {
                childScene[activeScene]->setSceneDone(false);
                activateScene();//V[ANeBuɂ
            }
        }
    }






    //////////////////////////////////////////////////
    /// \brief [Cxg] V[ǉꂽƂ(addChildScene)
    ///
    ///  GLGTMainWindow̏ꍇAC[vɓ钼ȌB(runĂ΂OpenGL̏I)
    virtual void onCreateScene(void) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] V[jƂ
    ///
    ///  GLGTMainWindow̏ꍇAC[voB
    virtual void onDestroyScene(void) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] SceneANeBuɂȂƂ̏
    /// \param lastscene OɃANeBuV[
    virtual void onEnterScene(unsigned int lastscene) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] SceneANeBułȂȂƂ̏
    /// \param nextscene ɃANeBuɂȂV[
    virtual void onLeaveScene(unsigned int nextscene) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] EChËʒuύXꂽƂ
    /// \param x xW
    /// \param y yW
    virtual void onMoveWindow(int x, int y) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] EChẼTCYύXꂽƂ
    /// \param width 
    /// \param height 
    virtual void onResizeWindow(unsigned int width, unsigned int height) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] L[{[hꂽƂ
    /// \param keycode L[R[h
    /// \param repeat s[gȂtrue
    /// \param keychar ̏ꍇ͕BȊONULL
    ///
    /// ftHgłESCŏI
    virtual void onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar) {
        if(keycode == KEY_ESCAPE) {leaveScene();}
    }
    //////////////////////////////////////////////////
    // onKeyUp ( <L[R[h>, <s[gȂtrue>, <̏ꍇ͕BȊONULL> )
    /// \brief [Cxg] L[{[hꂽƂ
    /// \param keycode L[R[h
    /// \param repeat false
    /// \param keychar ̏ꍇ͕BȊONULL
    virtual void onKeyUp(GLGTKeyCode keycode, bool repeat, char keychar) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] }EX{^ꂽƂ
    ///
    /// last_x,last_y̓{^ƂɋLĂB
    /// Ōɂ̃{^(UP or DOWN)ꂽƂ̍WĂB
    ///
    /// \param button }EX{^
    /// \param x xW
    /// \param y yW
    /// \param last_x OxW
    /// \param last_y OyW
    virtual void onMouseDown(GLGTMouseButton button, int x, int y, int last_x, int last_y) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] }EX{^ꂽƂ
    ///
    /// last_x,last_y̓{^ƂɋLĂB
    /// Ōɂ̃{^(UP or DOWN)ꂽƂ̍WĂB
    ///
    /// \param button }EX{^
    /// \param x xW
    /// \param y yW
    /// \param last_x OxW
    /// \param last_y OyW
    virtual void onMouseUp(GLGTMouseButton button, int x, int y, int last_x, int last_y) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] }EXꂽƂ
    /// \param x xW
    /// \param y yW
    /// \param last_x OxW
    /// \param last_y OyW
    virtual void onMouseMove(int x, int y, int last_x, int last_y) {
    }
    //////////////////////////////////////////////////
    /// \brief [Cxg] ACh̏
    virtual void onIdle(void) {
    }




    // J ****************************************
protected:
    //////////////////////////////////////////////////
    /// \brief sceneDonevpeBZbg
    /// \param in_scenedone ZbgsceneDone
    ///
    /// \attention V[𔲂Ƃ͂ł͂ȂleaveScenegׂB
    void setSceneDone(bool in_scenedone) {sceneDone = in_scenedone;}






};






#endif
