//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTSTRINGBOX_H_
#define _GLGTSTRINGBOX_H_

#include "GLGTBase.h"
#include "GLGTFlagArray.h"
#include "GLGTFontRenderer.h"
#include "GLGTRectBox.h"
#include "GLGTColor.h"

#define STRINGBOX_MAXPRINTFMT 2048 ///< printFmtł̐̕

//********************************************************************
/// \brief GLGTStringBox̃[h
/// 
enum GLGTStringBoxMode {
    GLGTSTRINGBOXMODE_BOUNDINGBOX, ///< oEfBO{bNX`悷邩

    STRINGBOXMODE_LAST
} ;


//********************************************************************
/// \brief GLGTStringBox̃tO
/// 
enum GLGTStringBoxFlag {
    STRINGBOXFLAG_RIGHTADJUST, ///< E񂹂ɂ邩(falseȂ獶)
    STRINGBOXFLAG_CENTERING, ///< Z^O邩(trueȂSTRINGBOXMODE_RIGHTADJUST͖)

    STRINGBOXFLAG_LAST
} ;



//********************************************************************
/// \brief s̃eLXg{bNX\B
/// 
/// oEfBO{bNXGLGTRectBox
/// 
/// 
class GLGTStringBox : public GLGTRectBox {

    // vpeB ****************************************
public:
    GLGTFlagArray<GLGTStringBoxMode> stringBoxMode; ///< [h
protected:
    const GLGTRectEXT* ptrStringBoxRect; ///<{bNẌʒuE傫
    GLGTFontString fontString; ///< ێ
    GLGTColor4<unsigned char> defaultStringColor; ///< ftHg̐̕F

    unsigned int scale;///< tHg̃XP[(0傫Ȃ΂ȂȂ)

    int margin;// ](EE񂹂̂ƂɊ񂹂)
    
    GLGTVector2<int> stringPosition; ///< ̍̈ʒu
    
    GLGTFlagArray<GLGTStringBoxFlag> stringBoxFlag; ///< tO
    
    
    
    // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTStringBox(const GLGTRectEXT* in_rect);
    
    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTStringBox();
        

    //////////////////////////////////////////////////
    /// \brief t
    ///
    /// tŃeLXg͂BgprintfƓ
    void printFmt(char* fmt, ...);

        
    //////////////////////////////////////////////////
    /// \brief Zbg(u)
    void setString(GLGTFontString& in_fstr) {
        clearString();
        fontString = in_fstr;   
        recalcStringPosition();
    }
        
    //////////////////////////////////////////////////
    /// \brief Zbg(u)
    void setString(std::string& in_str) {
        clearString();
        fontString.stringBuffer = in_str;      
        recalcStringPosition();
    }
        
    //////////////////////////////////////////////////
    /// \brief 擪̐FƕZbg(u)
    void setString(std::string& in_str,GLGTColor4<unsigned char>& in_color) {
        clearString();
        fontString.stringBuffer = in_str;
        setStringColor(in_color);
        recalcStringPosition();
    }
        
    //////////////////////////////////////////////////
    /// \brief 擪̐FƕZbg(u)
    void setString(std::string& in_str, unsigned char r, unsigned char g, unsigned char b, unsigned char a) {
        clearString();
        fontString.stringBuffer = in_str;
        setStringColor(r,g,b,a);
        recalcStringPosition();
    }
        
    //////////////////////////////////////////////////
    /// \brief FZbgB
    ///
    /// 
    /// ʒuɂłɐFZbgĂꍇ͒u
    /// 
    void setStringColor(GLGTColor4<unsigned char>& in_color);
    //////////////////////////////////////////////////
    /// \brief FZbgB
    ///
    /// 
    /// ʒuɂłɐFZbgĂꍇ͒u
    /// 
    void setStringColor(unsigned char r, unsigned char g, unsigned char b, unsigned char a);


    //////////////////////////////////////////////////
    /// \brief Z^Oĕ\B
    void centerString(void) {
        stringBoxFlag[STRINGBOXFLAG_CENTERING] = true;
        recalcStringPosition();
    }
    //////////////////////////////////////////////////
    /// \brief 񂹂ĕ\B
    void adjustStringLeft(void) {
        stringBoxFlag[STRINGBOXFLAG_RIGHTADJUST] = false;
        stringBoxFlag[STRINGBOXFLAG_CENTERING] = false;
        recalcStringPosition();
    }
    //////////////////////////////////////////////////
    /// \brief E񂹂ĕ\B
    void adjustStringRight(void) {
        stringBoxFlag[STRINGBOXFLAG_RIGHTADJUST] = true;
        stringBoxFlag[STRINGBOXFLAG_CENTERING] = false;
        recalcStringPosition();
    }
    
    //////////////////////////////////////////////////
    /// \brief NA
    ///
    /// AFNA
    void clearString(void);

    //////////////////////////////////////////////////
    /// \brief Ō̈ꕶ폜
    ///
    void backspace(void) {
        std::string::size_type  strsize = fontString.stringBuffer.size();
        if(strsize > 0) {
            fontString.stringBuffer.erase(strsize-1,1);
        }
        recalcStringPosition();
    }



    //////////////////////////////////////////////////
    /// \brief w肵{bNX̍œKȃTCYvZB
    ///
    /// 
    /// 
    GLGTVector2<unsigned int> calcOptimumDimension(unsigned int charcount_x, unsigned int in_margin, unsigned int in_fontscale)
    {
        GLGTVector2<unsigned int> ret;
        ret.x = GLGTFontRenderer.getFontWidth() *in_fontscale*charcount_x + in_margin*2;
        ret.y = GLGTFontRenderer.getFontHeight()*in_fontscale             + in_margin*2;

        return ret;
    }



    //////////////////////////////////////////////////
    /// \brief ̍̈ʒuČvZB
    ///
    /// {bNXړETCYꂽƂȂ
    /// 
    void recalcStringPosition(void);



    //////////////////////////////////////////////////
    /// \brief {bNX`
    void drawStringBox(unsigned int projectionwidth, unsigned int projectionheight);


    // getter/setter ****************************************

    //////////////////////////////////////////////////
    /// \brief getter of fontString.stringBuffer
    const std::string& getString(void) const {return fontString.stringBuffer;}

    //////////////////////////////////////////////////
    /// \brief getter of defaultStringColor
    const GLGTColor4<unsigned char>& getDefaultStringColor(void) const {
        return defaultStringColor;
    }
    //////////////////////////////////////////////////
    /// \brief setter of defaultStringColor
    void setDefaultStringColor(const GLGTColor4<unsigned char>& in_color) {
        defaultStringColor = in_color;
    }
    //////////////////////////////////////////////////
    /// \brief setter of defaultStringColor
    void setDefaultStringColor(unsigned char in_r, unsigned char in_g, unsigned char in_b, unsigned char in_a) {
        defaultStringColor.set(in_r,in_g,in_b,in_a);
    }

    //////////////////////////////////////////////////
    /// \brief setter of in_scale
    void setScale(unsigned int in_scale) {
        if(in_scale != 0) {
            scale = in_scale;
        }
    }

    //////////////////////////////////////////////////
    /// \brief setter of margin
    void setMargin(int in_mgn) {
        margin = in_mgn;
        recalcStringPosition();
    }





    // J ****************************************
protected:


private:


    
    
    
    
    

};


#endif
