//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTTEXTBOX_H_
#define _GLGTTEXTBOX_H_

#include <deque>
#include <string>
#include "GLGTBase.h"
#include "GLGTFlagArray.h"
#include "GLGTFontRenderer.h"
#include "GLGTRectBox.h"
#include "GLGTColor.h"

#define TEXTBOX_MAXPRINTFMT 2048 ///< printFmtł̐̕




//********************************************************************
/// \brief TextBox̃[h
/// 
enum GLGTTextBoxMode {
    GLGTTEXTBOXMODE_BOUNDINGBOX, ///< oEfBO{bNX`悷邩

    SIZE_GLGTTEXTBOXMODE
} ;

//********************************************************************
/// \brief eLXg{bNX\B
/// 
/// 
/// <BR>
/// gpOcreate()ĂяoȂ΂ȂȂB
/// <BR>
/// 
/// 
class GLGTTextBox : public GLGTRectBox {

protected:
    std::deque<GLGTFontString> text; ///< eLXgsێ
    GLGTColor4<unsigned char> defaultTextColor; ///< ftHg̃eLXgF

    unsigned int maxLineCount; ///< ێős(0Ȃ疳)

    unsigned int maxColumn; ///< tH[Ɏ܂s̍ő啶
    unsigned int maxRow; ///< tH[Ɏ܂ős
    unsigned int scrollCount; ///< XN[

    const GLGTRectEXT* ptrTextBoxRect; ///<{bNẌʒuE傫
    GLGTVector2<int> textPosition; ///< eLXg̍̈ʒu

    int margin; ///< oEfBO{bNX̃}[W

    unsigned int scale;///< tHg̃XP[(0傫Ȃ΂ȂȂ)

public:
    GLGTFlagArray<GLGTTextBoxMode> textBoxMode; ///< [h







public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTTextBox(const GLGTRectEXT* in_rect);

    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTTextBox();

    //////////////////////////////////////////////////
    /// \brief IuWFNg
    /// 
    /// 
    /// <BR>
    /// GLGTFontRendererꂽɌĂяoȂ΂ȂȂB
    /// 
    void init(void) {
        recalcTextPosition();
        recalcBoxCapacity();

    }


    //////////////////////////////////////////////////
    /// \brief eLXg̍s𐔂
    unsigned int getLineCount(void) {
        if((text.size() == 1)&&(text.back().stringBuffer.size() == 0)) {
            return 0;
        }

        return (unsigned int)text.size();
    }



    //////////////////////////////////////////////////
    /// \brief eLXgNA
    ///
    /// eLXgAFNA
    void clearText(void);

    //////////////////////////////////////////////////
    /// \brief 擪̍s폜
    void deleteTopLine(void);

    //////////////////////////////////////////////////
    /// \brief Ō̍s폜
    void deleteBottomLine(void);

    //////////////////////////////////////////////////
    /// \brief Ō̍s̍Ō̈ꕶ폜
    /// 
    /// Ō̍s̐擪ŌĂяoꂽꍇA
    /// ̍sIȉs̏ꍇ͍Ō̍s폜A̍s\\n폜B
    /// IȉsłȂꍇ͍Ō̍s폜A̍s̍Ō̈ꕶ폜B
    void deleteLastChar(void);

    //////////////////////////////////////////////////
    /// \brief sy[WAbvB
    void pageUp(void) {
        if(scrollCount != 0) {scrollCount--;}
    }

    //////////////////////////////////////////////////
    /// \brief sy[W_EB
    void pageDown(void) {
        if(text.size() > scrollCount) {scrollCount++;}
    }

    //////////////////////////////////////////////////
    /// \brief y[W̐擪ցB
    void pageTop(void) {scrollCount = 0;}

    //////////////////////////////////////////////////
    /// \brief y[W̍ŌցB
    /// 
    /// SĂ̍s\͈͊OɂȂB
    /// 
    void pageBottom(void) {scrollCount = (unsigned int)text.size();}

    //////////////////////////////////////////////////
    /// \brief y[W̍ŌԉɌ悤XN[B
    /// 
    /// 
    /// 
    void pageReset(void) {
        if(text.size() <= maxRow) { //SstH[͈͓Ɏ܂ꍇ
            scrollCount = 0;
        }
        else {
            scrollCount = (unsigned int)text.size() - maxRow;
        }
    }

    //////////////////////////////////////////////////
    /// \brief t
    ///
    /// tŃeLXg͂BgprintfƓ
    void printFmt(char* fmt, ...);

    //////////////////////////////////////////////////
    /// \brief FZbgB
    ///
    /// 
    /// ʒuɂłɐFZbgĂꍇ͒u
    /// 
    void setTextColor(unsigned char r, unsigned char g, unsigned char b, unsigned char a);
    //////////////////////////////////////////////////
    /// \brief FZbgB
    ///
    /// 
    /// ʒuɂłɐFZbgĂꍇ͒u
    /// 
    void setTextColor(const GLGTColor4<unsigned char>& in_color);


    //////////////////////////////////////////////////
    /// \brief w肵{bNX̍œKȃTCYvZB
    ///
    /// 
    /// 
    GLGTVector2<unsigned int> calcOptimumDimension(unsigned int charcount_x, unsigned int charcount_y,
        unsigned int in_margin, unsigned int in_fontscale)
    {
        GLGTVector2<unsigned int> ret;
        ret.x = GLGTFontRenderer.getFontWidth() *in_fontscale*charcount_x + in_margin*2;
        ret.y = GLGTFontRenderer.getFontHeight()*in_fontscale*charcount_y + in_margin*2;

        return ret;
    }



    //////////////////////////////////////////////////
    /// \brief eLXg̍̈ʒuČvZB
    ///
    /// {bNXړƂȂ
    /// 
    void recalcTextPosition(void) {
        textPosition.x = ptrTextBoxRect->position.x + margin;
        textPosition.y = ptrTextBoxRect->position.y + margin;
    }
    //////////////////////////////////////////////////
    /// \brief maxColumn,maxRowČvZB
    ///
    /// ŌarrangeTextĂяoĐ`B
    /// <BR>
    /// {bNXTCYƂȂ
    /// 
    void recalcBoxCapacity(void) {
        maxColumn = (ptrTextBoxRect->dimension.x-margin*2) / (GLGTFontRenderer.getFontWidth()*scale);
        maxRow = (ptrTextBoxRect->dimension.y-margin*2) / (GLGTFontRenderer.getFontHeight()*scale);
        arrangeText();
    }



    //////////////////////////////////////////////////
    /// \brief eLXg{bNX`
    void drawTextBox(unsigned int projectionwidth, unsigned int projectionheight);



    // getter/setter ****************************************

    //////////////////////////////////////////////////
    /// \brief getter of defaultTextColor
    const GLGTColor4<unsigned char>& getDefaultTextColor(void) const {
        return defaultTextColor;
    }
    //////////////////////////////////////////////////
    /// \brief setter of defaultTextColor
    void setDefaultTextColor(const GLGTColor4<unsigned char>& in_color) {
        defaultTextColor = in_color;
    }
    //////////////////////////////////////////////////
    /// \brief setter of defaultTextColor
    void setDefaultTextColor(unsigned char in_r, unsigned char in_g, unsigned char in_b, unsigned char in_a) {
        defaultTextColor.set(in_r,in_g,in_b,in_a);
    }

    //////////////////////////////////////////////////
    /// \brief getMaxLineCount
    unsigned int getMaxLineCount(void) const {return maxLineCount;}
    //////////////////////////////////////////////////
    /// \brief ێősZbg
    void setMaxLineCount(unsigned int in_max) {
        maxLineCount = in_max;
        //sősȉɂȂ܂Ő擪̍sĂ
        if(maxLineCount != 0) {
            while(maxLineCount < getLineCount()) {deleteTopLine();}
        }
    }

    //////////////////////////////////////////////////
    /// \brief getter of margin
    int getMargin(void) const {return margin;}
    //////////////////////////////////////////////////
    /// \brief setter of margin
    void setMargin(int m) {
        margin = m;
        recalcTextPosition();
        recalcBoxCapacity();
    }

    //////////////////////////////////////////////////
    /// \brief getter of scale
    unsigned int getScale(void) const {
        return scale;
    }
    //////////////////////////////////////////////////
    /// \brief setter of scale
    ///
    /// in_scale0ȉ̏ꍇ͖
    void setScale(unsigned int in_scale) {
        if(in_scale == 0) {return;}
        scale = in_scale;
        recalcBoxCapacity();
    }


    //////////////////////////////////////////////////
    /// \brief getter of 
    // get(void) const {}  
    //////////////////////////////////////////////////
    /// \brief setter of 
    //void set( in_) {}



    // J ****************************************
protected:
    //////////////////////////////////////////////////
    /// \brief eLXg𐮂
    ///
    /// Ss擪1sɂ܂Ƃ߂ĂarrangeBottomLineĂяoB
    /// <BR>
    /// {bNX̃TCYtHg̃XP[ύXꂽꍇȂǁB
    /// 
    void arrangeText(void);

    //////////////////////////////////////////////////
    /// \brief ŏIs𐮂
    ///
    /// ŏIssĕɎ܂悤ɂB
    /// <BR>
    /// printFmtĂ΂ꂽȂǁB
    void arrangeBottomLine(void);


private:




};




#endif
