//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************

#ifndef _GLGTTEXTUREMANAGER_H_
#define _GLGTTEXTUREMANAGER_H_

#include <vector>
#include <fstream>
#include <string>

#include "GLGTBase.h"
#include "GLGTSingleton.h"
#include "GLGTUtility.h"

#define GLGTTextureManager    GLGTTextureManager_Singleton::getSingleton()
#define ptrGLGTTextureManager    GLGTTextureManager_Singleton::getSingletonPtr()

#define GLGTDEFAULTTEXTUREDATAARRAYSIZE 128 ///< GLGTTextureManager.ptrTextureDatȁ̃TCY

//********************************************************************
/// \brief eNX`̃^Cv
/// 
/// 
/// 
/// 
enum GLGTTextureType {
    TEXTURE_UNKNOWN,
    TEXTURE_TGA
};


//********************************************************************
/// \brief eNX`̃f[^ێ\
/// 
/// 
struct GLGTTextureData {
    //unsigned int textureIndex;///< eNX`}l[W猩CfbNX
    //bool loaded; ///< ǂݍ܂Ă邩
    std::vector<unsigned char> pixels; ///< eNX`̃f[^(RGBAłȂ̂RGBA`Ŋi[)
    unsigned int width; ///< eNX`̕
    unsigned int height; ///< eNX`̍
    std::string name; ///eNX`̖O(t@C)
    GLGTTextureType type; ///< eNX`̃^Cv
    int referenceCount; ///< QƂĂ鐔


};




//********************************************************************
/// \brief eNX`NX
/// 
/// GLGTTextureManagerf[^󂯎B
/// 
/// 
class GLGTTexture {

    // vpeB ****************************************
protected:
    GLGTTextureData* ptrTextureData; ///< eNX`f[^ւ̃|C^
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTTexture(void);
    //////////////////////////////////////////////////
    /// \brief Rs[RXgN^
    GLGTTexture(const GLGTTexture& in);
    //////////////////////////////////////////////////
    /// \brief RXgN^
    explicit GLGTTexture(GLGTTextureData* in_texdata);
    
    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTTexture();



    //////////////////////////////////////////////////
    /// \brief QƂĂ邩iTextureDataNULLłȂj
    bool isReferring(void) const {
        if(ptrTextureData == NULL) {return false;}
        return true;
    }
    

    //////////////////////////////////////////////////
    /// \brief eNX`̃|C^Ԃ
    const unsigned char* getPixels(void) const {
        GLGTASSERT(ptrTextureData != NULL);
        return &(ptrTextureData->pixels[0]);
    }
    
    //////////////////////////////////////////////////
    /// \brief getWidth
    unsigned int getWidth(void) const {
        GLGTASSERT(ptrTextureData != NULL);
        return ptrTextureData->width;
    }
    
    //////////////////////////////////////////////////
    /// \brief getHeight
    unsigned int getHeight(void) const {
        GLGTASSERT(ptrTextureData != NULL);
        return ptrTextureData->height;
    }


    //////////////////////////////////////////////////
    /// \brief getName
    const std::string& getName(void) const {
        GLGTASSERT(ptrTextureData != NULL);
        return ptrTextureData->name;
    }
    
    //////////////////////////////////////////////////
    /// \brief getType
    GLGTTextureType getType(void) const {
        GLGTASSERT(ptrTextureData != NULL);
        return ptrTextureData->type;
    }


    //////////////////////////////////////////////////
    /// \brief eNX`f[^QƂB
    /// 
    /// ptrTextureDataɑQƃJEg𑝂₷B
    void refer(GLGTTextureData* in_texdata);
    
    //////////////////////////////////////////////////
    /// \brief eNX`f[^̎QƂ߂B
    /// 
    /// QƃJEg炵ptrTextureDataNULLB
    /// delete̓eNX`}l[WɔCB
    void unrefer(void);
    



    //////////////////////////////////////////////////
    /// \brief =
   GLGTTexture& operator =(const GLGTTexture& in);
    
    // J ****************************************
private:
    //////////////////////////////////////////////////
    /// \brief vpeB
    void clear(void);
    
};












//********************************************************************
/// \brief eNX`ǗVOgNX
///
/// GLGTTextureManager_SingletonGLGTInitŃRXgNgA
/// GLGTQuitŃfXgNgB<BR>
/// GLGTTextureManagerŃCX^XɃANZX (FGLGTTextureManager.loadTexture())
/// <BR>
/// TGAǂݍ݂ Interactive 3D Graphics with OpenGL <http://www.levp.de/3d/> ŌJĂ\[XR[hQlɂĂ܂B
/// 
/// 
/// 
class GLGTTextureManager_Singleton : public GLGTSingleton <GLGTTextureManager_Singleton> {

    // vpeB ****************************************
public:



protected:
    std::vector<GLGTTextureData*> ptrTextureData; ///< eNX`f[^ւ̃|C^z



private:


    // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTTextureManager_Singleton(void);
    
    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTTextureManager_Singleton();



    //////////////////////////////////////////////////
    /// \brief nameɊYeNX`f[^݂邩
    /// 
    bool isTextureExist(const std::string& in_texturename) const;
    
    //////////////////////////////////////////////////
    /// \brief nameɊYeNX`f[^QƂGLGTTextureԂB
    /// 
    /// YeNX`f[^Ȃꍇ͉QƂȂGLGTTextureԂB
    /// 
    /// \param in_texturename eNX`
    GLGTTexture getTexture(const std::string& in_texturename);
    

    //////////////////////////////////////////////////
    /// \brief VeNX`f[^[hĒǉ
    ///
    /// łɓnamẽeNX`f[^݂Ăꍇ͂̃eNX`f[^QƂGLGTTextureԂB
    /// ǉ܂̓[hɎsꍇ͉QƂȂGLGTTextureԂB
    /// 
    /// 
    /// \param in_texturename eNX`(t@C)
    /// \param type eNX`̃^Cv
    /// \return ǉeNX`f[^QƂGLGTTexture
    GLGTTexture addTexture(const std::string& in_texturename, GLGTTextureType type = TEXTURE_UNKNOWN);
    
    //////////////////////////////////////////////////
    /// \brief eNX`f[^ǉ([hȂ)
    ///
    /// ̃f[^̃Rs[쐬i[B
    /// łɓnamẽeNX`f[^݂Ăꍇ͂̃eNX`f[^QƂGLGTTextureԂB
    /// ǉɎsꍇ͉QƂȂGLGTTextureԂB
    /// 
    /// 
    ///
    /// \param in_texturedata ǉeNX`f[^
    /// \return ǉeNX`f[^QƂGLGTTexture
    GLGTTexture addTexture(const GLGTTextureData& in_texturedata);
    
    //////////////////////////////////////////////////
    /// \brief QƂĂȂeNX`f[^Sč폜
    ///
    /// 
    void deleteUnreferredData(void);
  

    //////////////////////////////////////////////////
    /// \brief t@CeNX`[h
    ///
    /// in_textureɂ̓t@CZbgĂȂ΂ȂȂ
    ///
    /// \param in_texture ZbgeNX`
    /// \retval true 
    /// \retval false s
    bool loadTexture(GLGTTextureData& in_texture);
    
    //////////////////////////////////////////////////
    /// \brief TGAt@CeNX`[h
    ///
    /// in_textureɂ̓t@CZbgĂȂ΂ȂȂ
    ///
    /// \param in_texture ZbgeNX`
    /// \retval true 
    /// \retval false s
    bool loadTGATexture(GLGTTextureData& in_texture);
        


    //////////////////////////////////////////////////
    /// \brief eNX`f[^\[Xt@Cɂɏo
    ///
    /// 
    bool outputTextureData(const GLGTTexture& in_texture) const;



    // J ****************************************
protected:
    //////////////////////////////////////////////////
    /// \brief eNX`f[^z(ptrTextureData)̖gpꏊT
    /// 
    /// z擪瑖Ėgpꏊ(NULLĂꏊ)TB
    /// gpꏊłȂĂQƂĂȂ΍폜Ă̈ʒuԂB
    /// gpꏊȂpush_backŐVɃXy[X肻̈ʒuԂB
    /// 
    /// 
    unsigned int findUnusedArraySpace(void);
        


    //////////////////////////////////////////////////
    void readData(std::ifstream &file, char* data, unsigned int size, int* err) const {
        if(!file.is_open()) {*err++;}
        else {
            unsigned int a = file.tellg();
            a+= size;
            file.read(data, size);
            unsigned int b = file.tellg();
            if(a != b) {*err++;}
        }
    }



private:
    //////////////////////////////////////////////////
    /// \brief =
    ///
    /// ȂB
    /// 
    GLGTTextureManager_Singleton& operator =(const GLGTTextureManager_Singleton& in) const {}





};











#endif
