//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTUTILITY_H_
#define _GLGTUTILITY_H_

#include <string>
#include <vector>

#include "GLGTBase.h"
#include "GLGTSingleton.h"
#include "GLGTTime.h"


#define GLGTUtility      GLGTUtility_Singleton::getSingleton()    ///< CX^XɃANZX
#define ptrGLGTUtility   GLGTUtility_Singleton::getSingletonPtr() ///< CX^X̃|C^ɃANZX

//********************************************************************
/// \brief 낢ȋ@\񋟂VOgNX
///
/// GLGTUtility_SingletonGLGTInitŃRXgNgA
/// GLGTQuitŃfXgNgB
/// <BR>
/// GLGTUtilityŃCX^XɃANZX (FGLGTUtility.)
/// <BR>
/// 
/// \par GLGTUtilitygfpsl̋ߕ
///       `悷邽тupdateFps()Ăяo悤ɂBꂪĂяoꂽ񐔂`悳ꂽ񐔂Ƃ݂ȂB
///       fpsl𓾂ɂgetFps()ĂяoB
/// 
/// ̂܂DoxygenŃhLgȂ̂ŏڂ̓\[XĂB
/// 
class GLGTUtility_Singleton : public GLGTSingleton <GLGTUtility_Singleton> {

    // vpeB ****************************************
public:



protected:
    float fps; ///< fpsl
    float lastFps; ///< Ofpsl
    unsigned int fpsInterval; ///< fpsvC^[o[ms]



private:


    // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTUtility_Singleton(void);

    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTUtility_Singleton();



    // string֘A ****************************************

    //////////////////////////////////////////////////
    /// \brief strs1s2ɒu
    /// 
    /// 
    /// 
    /// \param str Ώstring
    /// \param s1 ustring
    /// \param s2 ustring
    /// \return str
    std::string& replaceString(std::string& str, const std::string& s1, const std::string& s2) const {
        std::string::size_type n, n1 = 0;

        while ((n = str.find(s1,n1)) != std::string::npos) {
            str.replace(n,s1.size(),s2);
            n1 = n + s2.size();
        }
        return str;
    }

    //////////////////////////////////////////////////
    /// \brief string𕪉
    /// 
    /// 󔒕(Xy[XAsA^u)str𕪉AdataɊi[B
    /// <BR>
    /// _uNH[e[Vň͂܂ꂽ͈̃g[NƂ݂ȂA
    /// rɋ󔒕Ẵ_uNH[e[V܂ňstringɊi[B
    /// _uNH[e[V̋L͎̂荞܂ȂB
    /// _uNH[e[VꂸstȑI܂ŗꍇÃ_uNH[e[Vȍ~͖A
    /// falseԂB
    /// 
    /// \param data stringi[vector
    /// \param str Ώۂstring
    /// \retval true G[
    /// \retval false G[L
    bool parseString(std::vector<std::string>& data, const std::string& str) const;

    //////////////////////////////////////////////////
    /// \brief fBNg̃Zp[^ǂ
    /// 
    /// WindowsȊÕVXeŎgƂl
    /// 
    /// \param c `FbN镶
    /// \retval true fBNg̃Zp[^ł
    /// \retval fBNg̃Zp[^łȂ
    bool isDirSeparator(char c) const {
        if((c == '/')||(c == '\\'))  {return true;}
        return false;
    }

    //////////////////////////////////////////////////
    /// \brief pXtt@Ct@Ĉ݂𓾂B
    /// 
    /// 
    /// 
    /// \param filename pXtt@C
    /// \return t@C
    std::string getFileName(const std::string& filename) const {
        for(std::string::size_type i = filename.size()-1; i > 0; i--) { //璲ׂ
            if(isDirSeparator(filename[i])) {
                return filename.substr(i+1);
            }
        }
        return filename;
    }


    //////////////////////////////////////////////////
    /// \brief pXtt@CpX݂̂𓾂B
    /// 
    /// 
    /// 
    /// \param filename pXtt@C
    /// \return pX
    std::string getFilePath(const std::string& filename) const {
        for(std::string::size_type i = filename.size()-1; i > 0; i--) { //璲ׂ
            if(isDirSeparator(filename[i])) {
                return filename.substr(0,i+1);
            }
        }
        return std::string("");
    }

    //////////////////////////////////////////////////
    /// \brief (pXt)t@Cgq𓾂
    /// 
    /// 
    /// 
    /// \param filename t@C
    /// \return gq
    /// \retval \"\" gq
    std::string getFileExtensions(const std::string& filename) const {
        for(std::string::size_type i = filename.size()-2; i > 0; i--) { //璲ׂ(Ō͖̕)
            if(filename[i] == '.') { 
                return filename.substr(i+1); // '.'ȍ~̕Ԃ
            }
            if(isDirSeparator(filename[i])) { //̃fBNgɗI
                return std::string("");
            }
        }
        //擪̕(filename[0])'.'łȍ~̕񂪊gqɂ͂ȂȂB

        return std::string("");
    }

    //////////////////////////////////////////////////
    /// \brief pXA܂̓pXtt@C𕪉B
    /// 
    /// : \"c:/aaa/bbb.h\"̏ꍇA\"c:/\"\"aaa/\"\"bbb.h\"zɊi[B
    /// <BR>
    /// A/͈擾B܂擪̈ȏ/͏B
    /// 
    /// \param path fBNg/t@C̔z
    /// \param filepath pXA܂̓pXtt@C
    void parseFilePath(std::vector<std::string>& path, const std::string& filepath) const {
        path.clear();

        std::string::size_type top = 0;
        std::string::size_type filepathsize = filepath.size();
        for(std::string::size_type i = 0; i < filepathsize; i++) {
            if(isDirSeparator(filepath[i])) {
                if(top != i) {
                    path.push_back(filepath.substr(top,i-top+1));
                }
                top = i+1;
            }
        }
        //Ō̕
        if(top != filepathsize) {
            path.push_back(filepath.substr(top));
        }
    }

    //////////////////////////////////////////////////
    /// \brief Rg𓾂(Rg߂̕͏)
    ///
    /// \"ň͂܂ꂽ͖B
    /// Rg݂Ȃꍇ\"\"Ԃ
    ///
    /// \param str Ώۂ̕
    /// \param comment Rg߂̕
    std::string getComment(const std::string& str, const std::string& comment) const;


    //////////////////////////////////////////////////
    /// \brief Rg菜
    ///
    /// \"ň͂܂ꂽ͖B
    ///
    /// \param str Ώۂ̕
    /// \param comment Rg߂̕
    void removeComment(std::string& str, const std::string& comment) const;



    // fps֘A ****************************************

    //////////////////////////////////////////////////
    /// \brief fpsXV
    /// 
    /// `悷邽тɂĂяo悤ɂB
    /// 
    /// \retval true fps͍XVꂽ
    /// \retval false fps͍XVĂȂ
    bool updateFps(void) {
        static unsigned int frames = 0;
        static unsigned long lastmeasured = GLGTTime.getTime();

        frames++;
        unsigned int currenttime = GLGTTime.getTime();
        //fpsXV
        if((currenttime - lastmeasured) >= fpsInterval) {
            lastFps = fps;
            fps = 1000.0f * (float)frames / (float)(currenttime - lastmeasured);
            lastmeasured = currenttime;
            frames = 0;
            return true;
        }
        return false;
    }

    //////////////////////////////////////////////////
    /// \brief fpsl𓾂B(P:s)
    float getFps(void) {return fps;}

    //////////////////////////////////////////////////
    /// \brief 炩fpsl𓾂B(P:s)
    /// 
    /// getSmoothFps͍ŐVfpslƁȂOfpsl̕ςԂB
    float getSmoothFps(void) {return (fps+lastFps)/2;}

    //////////////////////////////////////////////////
    /// \brief fpsXVC^[o𓾂
    unsigned int getFpsInterval(void) {return fpsInterval;}


    //////////////////////////////////////////////////
    /// \brief fpsXVC^[oZbg(P:ms)
    /// 
    /// in_interval0傫ꍇ̂ݑ
    void setFpsInterval(unsigned int in_interval) {
        if(in_interval > 0) {fpsInterval = in_interval;}
    }







    // cfg֘A ****************************************

    //////////////////////////////////////////////////
    /// \brief 
    /// \param 
    /// \return 
    /// \retval 
    //void (void);

    //////////////////////////////////////////////////
    /// \brief 
    /// \param 
    /// \return 
    /// \retval 
    //void (void);



    //  ****************************************

    //////////////////////////////////////////////////
    /// \brief 
    /// \param 
    /// \return 
    /// \retval 
    //void (void);



    // J ****************************************
protected:



private:
    //////////////////////////////////////////////////
    /// \brief =
    ///
    /// ȂB
    /// 
    GLGTUtility_Singleton& operator =(const GLGTUtility_Singleton& in) const {}








};


#endif
