//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTWINDOWPROPERTY_H_
#define _GLGTWINDOWPROPERTY_H_

#include "GLGTBase.h"
#include "GLGTFlagArray.h"
#include "GLGTMath.h"
#include "GLGTMouseCursor.h"


//********************************************************************
/// \brief GLGTMainWindow̓tO
/// 
enum GLGTMainWindowFlag {
    GLGTMAINWINDOWFLAG_MOUSECURSORVISIBLE,              ///< }EXJ[\\
    GLGTMAINWINDOWFLAG_CUSTOMMOUSECURSOR,               ///< JX^}EXJ[\gp邩
    GLGTMAINWINDOWFLAG_MOUSEWARPED,                     ///< warpMouseCursorĂяoꂽ

    GLGTFLAGARRAYSIZE_GLGTMAINWINDOWFLAG
} ;



//********************************************************************
/// \brief GLGTMainWindow̃[h
/// 
enum GLGTMainWindowMode {
    GLGTMAINWINDOWMODE_AUTOSWAPBUFFERS,                 ///< C[v̍ŌŎswapBuffers()ĂԁB
    GLGTMAINWINDOWMODE_AUTODRAWALLFORM,                 ///< onIdle()̒ɎDrawAllForm()ĂԁB


    GLGTFLAGARRAYSIZE_GLGTMAINWINDOWMODE
} ;




//********************************************************************
/// \brief F[x(Bit Per Pixel)
/// 
/// 
/// 
/// 
enum  GLGTColorDepth {
    GLGTCOLORDEPTH_8  = 8,
    GLGTCOLORDEPTH_16 = 16,
    GLGTCOLORDEPTH_24 = 24,
    GLGTCOLORDEPTH_32 = 32
};



//********************************************************************
/// \brief EChE֘ÃvpeB
///
/// GLGTMainWindowŕێB
///
class GLGTWindowProperty {
    // vpeB ****************************************
public:
    //VXeˑ̃vpeB
    HINSTANCE hInstance;                                ///< CX^Xnh
    HWND hWnd;                                          ///< EBhEnh(resize,moveȂǂ̂)
    HDC hDC;                                            ///< foCXReLXg(swapBuffer̂)
    std::string windowName;                             ///< EChẼLvV
    unsigned long windowStyle;                          ///< EBhẼX^C

    //VXeˑ̃vpeB
    GLGTRectEXT windowRect;                             ///< EBhËʒu(オ_)ETCY
    unsigned int colorDepth;                            ///< EBhE̐F[x(Bit per Pixel)
    GLGTMouseCursor mouseCursor;                        ///< }EXJ[\
    GLGTFlagArray<GLGTMainWindowFlag> mainWindowFlag;   ///< tO
    GLGTFlagArray<GLGTMainWindowMode> mainWindowMode;   ///< [h


    // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTWindowProperty(void)
        : mainWindowMode(GLGTFLAGARRAYSIZE_GLGTMAINWINDOWMODE), mainWindowFlag(GLGTFLAGARRAYSIZE_GLGTMAINWINDOWFLAG) {}

    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTWindowProperty() {}


};







//********************************************************************
/// \brief EChE֘ÃvpeBւ̃|C^Q
/// 
/// VXeˑ̃vpeBɂgetter쐬ĂȂB
/// <BR>
/// ptrColorDepth̓tXN[ɂ̂ݔfB
/// 
class GLGTWindowPropertyPtr {
    friend class GLGTScene;
    friend class GLGTMainWindow;
    // vpeB ****************************************
protected:
    //GLGTWindowProperty* ptrWindowProperty; 
    GLGTWindowProperty* ptr; ///< GLGTWindowPropertyւ̃|C^

    // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTWindowPropertyPtr(void) : ptr(NULL) {}
    //////////////////////////////////////////////////
    /// \brief Rs[RXgN^
    GLGTWindowPropertyPtr(GLGTWindowPropertyPtr& in) : ptr(in.ptr) {}
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTWindowPropertyPtr(GLGTWindowProperty* in) : ptr(in) {}

    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTWindowPropertyPtr() {}


    //////////////////////////////////////////////////
    /// \brief =
    GLGTWindowPropertyPtr& operator =(GLGTWindowPropertyPtr& in) {ptr = in.ptr; return *this;}
    //////////////////////////////////////////////////
    /// \brief =
    GLGTWindowPropertyPtr& operator =(GLGTWindowProperty* in) {ptr = in; return *this;}

    //////////////////////////////////////////////////
    /// \brief 
    ///
    /// ύXs
    ///
    const GLGTRectEXT& getWindowRect(void) const {
        GLGTASSERT(ptr!=NULL);
        return ptr->windowRect;
    }

    //////////////////////////////////////////////////
    /// \brief 
    ///
    /// ύXs
    ///
    unsigned int getColorDepth(void) const {
        GLGTASSERT(ptr!=NULL);
        return ptr->colorDepth;
    }

    //////////////////////////////////////////////////
    /// \brief 
    ///
    /// ύX\
    ///
    GLGTMouseCursor& getMouseCursor(void) {
        GLGTASSERT(ptr!=NULL);
        return ptr->mouseCursor;
    }
    //////////////////////////////////////////////////
    /// \brief 
    ///
    /// ύXs
    ///
    const GLGTMouseCursor& getMouseCursor(void) const {
        GLGTASSERT(ptr!=NULL);
        return ptr->mouseCursor;
    }

    //////////////////////////////////////////////////
    /// \brief 
    ///
    /// ύXs
    ///
    const GLGTFlagArray<GLGTMainWindowFlag>& getMainWindowFlag(void) const {
        GLGTASSERT(ptr!=NULL);
        return ptr->mainWindowFlag;
    }

    //////////////////////////////////////////////////
    /// \brief 
    ///
    /// ύX\
    ///
    GLGTFlagArray<GLGTMainWindowMode>& getMainWindowMode(void) {
        GLGTASSERT(ptr!=NULL);
        return ptr->mainWindowMode;
    }
    //////////////////////////////////////////////////
    /// \brief 
    ///
    /// ύXs
    ///
    const GLGTFlagArray<GLGTMainWindowMode>& getMainWindowMode(void) const {
        GLGTASSERT(ptr!=NULL);
        return ptr->mainWindowMode;
    }


    // J ****************************************
private:




    //////////////////////////////////////////////////
    /// \brief 
    /// \param 
    /// \return 
    /// \retval 
    //void (void);











};







#endif
