/***************************************************
* 
* 
* 
* 
* 
***************************************************/
#include "GLGT.h"


static GLGTFlagArray<GLGTUtilityType> using_utility(GLGTFLAGARRAYSIZE_GLGTUTILITYTYPE);
//********************************************************************
/// \brief GLGT
///
/// \param utility gp郆[eBeB
bool GLGTInit(GLGTFlagArray<GLGTUtilityType>& utility) {
    using_utility = utility;

    if(using_utility[GLGTUTILITYTYPE_UTILITY])              {new GLGTUtility_Singleton;}
    if(using_utility[GLGTUTILITYTYPE_TIME])                 {new GLGTTime_Singleton;}
    if(using_utility[GLGTUTILITYTYPE_PROFILER])             {new GLGTProfiler_Singleton;}
    if(using_utility[GLGTUTILITYTYPE_KEY])                  {new GLGTKey_Singleton;}
    if(using_utility[GLGTUTILITYTYPE_MOUSE])                {new GLGTMouse_Singleton;}
    if(using_utility[GLGTUTILITYTYPE_SHAPES])               {new GLGTShapes_Singleton;}
    if(using_utility[GLGTUTILITYTYPE_MATH])                 {new GLGTMath_Singleton;}
    if(using_utility[GLGTUTILITYTYPE_TEXTUREMANAGER])       {new GLGTTextureManager_Singleton;}
    if(using_utility[GLGTUTILITYTYPE_MODELMANAGER])         {new GLGTModelManager_Singleton;}
    if(using_utility[GLGTUTILITYTYPE_FONTRENDERER])         {new GLGTFontRenderer_Singleton;}


    return true;
}

//********************************************************************
/// \brief GLGT
///
/// 
bool GLGTInit(void) {
    GLGTFlagArray<GLGTUtilityType> temp_utility(GLGTFLAGARRAYSIZE_GLGTUTILITYTYPE);
    temp_utility.setAllFlag(true);
    return GLGTInit(temp_utility);

}



//********************************************************************
/// \brief GLGTVbg_E
///
void GLGTQuit(void) {
    if(using_utility[GLGTUTILITYTYPE_FONTRENDERER])         {delete ptrGLGTFontRenderer;}
    if(using_utility[GLGTUTILITYTYPE_MODELMANAGER])         {delete ptrGLGTModelManager;}
    if(using_utility[GLGTUTILITYTYPE_TEXTUREMANAGER])       {delete ptrGLGTTextureManager;}
    if(using_utility[GLGTUTILITYTYPE_MATH])                 {delete ptrGLGTMath;}
    if(using_utility[GLGTUTILITYTYPE_SHAPES])               {delete ptrGLGTShapes;}
    if(using_utility[GLGTUTILITYTYPE_MOUSE])                {delete ptrGLGTMouse;}
    if(using_utility[GLGTUTILITYTYPE_KEY])                  {delete ptrGLGTKey;}
    if(using_utility[GLGTUTILITYTYPE_PROFILER])             {delete ptrGLGTProfiler;}
    if(using_utility[GLGTUTILITYTYPE_TIME])                 {delete ptrGLGTTime;}
    if(using_utility[GLGTUTILITYTYPE_UTILITY])              {delete ptrGLGTUtility;}

    using_utility.clear();

}
