//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************
#include "GLGTConfigFile.h"


const GLGTConfigElement GLGTConfigFile::emptyElement;


//////////////////////////////////////////////////
GLGTConfigFile::GLGTConfigFile(void) : configFileMode(SIZE_GLGTCONFIGFILEMODE) {
    clear();
}
//////////////////////////////////////////////////
GLGTConfigFile::GLGTConfigFile(const std::string& in_filename) : configFileMode(SIZE_GLGTCONFIGFILEMODE) {
    clear();
    configFileName = in_filename;
}
//////////////////////////////////////////////////
GLGTConfigFile::GLGTConfigFile(const std::string& in_filename, const std::string& in_commentcmd)
: configFileMode(SIZE_GLGTCONFIGFILEMODE)
{
    clear();
    configFileName = in_filename;
    commentCommand = in_commentcmd;
}

//////////////////////////////////////////////////
GLGTConfigFile::~GLGTConfigFile() {
    destroy();
}

//////////////////////////////////////////////////
void GLGTConfigFile::destroy(void) {
    configElement.clear();
    clear();
}

//////////////////////////////////////////////////
bool GLGTConfigFile::load(void) {
    loaded = false;
    configElement.clear();
    //t@CI[v
    std::ifstream cfgfile(configFileName.c_str());
    if(!cfgfile.is_open()){
        return false;
    }

    std::string line;
    std::vector<std::string> key_value;
    std::string comment;
    while(!cfgfile.eof()) {
        getline(cfgfile,line);
        if(configFileMode[GLGTCONFIGFILEMODE_LOADWITHOUTCOMMENT] == true) {
            comment.erase();
        }
        else {
        comment = GLGTUtility.getComment(line,commentCommand);
        }
        GLGTUtility.removeComment(line, commentCommand);
        GLGTUtility.parseString(key_value,line);
        if((key_value.size() > 0)||(comment.size() > 0)) {
            configElement.push_back(GLGTConfigElement(key_value,comment));
        }
    }

    loaded = true;
    return true;
}


//////////////////////////////////////////////////
void GLGTConfigFile::clear(void) {
    configFileMode.clear();
    loaded = false;
    configFileName = "";
    commentCommand = "";
}


