//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************
#include "GLGTConsoleBox.h"

bool          GLGTConsoleBox::staticMemberInitialized = false;
GLGTStringBox GLGTConsoleBox::inputtingString(&inputtingStringRect);
GLGTRectEXT   GLGTConsoleBox::inputtingStringRect;
std::string   GLGTConsoleBox::inputtedString;
GLGTTextBox   GLGTConsoleBox::logText(&logTextRect);
GLGTRectEXT   GLGTConsoleBox::logTextRect;





//////////////////////////////////////////////////
void GLGTConsoleBox::initStaticMember(unsigned int console_width, unsigned int console_height,
                                   unsigned int margin, unsigned int fontscale)
{

    if(staticMemberInitialized == false) {
        unsigned int inputtingstring_height = GLGTFontRenderer.getFontHeight()*fontscale+margin*2;
        unsigned int inputtingstring_top = console_height-inputtingstring_height;

        inputtingStringRect.set(0,inputtingstring_top,console_width,inputtingstring_height);
        inputtingString.setMargin(margin);
        inputtingString.setScale(fontscale);
        inputtingString.stringBoxMode[GLGTSTRINGBOXMODE_BOUNDINGBOX] = true;
        inputtingString.setDefaultStringColor(255,255,255,255);
        inputtingString.setRectColor(0,0,0,191);

        inputtedString = "";

        logTextRect.set(0,0,console_width,console_height-inputtingstring_height);
        logText.init();
        logText.setMargin(margin);
        logText.setScale(fontscale);
        logText.textBoxMode[GLGTTEXTBOXMODE_BOUNDINGBOX] = true;
        logText.setDefaultTextColor(191,191,191,255);
        logText.setRectColor(0,0,0,191);




        staticMemberInitialized = true;
    }

}



//////////////////////////////////////////////////
void GLGTConsoleBox::inputChar(char in_char) {
    if(inputtedString == ""){
        if     (in_char == '\b') {
            inputtingString.backspace();
        }
        else if(in_char == '\t') { //TAB

        }
        else if(in_char == '\n') {
            inputtedString = inputtingString.getString();
        }
        else if(in_char != NULL) {
            inputtingString.printFmt("%c",in_char);
        }
    }

}



//////////////////////////////////////////////////
/// \brief R\[̃TCYύXB
void GLGTConsoleBox::resizeConsoleBox(unsigned int width, unsigned int height,
                                unsigned int margin, unsigned int fontscale)
{

        unsigned int inputtingstring_height = GLGTFontRenderer.getFontHeight()*fontscale+margin*2;
        unsigned int inputtingstring_top = height-inputtingstring_height;

        inputtingStringRect.set(0,inputtingstring_top,width,inputtingstring_height);
        inputtingString.setMargin(margin);
        inputtingString.setScale(fontscale);
        inputtingString.recalcStringPosition();

        logTextRect.set(0,0,width,height-inputtingstring_height);
        logText.setMargin(margin);
        logText.setScale(fontscale);
        logText.recalcTextPosition();
        logText.recalcBoxCapacity();




}





