//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************
#include "GLGTConsoleScene.h"

//////////////////////////////////////////////////
/// \brief RXgN^
GLGTConsoleScene::GLGTConsoleScene(void) {
    initMargin = 2;
    triggerKeyToLeaveScene = KEY_ESCAPE;
}

//////////////////////////////////////////////////
void GLGTConsoleScene::onCreateScene(void) {
    eventHook[GLGTEVENT_IDLE] = true;
    eventFilter.clear();
    eventFilter << GLGTEVENT_IDLE << GLGTEVENT_RESIZEWINDOW << GLGTEVENT_KEYDOWN;


    unsigned int console_height = windowProperty.getWindowRect().dimension.y/3;
    console_height /= GLGTFontRenderer.getFontHeight();
    console_height = console_height*GLGTFontRenderer.getFontHeight()+initMargin*4;
    initStaticMember(windowProperty.getWindowRect().dimension.x,console_height,initMargin);

}

//////////////////////////////////////////////////
/// \brief [Cxg] SceneANeBuɂȂƂ̏
void GLGTConsoleScene::onEnterScene(unsigned int lastscene) {
    unsigned int console_height = windowProperty.getWindowRect().dimension.y/3;
    console_height /= GLGTFontRenderer.getFontHeight();
    console_height = console_height*GLGTFontRenderer.getFontHeight()+initMargin*4;
    GLGTConsoleBox::resizeConsoleBox(windowProperty.getWindowRect().dimension.x,console_height,initMargin);
}
//////////////////////////////////////////////////
void GLGTConsoleScene::onResizeWindow(unsigned int width, unsigned int height) {
    unsigned int console_height = windowProperty.getWindowRect().dimension.y/3;
    console_height /= GLGTFontRenderer.getFontHeight();
    console_height = console_height*GLGTFontRenderer.getFontHeight()+initMargin*4;
    GLGTConsoleBox::resizeConsoleBox(windowProperty.getWindowRect().dimension.x,console_height,initMargin);

}

//////////////////////////////////////////////////
void GLGTConsoleScene::onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar){
    if(keycode == triggerKeyToLeaveScene) {
        leaveScene();
    }
    else if(keycode == KEY_PAGEDOWN){
        GLGTConsoleBox::pageDownLogText();
    }
    else if(keycode == KEY_PAGEUP){
        GLGTConsoleBox::pageUpLogText();
    }
    else if(keycode == KEY_END){
        GLGTConsoleBox::pageResetLogText();
    }
    else if(keycode == KEY_HOME){
        GLGTConsoleBox::pageTopLogText();
    }
    else {
        GLGTConsoleBox::inputChar(keychar);
    }

    if((keychar == '\n')&&(inputtedString == "")) {
        leaveScene();
    }
}





