//********************************************************************
///
/// 
///  \file
/// 
/// 
//********************************************************************
#include "GLGTFontRenderer.h"
#include "GLGTDefaultFont.h"




// C^[tFCX ****************************************

//////////////////////////////////////////////////
/// \brief RXgN^
GLGTFontRenderer_Singleton::GLGTFontRenderer_Singleton(void)
: char_first(32), char_end(127),fontWidth(DEFAULTFONT_FONTWIDTH) ,fontHeight(DEFAULTFONT_FONTHEIGHT),
fontTextureWidth(DEFAULTFONT_TEXTUREWIDTH), fontTextureHeight(DEFAULTFONT_TEXTUREHEIGHT), fontPerRow(DEFAULTFONT_FONTPERROW)
{

    created = false;

}

//////////////////////////////////////////////////
/// \brief fXgN^
GLGTFontRenderer_Singleton::~GLGTFontRenderer_Singleton() {
    glDeleteTextures(1, &textureID);
}

//////////////////////////////////////////////////
void GLGTFontRenderer_Singleton::create() {

    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    glGenTextures(1, &textureID);
    glBindTexture(GL_TEXTURE_2D, textureID);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_LUMINANCE_ALPHA, 
        fontTextureWidth, fontTextureHeight,
        0, GL_LUMINANCE_ALPHA, GL_UNSIGNED_BYTE, textboxfont);

    created = true;
}




//////////////////////////////////////////////////
void GLGTFontRenderer_Singleton::drawLine(std::string& in_line, GLGTColor4<unsigned char>& in_color,
                                          int in_left, int in_top, unsigned int in_scale)
{
    if(created == false) { create();}
    if(in_scale == 0) {in_scale = 1;}

    glEnable(GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, textureID);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST); //{Ȃ炱̕Y
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE); 



    //eLXg`
    int delta_left = fontWidth*in_scale;

    glColor4ubv(&in_color[0]);
    glBegin(GL_QUADS);

    std::string::size_type column_size = in_line.size();
    for(std::string::size_type column_index = 0; column_index < column_size; column_index++) {
        submitCharPolygon(in_line[column_index],in_left,in_top,in_scale);
        in_left += delta_left;
    }
    glEnd();

}



//////////////////////////////////////////////////
void GLGTFontRenderer_Singleton::drawLines(std::vector<std::string>& in_lines, GLGTColor4<unsigned char>& in_color,
                                           int in_left, int in_top, unsigned int in_scale)
{
    if(created == false) { create();}
    if(in_scale == 0) {in_scale = 1;}

    glEnable(GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, textureID);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST); //{Ȃ炱̕Y
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE); 



    //eLXg`
    int delta_left = fontWidth*in_scale;
    int delta_top  = fontHeight*in_scale;

    glColor4ubv(&in_color[0]);
    glBegin(GL_QUADS);

    std::vector<std::string>::size_type row_size = in_lines.size();
    for(std::vector<std::string>::size_type row_index = 0; row_index < row_size; row_index++) {
        std::string::size_type column_size = in_lines[row_index].size();
        for(std::string::size_type column_index = 0; column_index < column_size; column_index++) {
            submitCharPolygon(in_lines[row_index][column_index],in_left,in_top,in_scale);
            in_left += delta_left;
        }
        in_top += delta_top;

    }
    glEnd();










}


//////////////////////////////////////////////////
void GLGTFontRenderer_Singleton::drawFontString(GLGTFontString& in_fontstring, int in_left, int in_top, unsigned int in_scale) {

    if(created == false) { create();}
    if(in_scale == 0) {in_scale = 1;}

    glEnable(GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, textureID);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST); //{Ȃ炱̕Y
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE); 



    //eLXg`
    int delta_left = fontWidth*in_scale;
    unsigned int color_index = 0;

    glBegin(GL_QUADS);

    std::string::size_type column_size = in_fontstring.stringBuffer.size();
    for(std::string::size_type column_index = 0; column_index < column_size; column_index++) {
        //FύX
        if(in_fontstring.fontColor.size() > color_index) {
            if(in_fontstring.fontColor[color_index].column == column_index) {
                glColor4ubv(&(in_fontstring.fontColor[color_index].color[0]));
                color_index++;
            }
        }
        submitCharPolygon(in_fontstring.stringBuffer[column_index],in_left,in_top,in_scale);
        in_left += delta_left;
    }

    glEnd();



}






//////////////////////////////////////////////////
void GLGTFontRenderer_Singleton::drawTextForGLGTTextBox(std::deque<GLGTFontString>& text, unsigned int scale,
                                                        unsigned int start, unsigned int end, int left, int top)
{

    if(created == false) { create();}
    if(scale == 0) {scale = 1;}


    glEnable(GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, textureID);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST); //{Ȃ炱̕Y
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE); 






    //eLXg`
    int delta_cursorX = fontWidth*scale;
    int delta_cursorY = fontHeight*scale;

    glBegin(GL_QUADS);
    int cursorY = top;
    //unsigned int row_size = (unsigned int)line.size();
    for(unsigned int row_index = start; row_index < end; row_index++){
        unsigned int color_index = 0;
        int cursorX = left;

        unsigned int column_size = (unsigned int)text[row_index].stringBuffer.size();
        for(unsigned int column_index = 0; column_size > column_index; column_index++) {
            //FύX
            if(text[row_index].fontColor.size() > color_index) {
                if(text[row_index].fontColor[color_index].column == column_index) {
                    glColor4ubv(&(text[row_index].fontColor[color_index].color[0]));
                    color_index++;
                }
            }
            submitCharPolygon(text[row_index].stringBuffer[column_index],cursorX,cursorY,scale);
            cursorX += delta_cursorX;
        }
        cursorY += delta_cursorY;
    }
    glEnd();



}


//////////////////////////////////////////////////
void GLGTFontRenderer_Singleton::drawStringForGLGTStringBox(GLGTFontString& textline, unsigned int scale, int left, int top)
{
    if(created == false) { create();}
    if(scale == 0) {scale = 1;}

    //O
    /* //Ȃ
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
    glOrtho(0.0, ProjectionWidth, ProjectionHeight, 0.0, -1.0, 1.0);
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();  
    glPushAttrib(GL_TEXTURE_BIT|GL_ENABLE_BIT);

    glDisable(GL_LIGHTING);
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_CULL_FACE);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
    */

    glEnable(GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, textureID);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST); //{Ȃ炱̕Y
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE); 



    //eLXg`
    int delta_cursorX = fontWidth*scale;

    glBegin(GL_QUADS);
    int cursorY = top;
    unsigned int color_index = 0;
    int cursorX = left;

    unsigned int column_size = (unsigned int)textline.stringBuffer.size();
    for(unsigned int column_index = 0; column_size > column_index; column_index++) {
        //FύX
        if(textline.fontColor.size() > color_index) {
            if(textline.fontColor[color_index].column == column_index) {
                glColor4ubv(&(textline.fontColor[color_index].color[0]));
                color_index++;
            }
        }
        submitCharPolygon(textline.stringBuffer[column_index],cursorX,cursorY,scale);
        cursorX += delta_cursorX;
    }
    glEnd();





    //㏈
    /* //Ȃ
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();
    glPopAttrib();
    */


}




// J ****************************************



