//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************
#include "GLGTKey.h"


//////////////////////////////////////////////////
// RXgN^
GLGTKey_Singleton::GLGTKey_Singleton(void) {
    clear();
}

//////////////////////////////////////////////////
// fXgN^
GLGTKey_Singleton::~GLGTKey_Singleton() {
    destroy();
}


//////////////////////////////////////////////////
// destroy
void GLGTKey_Singleton::destroy(void) {

    clear();
}

//////////////////////////////////////////////////
// clear
void GLGTKey_Singleton::clear(void) {
    //L[}bv
    for(int i = 0; i < KEYMAPSIZE; i++) {
        KeyMap[i] = KEY_UNKNOWN;
    }
    KeyMap[VK_BACK] = KEY_BACKSPACE;
    KeyMap[VK_TAB] = KEY_TAB;
    KeyMap[VK_RETURN] = KEY_RETURN;
    KeyMap[VK_PAUSE] = KEY_PAUSE;
    KeyMap[VK_ESCAPE] = KEY_ESCAPE;
    KeyMap[VK_SPACE] = KEY_SPACE;
    KeyMap[VK_OEM_COMMA] = KEY_COMMA;
    KeyMap[VK_OEM_MINUS] = KEY_MINUS;
    KeyMap[VK_OEM_PERIOD] = KEY_PERIOD;
    KeyMap[VK_OEM_2] = KEY_SLASH;
    KeyMap['0'] = KEY_0;
    KeyMap['1'] = KEY_1;
    KeyMap['2'] = KEY_2;
    KeyMap['3'] = KEY_3;
    KeyMap['4'] = KEY_4;
    KeyMap['5'] = KEY_5;
    KeyMap['6'] = KEY_6;
    KeyMap['7'] = KEY_7;
    KeyMap['8'] = KEY_8;
    KeyMap['9'] = KEY_9;
    KeyMap[VK_OEM_1] = KEY_COLON;
    KeyMap[VK_OEM_PLUS] = KEY_SEMICOLON;
    KeyMap['A'] = KEY_A;
    KeyMap['B'] = KEY_B;
    KeyMap['C'] = KEY_C;
    KeyMap['D'] = KEY_D;
    KeyMap['E'] = KEY_E;
    KeyMap['F'] = KEY_F;
    KeyMap['G'] = KEY_G;
    KeyMap['H'] = KEY_H;
    KeyMap['I'] = KEY_I;
    KeyMap['J'] = KEY_J;
    KeyMap['K'] = KEY_K;
    KeyMap['L'] = KEY_L;
    KeyMap['M'] = KEY_M;
    KeyMap['N'] = KEY_N;
    KeyMap['O'] = KEY_O;
    KeyMap['P'] = KEY_P;
    KeyMap['Q'] = KEY_Q;
    KeyMap['R'] = KEY_R;
    KeyMap['S'] = KEY_S;
    KeyMap['T'] = KEY_T;
    KeyMap['U'] = KEY_U;
    KeyMap['V'] = KEY_V;
    KeyMap['W'] = KEY_W;
    KeyMap['X'] = KEY_X;
    KeyMap['Y'] = KEY_Y;
    KeyMap['Z'] = KEY_Z;
    KeyMap[VK_OEM_4] = KEY_LBRACKET;
    KeyMap[VK_OEM_5] = KEY_BACKSLASH;
    KeyMap[VK_OEM_6] = KEY_RBRACKET;
    KeyMap[VK_OEM_7] = KEY_CARET;
    KeyMap[VK_OEM_3] = KEY_BACKQUOTE;

    KeyMap[VK_NUMPAD0] = KEY_NUM_0;
    KeyMap[VK_NUMPAD1] = KEY_NUM_1;
    KeyMap[VK_NUMPAD2] = KEY_NUM_2;
    KeyMap[VK_NUMPAD3] = KEY_NUM_3;
    KeyMap[VK_NUMPAD4] = KEY_NUM_4;
    KeyMap[VK_NUMPAD5] = KEY_NUM_5;
    KeyMap[VK_NUMPAD6] = KEY_NUM_6;
    KeyMap[VK_NUMPAD7] = KEY_NUM_7;
    KeyMap[VK_NUMPAD8] = KEY_NUM_8;
    KeyMap[VK_NUMPAD9] = KEY_NUM_9;
    KeyMap[VK_DECIMAL] = KEY_NUM_DECIMAL;
    KeyMap[VK_DIVIDE] = KEY_NUM_DIVIDE;
    KeyMap[VK_MULTIPLY] = KEY_NUM_MULTIPLY;
    KeyMap[VK_SUBTRACT] = KEY_NUM_SUBTRACT;
    KeyMap[VK_ADD] = KEY_NUM_ADD;
    KeyMap[VK_SEPARATOR] = KEY_NUM_SEPARATOR;

    KeyMap[VK_INSERT] = KEY_INSERT;
    KeyMap[VK_DELETE] = KEY_DELETE;
    KeyMap[VK_HOME] = KEY_HOME;
    KeyMap[VK_END] = KEY_END;
    KeyMap[VK_PRIOR] = KEY_PAGEUP;
    KeyMap[VK_NEXT] = KEY_PAGEDOWN;
    KeyMap[VK_UP] = KEY_UP;
    KeyMap[VK_DOWN] = KEY_DOWN;
    KeyMap[VK_RIGHT] = KEY_RIGHT;
    KeyMap[VK_LEFT] = KEY_LEFT;

    KeyMap[VK_F1]  = KEY_F1;
    KeyMap[VK_F2]  = KEY_F2;
    KeyMap[VK_F3]  = KEY_F3;
    KeyMap[VK_F4]  = KEY_F4;
    KeyMap[VK_F5]  = KEY_F5;
    KeyMap[VK_F6]  = KEY_F6;
    KeyMap[VK_F7]  = KEY_F7;
    KeyMap[VK_F8]  = KEY_F8;
    KeyMap[VK_F9]  = KEY_F9;
    KeyMap[VK_F10] = KEY_F10;
    KeyMap[VK_F11] = KEY_F11;
    KeyMap[VK_F12] = KEY_F12;

    KeyMap[VK_NUMLOCK] = KEY_NUMLOCK;
    KeyMap[VK_CAPITAL] = KEY_CAPSLOCK;
    KeyMap[VK_SCROLL] = KEY_SCROLLOCK;
    KeyMap[VK_SHIFT] = KEY_SHIFT;
    KeyMap[VK_CONTROL] = KEY_CTRL;
    KeyMap[VK_MENU] = KEY_ALT;
    KeyMap[VK_RSHIFT] = KEY_RSHIFT;
    KeyMap[VK_LSHIFT] = KEY_LSHIFT;
    KeyMap[VK_RCONTROL] = KEY_RCTRL;
    KeyMap[VK_LCONTROL] = KEY_LCTRL;
    KeyMap[VK_RMENU] = KEY_RALT;
    KeyMap[VK_LMENU] = KEY_LALT;

    KeyMap[VK_SNAPSHOT] = KEY_PRINTSCREEN;
    KeyMap[VK_OEM_102] = KEY_BACKSLASH102;



    //L[
    for(int i = 0; i < KEY_LAST; i++) {
        KeyName[i] = "unknown key";
    }
    KeyName[KEY_BACKSPACE] = "Backspace";
    KeyName[KEY_TAB] = "Tab";
    KeyName[KEY_RETURN] = "Return";
    KeyName[KEY_PAUSE] = "pause";
    KeyName[KEY_ESCAPE] = "Escape";
    KeyName[KEY_SPACE] = "Space";
    KeyName[KEY_COMMA] = ",";
    KeyName[KEY_MINUS] = "-";
    KeyName[KEY_PERIOD] = ".";
    KeyName[KEY_SLASH] = "/";
    KeyName[KEY_0] = "0";
    KeyName[KEY_1] = "1";
    KeyName[KEY_2] = "2";
    KeyName[KEY_3] = "3";
    KeyName[KEY_4] = "4";
    KeyName[KEY_5] = "5";
    KeyName[KEY_6] = "6";
    KeyName[KEY_7] = "7";
    KeyName[KEY_8] = "8";
    KeyName[KEY_9] = "9";
    KeyName[KEY_COLON] = ":";
    KeyName[KEY_SEMICOLON] = ";";
    KeyName[KEY_A] = "A";
    KeyName[KEY_B] = "B";
    KeyName[KEY_C] = "C";
    KeyName[KEY_D] = "D";
    KeyName[KEY_E] = "E";
    KeyName[KEY_F] = "F";
    KeyName[KEY_G] = "G";
    KeyName[KEY_H] = "H";
    KeyName[KEY_I] = "I";
    KeyName[KEY_J] = "J";
    KeyName[KEY_K] = "K";
    KeyName[KEY_L] = "L";
    KeyName[KEY_M] = "M";
    KeyName[KEY_N] = "N";
    KeyName[KEY_O] = "O";
    KeyName[KEY_P] = "P";
    KeyName[KEY_Q] = "Q";
    KeyName[KEY_R] = "R";
    KeyName[KEY_S] = "S";
    KeyName[KEY_T] = "T";
    KeyName[KEY_U] = "U";
    KeyName[KEY_V] = "V";
    KeyName[KEY_W] = "W";
    KeyName[KEY_X] = "X";
    KeyName[KEY_Y] = "Y";
    KeyName[KEY_Z] = "Z";
    KeyName[KEY_LBRACKET] = "[";
    KeyName[KEY_BACKSLASH] = "\\";
    KeyName[KEY_RBRACKET] = "]";
    KeyName[KEY_CARET] = "^";
    KeyName[KEY_BACKQUOTE] = "`";

    KeyName[KEY_NUM_0] = "Num 0";
    KeyName[KEY_NUM_1] = "Num 1";
    KeyName[KEY_NUM_2] = "Num 2";
    KeyName[KEY_NUM_3] = "Num 3";
    KeyName[KEY_NUM_4] = "Num 4";
    KeyName[KEY_NUM_5] = "Num 5";
    KeyName[KEY_NUM_6] = "Num 6";
    KeyName[KEY_NUM_7] = "Num 7";
    KeyName[KEY_NUM_8] = "Num 8";
    KeyName[KEY_NUM_9] = "Num 9";
    KeyName[KEY_NUM_DECIMAL] = "Num .";
    KeyName[KEY_NUM_DIVIDE] = "Num /";
    KeyName[KEY_NUM_MULTIPLY] = "Num *";
    KeyName[KEY_NUM_SUBTRACT] = "Num -";
    KeyName[KEY_NUM_ADD] = "Num +";
    KeyName[KEY_NUM_SEPARATOR] = "Num Return";

    KeyName[KEY_INSERT] = "Insert";
    KeyName[KEY_DELETE] = "Delete";
    KeyName[KEY_HOME] = "Home";
    KeyName[KEY_END] = "End";
    KeyName[KEY_PAGEUP] = "Page Up";
    KeyName[KEY_PAGEDOWN] = "Page Down";
    KeyName[KEY_UP] = "Up";
    KeyName[KEY_DOWN] = "Down";
    KeyName[KEY_RIGHT] = "Right";
    KeyName[KEY_LEFT] = "Left";

    KeyName[KEY_F1] = "F1";
    KeyName[KEY_F2] = "F2";
    KeyName[KEY_F3] = "F3";
    KeyName[KEY_F4] = "F4";
    KeyName[KEY_F5] = "F5";
    KeyName[KEY_F6] = "F6";
    KeyName[KEY_F7] = "F7";
    KeyName[KEY_F8] = "F8";
    KeyName[KEY_F9] = "F9";
    KeyName[KEY_F10] = "F10";
    KeyName[KEY_F11] = "F11";
    KeyName[KEY_F12] = "F12";

    KeyName[KEY_NUMLOCK] = "Num Lock";
    KeyName[KEY_CAPSLOCK] = "Caps Lock";
    KeyName[KEY_SCROLLOCK] = "Scroll Lock";
    KeyName[KEY_SHIFT] = "Shift";
    KeyName[KEY_CTRL] = "Ctrl";
    KeyName[KEY_ALT] = "Alt";
    KeyName[KEY_RSHIFT] = "Right Shift";
    KeyName[KEY_LSHIFT] = "Left Shift";
    KeyName[KEY_RCTRL] = "Right Ctrl";
    KeyName[KEY_LCTRL] = "Left Ctrl";
    KeyName[KEY_RALT] = "Right Alt";
    KeyName[KEY_LALT] = "Left Alt";

    KeyName[KEY_PRINTSCREEN] = "Print Screen";
    KeyName[KEY_BACKSLASH102] = "\\";




    //L[ɑΉLN^
    for(int i = 0; i < KEY_LAST; i++) {
        KeyChar[i][0] = NULL;
        KeyChar[i][1] = NULL;
    }
    //Shift̏ꍇ
    KeyChar[KEY_BACKSPACE][0] = '\b';
    KeyChar[KEY_TAB][0] = '\t';
    KeyChar[KEY_RETURN][0] = '\n';
    KeyChar[KEY_SPACE][0] = ' ';
    KeyChar[KEY_COMMA][0] = ',';
    KeyChar[KEY_MINUS][0] = '-';
    KeyChar[KEY_PERIOD][0] = '.';
    KeyChar[KEY_SLASH][0] = '/';
    KeyChar[KEY_0][0] = '0';
    KeyChar[KEY_1][0] = '1';
    KeyChar[KEY_2][0] = '2';
    KeyChar[KEY_3][0] = '3';
    KeyChar[KEY_4][0] = '4';
    KeyChar[KEY_5][0] = '5';
    KeyChar[KEY_6][0] = '6';
    KeyChar[KEY_7][0] = '7';
    KeyChar[KEY_8][0] = '8';
    KeyChar[KEY_9][0] = '9';
    KeyChar[KEY_COLON][0] = ':';
    KeyChar[KEY_SEMICOLON][0] = ';'; // ?
    KeyChar[KEY_A][0] = 'a';
    KeyChar[KEY_B][0] = 'b';
    KeyChar[KEY_C][0] = 'c';
    KeyChar[KEY_D][0] = 'd';
    KeyChar[KEY_E][0] = 'e';
    KeyChar[KEY_F][0] = 'f';
    KeyChar[KEY_G][0] = 'g';
    KeyChar[KEY_H][0] = 'h';
    KeyChar[KEY_I][0] = 'i';
    KeyChar[KEY_J][0] = 'j';
    KeyChar[KEY_K][0] = 'k';
    KeyChar[KEY_L][0] = 'l';
    KeyChar[KEY_M][0] = 'm';
    KeyChar[KEY_N][0] = 'n';
    KeyChar[KEY_O][0] = 'o';
    KeyChar[KEY_P][0] = 'p';
    KeyChar[KEY_Q][0] = 'q';
    KeyChar[KEY_R][0] = 'r';
    KeyChar[KEY_S][0] = 's';
    KeyChar[KEY_T][0] = 't';
    KeyChar[KEY_U][0] = 'u';
    KeyChar[KEY_V][0] = 'v';
    KeyChar[KEY_W][0] = 'w';
    KeyChar[KEY_X][0] = 'x';
    KeyChar[KEY_Y][0] = 'y';
    KeyChar[KEY_Z][0] = 'z';
    KeyChar[KEY_LBRACKET][0] = '[';
    KeyChar[KEY_BACKSLASH][0] = '\\'; 
    KeyChar[KEY_RBRACKET][0] = ']';
    KeyChar[KEY_CARET][0] = '^';
    KeyChar[KEY_BACKQUOTE][0] = '@'; // ?
    KeyChar[KEY_NUM_0][0] = '0';
    KeyChar[KEY_NUM_1][0] = '1';
    KeyChar[KEY_NUM_2][0] = '2';
    KeyChar[KEY_NUM_3][0] = '3';
    KeyChar[KEY_NUM_4][0] = '4';
    KeyChar[KEY_NUM_5][0] = '5';
    KeyChar[KEY_NUM_6][0] = '6';
    KeyChar[KEY_NUM_7][0] = '7';
    KeyChar[KEY_NUM_8][0] = '8';
    KeyChar[KEY_NUM_9][0] = '9';
    KeyChar[KEY_NUM_DECIMAL][0] = '.';
    KeyChar[KEY_NUM_DIVIDE][0] = '/';
    KeyChar[KEY_NUM_MULTIPLY][0] = '*';
    KeyChar[KEY_NUM_SUBTRACT][0] = '-';
    KeyChar[KEY_NUM_ADD][0] = '+';
    KeyChar[KEY_NUM_SEPARATOR][0] = '\n';
    KeyChar[KEY_BACKSLASH102][0] = '\\';

    //ShiftL̏ꍇ
    KeyChar[KEY_BACKSPACE][1] = '\b';
    KeyChar[KEY_TAB][1] = '\t';
    KeyChar[KEY_RETURN][1] = '\n';
    KeyChar[KEY_SPACE][1] = ' ';
    KeyChar[KEY_COMMA][1] = '<';
    KeyChar[KEY_MINUS][1] = '=';
    KeyChar[KEY_PERIOD][1] = '>';
    KeyChar[KEY_SLASH][1] = '?';
    KeyChar[KEY_0][1] = NULL; //Ԃ
    KeyChar[KEY_1][1] = '!';
    KeyChar[KEY_2][1] = '"';
    KeyChar[KEY_3][1] = '#';
    KeyChar[KEY_4][1] = '$';
    KeyChar[KEY_5][1] = '%';
    KeyChar[KEY_6][1] = '&';
    KeyChar[KEY_7][1] = '\'';
    KeyChar[KEY_8][1] = '(';
    KeyChar[KEY_9][1] = ')';
    KeyChar[KEY_COLON][1] = '*';
    KeyChar[KEY_SEMICOLON][1] = '+'; // ?
    KeyChar[KEY_A][1] = 'A';
    KeyChar[KEY_B][1] = 'B';
    KeyChar[KEY_C][1] = 'C';
    KeyChar[KEY_D][1] = 'D';
    KeyChar[KEY_E][1] = 'E';
    KeyChar[KEY_F][1] = 'F';
    KeyChar[KEY_G][1] = 'G';
    KeyChar[KEY_H][1] = 'H';
    KeyChar[KEY_I][1] = 'I';
    KeyChar[KEY_J][1] = 'J';
    KeyChar[KEY_K][1] = 'K';
    KeyChar[KEY_L][1] = 'L';
    KeyChar[KEY_M][1] = 'M';
    KeyChar[KEY_N][1] = 'N';
    KeyChar[KEY_O][1] = 'O';
    KeyChar[KEY_P][1] = 'P';
    KeyChar[KEY_Q][1] = 'Q';
    KeyChar[KEY_R][1] = 'R';
    KeyChar[KEY_S][1] = 'S';
    KeyChar[KEY_T][1] = 'T';
    KeyChar[KEY_U][1] = 'U';
    KeyChar[KEY_V][1] = 'V';
    KeyChar[KEY_W][1] = 'W';
    KeyChar[KEY_X][1] = 'X';
    KeyChar[KEY_Y][1] = 'Y';
    KeyChar[KEY_Z][1] = 'Z';
    KeyChar[KEY_LBRACKET][1] = '{';
    KeyChar[KEY_BACKSLASH][1] = '|';
    KeyChar[KEY_RBRACKET][1] = '}';
    KeyChar[KEY_CARET][1] = '~';
    KeyChar[KEY_BACKQUOTE][1] = '`'; // ?
    KeyChar[KEY_NUM_0][1] = '0';
    KeyChar[KEY_NUM_1][1] = '1';
    KeyChar[KEY_NUM_2][1] = '2';
    KeyChar[KEY_NUM_3][1] = '3';
    KeyChar[KEY_NUM_4][1] = '4';
    KeyChar[KEY_NUM_5][1] = '5';
    KeyChar[KEY_NUM_6][1] = '6';
    KeyChar[KEY_NUM_7][1] = '7';
    KeyChar[KEY_NUM_8][1] = '8';
    KeyChar[KEY_NUM_9][1] = '9';
    KeyChar[KEY_NUM_DECIMAL][1] = '.';
    KeyChar[KEY_NUM_DIVIDE][1] = '/';
    KeyChar[KEY_NUM_MULTIPLY][1] = '*';
    KeyChar[KEY_NUM_SUBTRACT][1] = '-';
    KeyChar[KEY_NUM_ADD][1] = '+';
    KeyChar[KEY_NUM_SEPARATOR][1] = '\n';
    KeyChar[KEY_BACKSLASH102][1] = '_';


}


//////////////////////////////////////////////////
// getOSKeyCode
OSKeyCode GLGTKey_Singleton::getOSKeyCode(GLGTKeyCode keycode) {
    for(unsigned int i = 0; i < KEYMAPSIZE; i++) {
        if(KeyMap[i] == keycode) {
            return (OSKeyCode)i;
        }
    }
    return (OSKeyCode)KEYMAPSIZE;

}




