//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************

#include "GLGTMainWindow.h"

//////////////////////////////////////////////////
// RXgN^
GLGTMainWindow::GLGTMainWindow(void) {

    windowProperty = &property;
    clear();
}

//////////////////////////////////////////////////
// fXgN^
GLGTMainWindow::~GLGTMainWindow(void){
    destroy();
}


//////////////////////////////////////////////////
// clear
void GLGTMainWindow::clear(void){

    //EBhẼf[^
    ZeroMemory((LPVOID)&wndClass, sizeof(WNDCLASSEX));
    hRC = NULL;
    className = "GLGTMainWindow";// typeid (*this).name();//̃NX̌^EChENXɂ

    //EBhEvpeB
    property.hWnd = NULL;
    property.hDC = NULL;
    property.windowName = "GLGTMainWindow";
    property.windowStyle = WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU;
    property.windowRect.set(100,100,800,600);
    property.colorDepth = 32;
    property.mainWindowFlag.clear();
    property.mainWindowFlag[GLGTMAINWINDOWFLAG_MOUSECURSORVISIBLE] = true;
    property.mainWindowMode.clear();

    //sNZtH[}bg̃f[^
    pixelBufferFlags = (PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER);
    pixelType = PFD_TYPE_RGBA;
    colorBits = 32;
    redBits  = 0;
    redShift = 0;
    greenBits  = 0;
    greenShift = 0;
    blueBits   = 0;
    blueShift  = 0; 
    alphaBits  = 0;
    alphaShift = 0;
    accumBits      = 0;
    accumRedBits   = 0;
    accumGreenBits = 0;
    accumBlueBits  = 0;
    accumAlphaBits = 0;
    depthBits = 32;
    stencilBits = 0;
    layerType = PFD_MAIN_PLANE; 
    reserved = 0; 



}

//////////////////////////////////////////////////
// create
bool GLGTMainWindow::create(void){

    onCreateWindow();

    // CX^Xnh擾
    property.hInstance = GetModuleHandle(NULL);

    // EBhENX\̂ݒ
    wndClass.cbSize = sizeof(WNDCLASSEX); 
    wndClass.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
    wndClass.lpfnWndProc = (WNDPROC)MainWindowProc;
    wndClass.cbClsExtra = 0;
    wndClass.cbWndExtra = 0;
    wndClass.hInstance = property.hInstance;
    wndClass.hIcon = NULL;//LoadIcon(property.hInstance, MAKEINTRESOURCE(IDI_ICON1));
    wndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
    wndClass.hbrBackground = NULL;
    wndClass.lpszMenuName = NULL;
    wndClass.lpszClassName = className.c_str(); 
    wndClass.hIconSm = NULL;//LoadIcon(property.hInstance,MAKEINTRESOURCE(IDI_ICON1));

    // EChENXo^
    if(!RegisterClassEx(&wndClass)) {
        return false;
    }

    //NCAg̈̃TCYvZ
    RECT rect;
    rect.top = property.windowRect.position.y;
    rect.left = property.windowRect.position.x;
    rect.bottom = rect.top + property.windowRect.dimension.y;
    rect.right = rect.left + property.windowRect.dimension.x;
    AdjustWindowRect(&rect, property.windowStyle, FALSE);

    // EChE쐬
    property.hWnd = CreateWindow(
        wndClass.lpszClassName,                 // EChENX
        property.windowName.c_str(),                     // LvV
        property.windowStyle,                            // EChẼX^C
        property.windowRect.position.x,                  // ʒu
        property.windowRect.position.y,                  // ʒu
        rect.right - rect.left,                 // 
        rect.bottom - rect.top,                 // 
        NULL,                                   // eEChE
        NULL,                                   // EChEj[
        property.hInstance,                              // CX^Xnh
        NULL);                                  // WM_CREATE

    if(!property.hWnd) {
        return false;
    }

    //EBhEnhGLGTMainWindowIuWFNgт
    if(!attachObject()) {
        return false;
    }


    return true;
}

//////////////////////////////////////////////////
// destroy
void GLGTMainWindow::destroy(void){

    onDestroyWindow();

    clear();  // ŌɃoϐ


}

//////////////////////////////////////////////////
// run
bool GLGTMainWindow::run(void){
    if(!property.hWnd) {
        return false;
    }

    if(!initGLWindow()) {
        return false;
    }
    ShowWindow(property.hWnd, SW_SHOWNORMAL);
    UpdateWindow(property.hWnd);


    onCreateScene();
    property.mouseCursor.create();
    onEnterScene(OWNSCENE);//qV[玩V[ɐ؂ւƂɂĂ΂

    MSG msg;
    //vt@C
    static unsigned int prof_mainloop;
    static unsigned int prof_idle;
    prof_mainloop = GLGTProfiler.beginSampleProfiling("[GLGT]Main Loop");//C[ṽvt@CJn
    while((!sceneDone)||(!isActive())){
        if(PeekMessage(&msg,NULL,0,0,PM_REMOVE)){
            //WM_QUIT𖾎Iɏ
            if(msg.message==WM_QUIT){
                leaveScene();
            }
            else {
                DispatchMessage(&msg);
            }
        }
        //ɂȂɂȂꍇonIdleĂяo
        else{
            if(GLGTProfiler.profilerMode[GLGTPROFILERMODE_ENABLE] == true) {

                prof_idle = GLGTProfiler.beginSampleProfiling("[GLGT]Idle Event");//AChCxg̃vt@CJn
                assignIdleEvent();
                GLGTProfiler.endSampleProfiling(prof_idle);//AChCxg̃vt@CI

                GLGTProfiler.endSampleProfiling(prof_mainloop);//C[ṽvt@CI

                //vt@C̓v𓾂
                GLGTProfiler.updateProfileStatistics();

                //vt@C̓v\
                GLGTProfiler.drawProfile(5,5,property.windowRect.dimension.x,property.windowRect.dimension.y);
                //GLGTProfiler.outputToStdout(2000);

                GLGTProfiler.clearProfileSamples();
                prof_mainloop = GLGTProfiler.beginSampleProfiling("[GLGT]Main Loop");//C[ṽvt@CJn
            }
            else {
                assignIdleEvent();
            }

            //swapBuffers()
            if(property.mainWindowMode[GLGTMAINWINDOWMODE_AUTOSWAPBUFFERS] == true) {swapBuffers();}
        }
    }

    onLeaveScene(OWNSCENE);
    property.mouseCursor.destroy();
    onDestroyScene();

    releaseGLWindow();

    return true;
}


//////////////////////////////////////////////////
bool GLGTMainWindow::initGLWindow(void) {
    //sNZtH[}bg\̂
    PIXELFORMATDESCRIPTOR pfd;
    pfd.nSize = sizeof(PIXELFORMATDESCRIPTOR); // PIXELFORMATDESCRIPTOR\̂̃TCY
    pfd.nVersion = 1;                          // \̂̃o[Wԍ
    pfd.dwFlags = pixelBufferFlags;
    pfd.iPixelType = pixelType;
    pfd.cColorBits = colorBits;
    pfd.cRedBits = redBits;
    pfd.cRedShift = redShift;
    pfd.cGreenBits = greenBits;
    pfd.cGreenShift = greenShift;
    pfd.cBlueBits = blueBits;
    pfd.cBlueShift = blueShift;
    pfd.cAlphaBits = alphaBits;
    pfd.cAlphaShift = alphaShift;
    pfd.cAccumBits = accumBits;
    pfd.cAccumRedBits = accumRedBits;
    pfd.cAccumGreenBits = accumGreenBits;
    pfd.cAccumBlueBits = accumBlueBits;
    pfd.cAccumAlphaBits = accumAlphaBits;
    pfd.cDepthBits = depthBits;
    pfd.cStencilBits = stencilBits;
    pfd.cAuxBuffers = 0;                        // ⏕obt@̐(Win32ł̓mT|[g)
    pfd.iLayerType = layerType;
    pfd.bReserved = reserved;
    pfd.dwLayerMask = 0;                        // C}XN(Win32ł̓mT|[g)
    pfd.dwVisibleMask = 0;                      // rWu}XN(Win32ł̓mT|[g)
    pfd.dwDamageMask = 0;                       // _[W}XN(Win32ł̓mT|[g)


    //foCXReLXg擾
    property.hDC=GetDC(property.hWnd);
    if (!property.hDC){
        return false;
    }

    //sNZtH[}bg̎w
    int pixelformat;
    if ((pixelformat = ChoosePixelFormat(property.hDC, &pfd)) == 0 ) {
        releaseGLWindow();
        return false;
    }

    //sNZtH[}bg̐ݒ
    if (SetPixelFormat(property.hDC, pixelformat, &pfd) == FALSE) {
        releaseGLWindow();
        return false;
    }

    //OpenGL_OReLXg̍쐬
    hRC=wglCreateContext(property.hDC);
    if (!hRC) {
        releaseGLWindow();
        return false;
    }

    //_OReLXgJg
    if(wglMakeCurrent(property.hDC,hRC) == FALSE) {
        releaseGLWindow();
        return false;
    }



    return true;


}


//////////////////////////////////////////////////
// 
void GLGTMainWindow::releaseGLWindow(void){
    if (hRC) {
        wglMakeCurrent(NULL, NULL);
        wglDeleteContext(hRC);
    }

    if (property.hDC) {
        ReleaseDC(property.hWnd, property.hDC);
    }
}


//////////////////////////////////////////////////
//  attachObject
bool GLGTMainWindow::attachObject(void) {
    if (!property.hWnd) {
        return false;
    }
    // EBhEnhGLGTMainWindowIuWFNgт
    SetProp(property.hWnd, "THIS_OBJECT", (HANDLE)this);
    return true;
}

//////////////////////////////////////////////////
// detachObject
bool GLGTMainWindow::detachObject(void) {
    if (!property.hWnd) {
        return false;
    }

    // EBhEnhGLGTMainWindowIuWFNg؂藣
    RemoveProp(property.hWnd, "THIS_OBJECT");

    return true;
}





//////////////////////////////////////////////////
// MainWindowProc
LRESULT CALLBACK GLGTMainWindow::MainWindowProc(HWND hwnd_, UINT umsg_, WPARAM wparam_, LPARAM lparam_) {
    //ĂяõIuWFNg̃|C^擾
    GLGTMainWindow* obj = (GLGTMainWindow*)GetProp(hwnd_, "THIS_OBJECT");
    //targetobj̎擾ɐꍇ
    if(obj) {
        //EBhE֘ACxgɎgϐ
        //RECT rect;
        //L[{[hCxgɎgϐ
        GLGTKeyCode keycode;
        bool is_repeated = false;
        bool is_shift = false;
        bool is_capslock = false;
        //}EXCxgɎgϐ
        static GLGTVector2<int> last_lbutton_pos(0,0);//O񍶃{^Cxg̈ʒu
        static GLGTVector2<int> last_rbutton_pos(0,0);//OE{^Cxg̈ʒu
        static GLGTVector2<int> last_mbutton_pos(0,0);//O񒆉{^Cxg̈ʒu
        static GLGTVector2<int> last_wheel_pos(0,0);//OzC[Cxg̈ʒu
        static GLGTVector2<int> last_move_pos(0,0);//O}EXړ̈ʒu
        /*
        static last_lbutton_x = 0; //O񍶃{^Cxg̈ʒu
        static last_lbutton_y = 0;
        static last_rbutton_x = 0; //OE{^Cxg̈ʒu
        static last_rbutton_y = 0;
        static last_mbutton_x = 0; //O񒆉{^Cxg̈ʒu
        static last_mbutton_y = 0;
        static last_wheel_x = 0; //OzC[Cxg̈ʒu
        static last_wheel_y = 0;
        static last_move_x = 0; //O}EXړ̈ʒu
        static last_move_y = 0;
        */

        switch (umsg_) {
                    case WM_CREATE:
                        break;
                    case WM_CLOSE:
                        if(obj->onCloseWindow() == true) {
                            //PostQuitMessage(0);
                            obj->leaveScene();
                        }
                        break;

                    case WM_DESTROY:
                        obj->onDestroyWindow();
                        PostQuitMessage(0);
                        break;

                    case WM_MOVE:
                        obj->property.windowRect.position.x = LOWORD(lparam_);
                        obj->property.windowRect.position.y = HIWORD(lparam_);
                        obj->assignMoveWindowEvent(obj->property.windowRect.position.x, obj->property.windowRect.position.y);
                        break;

                    case WM_SIZE:
                        obj->property.windowRect.dimension.x = LOWORD(lparam_);
                        obj->property.windowRect.dimension.y = HIWORD(lparam_);
                        obj->assignResizeWindowEvent(obj->property.windowRect.dimension.x, obj->property.windowRect.dimension.y);
                        break;



                        //L[ꂽꍇ
                    case WM_SYSKEYDOWN:
                    case WM_KEYDOWN:
                        if(GetKeyState(VK_SHIFT) < 0) {
                            is_shift = true;
                        }
                        if(GetKeyState(VK_CAPITAL) & 1) {
                            is_capslock = true;
                        }
                        if(lparam_&REPEATED_KEYMASK) {
                            is_repeated = true;
                        }
                        keycode = GLGTKey.getKeyCode((OSKeyCode)wparam_);
                        obj->assignKeyDownEvent(keycode, is_repeated, GLGTKey.getKeyChar(keycode, is_shift, is_capslock));
                        break;

                        //L[ꂽꍇ
                    case WM_SYSKEYUP:
                    case WM_KEYUP:
                        keycode = GLGTKey.getKeyCode((OSKeyCode)wparam_);
                        obj->assignKeyUpEvent(keycode, false, GLGTKey.getKeyChar(keycode, is_shift, is_capslock));
                        break;


                        //}EX{^ꂽꍇƃzC[AbvE_E
                    case WM_LBUTTONDOWN:
                        obj->assignMouseDownEvent(MOUSE_LEFTBUTTON,
                            obj->property.mouseCursor.position.x, obj->property.mouseCursor.position.y,
                            last_lbutton_pos.x, last_lbutton_pos.y);
                        last_lbutton_pos.x = last_move_pos.x;
                        last_lbutton_pos.y = last_move_pos.y;
                        break;
                    case WM_RBUTTONDOWN:
                        obj->assignMouseDownEvent(MOUSE_RIGHTBUTTON,
                            obj->property.mouseCursor.position.x, obj->property.mouseCursor.position.y,
                            last_rbutton_pos.x, last_rbutton_pos.y);
                        last_rbutton_pos.x = last_move_pos.x;
                        last_rbutton_pos.y = last_move_pos.y;
                        break;
                    case WM_MBUTTONDOWN:
                        obj->assignMouseDownEvent(MOUSE_MIDDLEBUTTON,
                            obj->property.mouseCursor.position.x, obj->property.mouseCursor.position.y,
                            last_mbutton_pos.x, last_mbutton_pos.y);
                        last_mbutton_pos.x = last_move_pos.x;
                        last_mbutton_pos.y = last_move_pos.y;
                        break;
                    case WM_MOUSEWHEEL:
                        if((SHORT)HIWORD(wparam_) < 0){
                            obj->assignMouseDownEvent(MOUSE_WHEELDOWN,
                                obj->property.mouseCursor.position.x, obj->property.mouseCursor.position.y,
                                last_wheel_pos.x, last_wheel_pos.y);
                        }
                        else if((SHORT)HIWORD(wparam_) > 0){
                            obj->assignMouseDownEvent(MOUSE_WHEELUP,
                                obj->property.mouseCursor.position.x, obj->property.mouseCursor.position.y,
                                last_wheel_pos.x, last_wheel_pos.y);
                        }
                        last_wheel_pos.x = last_move_pos.x;
                        last_wheel_pos.y = last_move_pos.y;
                        break;

                        //}EX{^ꂽꍇ
                    case WM_LBUTTONUP:
                        //x = LOWORD(lparam_);
                        //y = HIWORD(lparam_);
                        obj->assignMouseUpEvent(MOUSE_LEFTBUTTON,
                            obj->property.mouseCursor.position.x, obj->property.mouseCursor.position.y,
                            last_lbutton_pos.x, last_lbutton_pos.y);
                        last_lbutton_pos.x = last_move_pos.x;
                        last_lbutton_pos.y = last_move_pos.y;
                        break;
                    case WM_RBUTTONUP:
                        //x = LOWORD(lparam_);
                        //y = HIWORD(lparam_);
                        obj->assignMouseUpEvent(MOUSE_RIGHTBUTTON,
                            obj->property.mouseCursor.position.x, obj->property.mouseCursor.position.y,
                            last_rbutton_pos.x, last_rbutton_pos.y);
                        last_rbutton_pos.x = last_move_pos.x;
                        last_rbutton_pos.y = last_move_pos.y;
                        break;
                    case WM_MBUTTONUP:
                        //x = LOWORD(lparam_);
                        //y = HIWORD(lparam_);
                        obj->assignMouseUpEvent(MOUSE_MIDDLEBUTTON,
                            obj->property.mouseCursor.position.x, obj->property.mouseCursor.position.y,
                            last_mbutton_pos.x, last_mbutton_pos.y);
                        last_mbutton_pos.x = last_move_pos.x;
                        last_mbutton_pos.y = last_move_pos.y;
                        break;

                        //}EXꂽꍇ
                    case WM_MOUSEMOVE:
                        obj->property.mouseCursor.position.x = LOWORD(lparam_);
                        obj->property.mouseCursor.position.y = HIWORD(lparam_);
                        //moveMouseł̈ړ͖
                        if(obj->property.mainWindowFlag[GLGTMAINWINDOWFLAG_MOUSEWARPED] == true) {
                            last_move_pos.x = obj->property.mouseCursor.position.x;
                            last_move_pos.y = obj->property.mouseCursor.position.y;
                            obj->property.mainWindowFlag[GLGTMAINWINDOWFLAG_MOUSEWARPED] = false;
                        }
                        else {
                            obj->assignMouseMoveEvent(obj->property.mouseCursor.position.x, obj->property.mouseCursor.position.y,
                                last_move_pos.x, last_move_pos.y);
                            last_move_pos.x = obj->property.mouseCursor.position.x;
                            last_move_pos.y = obj->property.mouseCursor.position.y;
                        }
                        break;

                    default:
                        return DefWindowProc(hwnd_, umsg_, wparam_, lparam_);
                        //break; 
        }
        return 0L;
    }
    //targetobj̎擾Ɏsꍇ
    return DefWindowProc(hwnd_, umsg_, wparam_, lparam_);

}









//////////////////////////////////////////////////
// onCreateWindow
void GLGTMainWindow::onCreateWindow(void) {
}

//////////////////////////////////////////////////
// onCloseWindow
bool GLGTMainWindow::onCloseWindow(void) {
    return true;
}

//////////////////////////////////////////////////
// onDestroyWindow
void GLGTMainWindow::onDestroyWindow(void) {
}



//////////////////////////////////////////////////
// 



