//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************
#include "GLGTModelManager.h"



//////////////////////////////////////////////////
GLGTModelManager_Singleton::GLGTModelManager_Singleton(void) {
    clear();
}

//////////////////////////////////////////////////
GLGTModelManager_Singleton::~GLGTModelManager_Singleton() {
    destroy();
}


//////////////////////////////////////////////////
void GLGTModelManager_Singleton::destroy(void) {
    model.clear();
    clear();
}


//////////////////////////////////////////////////
void GLGTModelManager_Singleton::clear(void) {
}





//////////////////////////////////////////////////
GLGTModel<>* GLGTModelManager_Singleton::getModel(const std::string& in_modelname) {
    for(unsigned int i = 0; i< model.size(); i++) {
        if(in_modelname == model[i].getName()) {
            return &model[i];
        }
    }
    return NULL;
}



//////////////////////////////////////////////////
GLGTModel<>* GLGTModelManager_Singleton::pushModel(const std::string& in_modelname, GLGTModelType type) {
    //łɑ݂ĂȂ`FbN
    if(getModel(in_modelname) != NULL) {
        return getModel(in_modelname);
    }
    //eNX`ő吔ɒBĂȂ`FbN
    if(model.size() >= MAX_MODEL) {
        return NULL;
    }

    //eNX`ǉ
    model.push_back(GLGTModel<>(in_modelname, type));

    //ǂݍŃ`FbNiǂݍݎsꍇ͍폜)
    if(!loadModel(model.back())) {
        model.pop_back();
        return NULL;
    }

    model.back().setModelIndex((unsigned int)model.size()-1);
    return &model.back();
}


//////////////////////////////////////////////////
GLGTModel<>* GLGTModelManager_Singleton::pushModel(const GLGTModel<>& in_model) {
    //łɑ݂ĂȂ`FbN
    if(getModel(in_model.getName()) != NULL) {
        return getModel(in_model.getName());
    }
    //eNX`ő吔ɒBĂȂ`FbN
    if(model.size() >= MAX_MODEL) {
        return NULL;
    }

    //eNX`ǉ
    model.push_back(in_model);
    model.back().setModelIndex((unsigned int)model.size()-1);

    return &model.back();

}


//////////////////////////////////////////////////
unsigned int GLGTModelManager_Singleton::popModel(void) {
    //model󂩃`FbN
    if(model.size() == 0) {
        return 0;
    }

    model.pop_back();
    return (unsigned int)model.size();
}



//////////////////////////////////////////////////
bool GLGTModelManager_Singleton::loadModel(GLGTModel<>& in_model) const{
    if(in_model.getType() == MODEL_UNKNOWN) {
        //gqtype𔻒fāAʂtypeɑB
    }

    if(in_model.getType() == MODEL_MQO) {
        return loadMQOModel(in_model);
    }

    return false;

}


//////////////////////////////////////////////////
bool GLGTModelManager_Singleton::loadMQOModel(GLGTModel<>& in_model) const{

    //---------- t@Cǂ (mۂȂ) ----------
    //t@C̃pX擾
    std::string filepath(GLGTUtility.getFilePath(in_model.name));
    //t@CI[v
    std::ifstream mqofile(in_model.name.c_str());
    if(!mqofile.is_open()){
        return false;
    }
    //
    in_model.deleteModelData();
    std::string line; //s
    std::vector<std::string> token_parsed; //ꂽg[N
    //std::istringstream tokenizer; //g[NiCU

    //}eAƃIuWFNg̐𒲂׃m
    //IuWFNg̖Oׂ
    unsigned int materialcount = 0;
    unsigned int objectcount = 0; //IuWFNg̑
    unsigned int objectsize = 0; //EFCgȂǂIuWFNg
    std::vector<std::string> objectname; //IuWFNg̖O
    std::vector<std::string> parentname; //eIuWFNg̖O
    std::vector<unsigned int> vertexcount; //_
    while(!mqofile.eof()) {
        getline(mqofile, line);
        GLGTUtility.parseString(token_parsed, line);
        if(token_parsed.size() == 0) {continue;}
        if(token_parsed[0] == "Object") {
            std::string namestr = token_parsed[1];
            GLGTUtility.replaceString(namestr,"#"," #"); // "#"" #"(#<-̎Oŋ؂邽)
            GLGTUtility.parseString(token_parsed, namestr);
            if(token_parsed[0][0] != '#'){ // ʂ̃IuWFNg
                objectname.push_back(token_parsed[0]); //OL
                //eq֌WL
                std::string temp_pname = "";
                for(unsigned int i = 1; i < token_parsed.size(); i++) {
                    if(token_parsed[i].size() < 4) {continue;}
                    if(token_parsed[i].substr(0,3) == "#<-") {
                        temp_pname = token_parsed[i].substr(3);
                    }
                }
                parentname.push_back(temp_pname);
                //_L
                token_parsed.clear();
                do {
                    getline(mqofile, line);
                    GLGTUtility.parseString(token_parsed, line);
                    if(token_parsed.size() == 0) {continue;}
                    if(token_parsed[0] == "}") {break;} // vertexȂꍇ
                } while(token_parsed[0] != "vertex");
                if(token_parsed[0] == "vertex") {
                    unsigned int size = (unsigned int)atoi(token_parsed[1].c_str());
                    vertexcount.push_back(size);
                }

                objectsize++;
            }
            objectcount++;
        }
        else if(token_parsed[0] == "Material") {
            materialcount = (unsigned int)atoi(token_parsed[1].c_str());
            in_model.modelMaterial.resize(materialcount+1);
        }
    }
    //}eÃmۂƃ}eAݒ̂Ȃ|Sp̃}eAZbg
    in_model.modelMaterial.resize(materialcount+1);
    in_model.modelMaterial[materialcount].color.set(1.0,1.0,1.0,1.0);
    //IuWFNg̃mۂƁAOZbgA_̃mہAeq֌WZbg
    in_model.modelObject.resize(objectsize);
    for(unsigned int i = 0; i<objectsize; i++) {
        in_model.modelObject[i].name = objectname[i];
        in_model.modelObject[i].vertex.resize(vertexcount[i]);
        in_model.modelObject[i].normal.resize(vertexcount[i]);
        in_model.modelObject[i].origVertex.resize(vertexcount[i]);
        in_model.modelObject[i].origNormal.resize(vertexcount[i]);
        in_model.modelObject[i].weight.resize(vertexcount[i]);
    }
    for(unsigned int i = 0; i<objectsize; i++) {
        for(unsigned int j = 0; j<objectsize; j++) {
            if(i == j) {continue;} //eƎqƂƂ͂肦ȂB
            if(in_model.modelObject[i].name == parentname[j]) {
                in_model.modelObject[i].childObject.push_back(&(in_model.modelObject[j]));
            }
        }

    }

    //---------- ObjectMaterial̃f[^ǂݍ ----------
    mqofile.clear();
    mqofile.seekg(0,std::ios::beg); //t@C̐擪ֈړ
    while(!mqofile.eof()) {
        getline(mqofile, line);
        GLGTUtility.parseString(token_parsed, line);
        if(token_parsed.size() == 0) {continue;}
        //---------- Material ----------
        if(token_parsed[0] == "Material")
        {
            for(unsigned int i=0; i<materialcount; i++)
            {
                getline(mqofile, line);
                GLGTUtility.replaceString(line, "(", " ");
                GLGTUtility.replaceString(line, ")", " ");
                GLGTUtility.parseString(token_parsed, line);

                std::string mat_name = token_parsed[0];
                GLGTColor4<double> mat_color(1.0,1.0,1.0,1.0);
                GLGTTexture mat_texture;

                for(std::string::size_type j = 1; j < token_parsed.size(); j++) {
                    if     (token_parsed[j] == "col") {
                        mat_color.r = atof(token_parsed[++j].c_str());
                        mat_color.g = atof(token_parsed[++j].c_str());
                        mat_color.b = atof(token_parsed[++j].c_str());
                        mat_color.a = atof(token_parsed[++j].c_str());
                    }
                    else if(token_parsed[j] == "tex") {
                        //eNX`ǂݍ
                        mat_texture = GLGTTextureManager.addTexture(filepath+token_parsed[++j]);
                    }
                    in_model.modelMaterial[i].set(mat_name, mat_color, mat_texture);

                }

            }
        }
        //---------- Object ----------
        else if(token_parsed[0] == "Object")
        {
            static unsigned int obj_index = 0;
            if(token_parsed[1].substr(0,2) == "#w"){ //EFCgݒ
                //@@@@@@@@@@@@@@@
            }
            else if(token_parsed[1][0] != '#'){ //ʂ̃IuWFNg
                //IuWFNg
                while(token_parsed[0] != "}") {
                    getline(mqofile, line);
                    GLGTUtility.replaceString(line, "(", " ");
                    GLGTUtility.replaceString(line, ")", " ");
                    GLGTUtility.parseString(token_parsed, line);
                    //_
                    if(token_parsed[0] == "vertex") {
                        unsigned int vertex_size = (unsigned int)atoi(token_parsed[1].c_str());
                        for(unsigned int i = 0; i < vertex_size; i++) {
                            getline(mqofile, line);
                            GLGTUtility.parseString(token_parsed, line);

                            in_model.modelObject[obj_index].origVertex[i].x = atof(token_parsed[0].c_str());
                            in_model.modelObject[obj_index].origVertex[i].y = atof(token_parsed[1].c_str());
                            in_model.modelObject[obj_index].origVertex[i].z = atof(token_parsed[2].c_str());
                            in_model.modelObject[obj_index].vertex[i] = in_model.modelObject[obj_index].origVertex[i];
                        }
                        getline(mqofile, line);//vertex } 
                    }
                    //ʉ
                    else if(token_parsed[0] == "face") {
                        unsigned int face_size = (unsigned int)atoi(token_parsed[1].c_str());
                        for(unsigned int i = 0; i < face_size; i++) {
                            getline(mqofile, line);
                            GLGTUtility.replaceString(line, "(", " ");
                            GLGTUtility.replaceString(line, ")", " ");
                            GLGTUtility.parseString(token_parsed, line);
                            unsigned int face_type = (unsigned int)atoi(token_parsed[0].c_str());
                            GLGTTriangle<double> temp_tri1;
                            GLGTTriangle<double> temp_tri2;
                            temp_tri1.materialindex = materialcount;
                            temp_tri2.materialindex = materialcount;
                            bool is_texture = false;
                            unsigned int v0,v1,v2,v3;
                            GLGTVector2<double> uv0,uv1,uv2,uv3;
                            for(unsigned int j = 1; j < token_parsed.size(); j++) {
                                //_CfbNX
                                if(token_parsed[j] == "V") {
                                    if(face_type == 3) {
                                        //tɊi[
                                        v0 = (unsigned int)atoi(token_parsed[++j].c_str());
                                        v1 = (unsigned int)atoi(token_parsed[++j].c_str());
                                        v2 = (unsigned int)atoi(token_parsed[++j].c_str());
                                        temp_tri1.vertexindex[0] = v0;
                                        temp_tri1.vertexindex[1] = v2;
                                        temp_tri1.vertexindex[2] = v1;
                                    }
                                    else if(face_type == 4) {
                                        //3p`ɕċtɊi[
                                        v0 = (unsigned int)atoi(token_parsed[++j].c_str());
                                        v1 = (unsigned int)atoi(token_parsed[++j].c_str());
                                        v2 = (unsigned int)atoi(token_parsed[++j].c_str());
                                        v3 = (unsigned int)atoi(token_parsed[++j].c_str());
                                        temp_tri1.vertexindex[0] = v0;
                                        temp_tri1.vertexindex[1] = v2;
                                        temp_tri1.vertexindex[2] = v1;
                                        temp_tri2.vertexindex[0] = v0;
                                        temp_tri2.vertexindex[1] = v3;
                                        temp_tri2.vertexindex[2] = v2;
                                    }
                                }
                                //}eACfbNX
                                else if(token_parsed[j] == "M") {
                                    if(face_type == 3) {
                                        temp_tri1.materialindex = (unsigned int)atoi(token_parsed[++j].c_str());
                                    }
                                    else if(face_type == 4) {
                                        temp_tri1.materialindex = (unsigned int)atoi(token_parsed[++j].c_str());
                                        temp_tri2.materialindex = temp_tri1.materialindex;
                                    }
                                    is_texture = in_model.modelMaterial[temp_tri1.materialindex].isTexture();
                                }
                                //CfbNX
                                else if(token_parsed[j] == "UV") {
                                    //㉺]
                                    if(face_type == 3) {
                                        uv0.x =      atof(token_parsed[++j].c_str());
                                        uv0.y = 1.0f-atof(token_parsed[++j].c_str());
                                        uv1.x =      atof(token_parsed[++j].c_str());
                                        uv1.y = 1.0f-atof(token_parsed[++j].c_str());
                                        uv2.x =      atof(token_parsed[++j].c_str());
                                        uv2.y = 1.0f-atof(token_parsed[++j].c_str());
                                        temp_tri1.uv[0] = uv0;
                                        temp_tri1.uv[1] = uv1;
                                        temp_tri1.uv[2] = uv2;
                                    }
                                    else if(face_type == 4) {
                                        uv0.x =      atof(token_parsed[++j].c_str());
                                        uv0.y = 1.0f-atof(token_parsed[++j].c_str());
                                        uv1.x =      atof(token_parsed[++j].c_str());
                                        uv1.y = 1.0f-atof(token_parsed[++j].c_str());
                                        uv2.x =      atof(token_parsed[++j].c_str());
                                        uv2.y = 1.0f-atof(token_parsed[++j].c_str());
                                        uv3.x =      atof(token_parsed[++j].c_str());
                                        uv3.y = 1.0f-atof(token_parsed[++j].c_str());
                                        temp_tri1.uv[0] = uv0;
                                        temp_tri1.uv[1] = uv2;
                                        temp_tri1.uv[2] = uv1;
                                        temp_tri2.uv[0] = uv0;
                                        temp_tri2.uv[1] = uv3;
                                        temp_tri2.uv[2] = uv2;
                                    }
                                }
                            }
                            if(is_texture) {
                                if(face_type == 3) {
                                    in_model.modelObject[obj_index].textureTriangle.push_back(temp_tri1);
                                }
                                else if(face_type == 4) {
                                    in_model.modelObject[obj_index].textureTriangle.push_back(temp_tri1);
                                    in_model.modelObject[obj_index].textureTriangle.push_back(temp_tri2);
                                }
                            }
                            else {
                                if(face_type == 3) {
                                    in_model.modelObject[obj_index].nonTextureTriangle.push_back(temp_tri1);
                                }
                                else if(face_type == 4) {
                                    in_model.modelObject[obj_index].nonTextureTriangle.push_back(temp_tri1);
                                    in_model.modelObject[obj_index].nonTextureTriangle.push_back(temp_tri2);
                                }
                            }
                        }

                        getline(mqofile, line); // }̍s΂
                    }

                }

            }
            obj_index++;
        }




    }
    return true;
}







