//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************
#include "GLGTMouseCursor.h"

#include "GLGTDefaultCursorTexture.h"






//////////////////////////////////////////////////
/// \brief RXgN^
GLGTMouseCursor::GLGTMouseCursor(void) {
    clear();


}


//////////////////////////////////////////////////
/// \brief fXgN^
GLGTMouseCursor::~GLGTMouseCursor() {


    destroy();
}


//////////////////////////////////////////////////
void GLGTMouseCursor::create(void) {
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    glGenTextures(1, &cursorTextureID);
    glBindTexture(GL_TEXTURE_2D, cursorTextureID);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA4,
        GLGTDEFAULTCURSORTEXTURE_WIDTH, GLGTDEFAULTCURSORTEXTURE_HEIGHT,
        0, GL_RGBA, GL_UNSIGNED_BYTE, defaultCursorTexturePixel);
    GLGTCHECKGLERROR();

    created = true;
}

//////////////////////////////////////////////////
void GLGTMouseCursor::destroy(void) {
    if(created) {
        glDeleteTextures(1,&cursorTextureID);
        GLGTCHECKGLERROR();
    }

    clear();

}


//////////////////////////////////////////////////
/// \brief
void GLGTMouseCursor::setCursorTexture(const GLGTTexture& in_texture) {
    cursorTexture = in_texture;
    if(cursorTexture.isReferring() == true) {
        glDeleteTextures(1,&cursorTextureID);
        glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
        glGenTextures(1, &cursorTextureID);
        glBindTexture(GL_TEXTURE_2D, cursorTextureID);
        glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA4,
            cursorTexture.getWidth(), cursorTexture.getHeight(),
            0, GL_RGBA, GL_UNSIGNED_BYTE, cursorTexture.getPixels());
    }
}

//////////////////////////////////////////////////
void GLGTMouseCursor::setDefaultCursorTexture(void) {
    cursorTexture.unrefer();
    glDeleteTextures(1,&cursorTextureID);
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    glGenTextures(1, &cursorTextureID);
    glBindTexture(GL_TEXTURE_2D, cursorTextureID);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA4,
        GLGTDEFAULTCURSORTEXTURE_WIDTH, GLGTDEFAULTCURSORTEXTURE_HEIGHT,
        0, GL_RGBA, GL_UNSIGNED_BYTE, defaultCursorTexturePixel);



}



//////////////////////////////////////////////////
void GLGTMouseCursor::drawMouseCursor(unsigned int ProjectionWidth, unsigned int ProjectionHeight) const {
    GLGTCHECKGLERROR();
    //O
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
    glOrtho(0.0, ProjectionWidth, ProjectionHeight, 0.0, -1.0, 1.0);
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();  
    glPushAttrib(GL_TEXTURE_BIT|GL_ENABLE_BIT|GL_COLOR_BUFFER_BIT);

    glEnable(GL_TEXTURE_2D);
    glDisable(GL_LIGHTING);
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_CULL_FACE);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
    glAlphaFunc(GL_GREATER,0.5f);
    glEnable(GL_ALPHA_TEST);

    glBindTexture(GL_TEXTURE_2D, cursorTextureID);
    //glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    //glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR); 
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE); 

    GLGTRect<int> cursorrect;
    if(cursorTexture.isReferring() == true) {
        cursorrect.left   = position.x - hotSpot.x;
        cursorrect.right  = cursorrect.left        + cursorTexture.getWidth();
        cursorrect.top    = position.y - hotSpot.y;
        cursorrect.bottom = cursorrect.top         + cursorTexture.getHeight();
    }
    else {
        cursorrect.left   = position.x - hotSpot.x;
        cursorrect.right  = cursorrect.left        + GLGTDEFAULTCURSORTEXTURE_WIDTH;
        cursorrect.top    = position.y - hotSpot.y;
        cursorrect.bottom = cursorrect.top         + GLGTDEFAULTCURSORTEXTURE_HEIGHT;
    }

    glColor4ubv(&cursorColor[0]);
    glBegin(GL_QUADS);

    glTexCoord2f(0.0f, 1.0f);
    glVertex3i(cursorrect.left , cursorrect.top   , 0);

    glTexCoord2f(0.0f, 0.0f);
    glVertex3i(cursorrect.left , cursorrect.bottom, 0);

    glTexCoord2f(1.0f, 0.0f);
    glVertex3i(cursorrect.right, cursorrect.bottom, 0);

    glTexCoord2f(1.0f, 1.0f);
    glVertex3i(cursorrect.right, cursorrect.top   , 0);

    glEnd();
    GLGTCHECKGLERROR();








    //㏈
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();
    glPopAttrib();

    GLGTCHECKGLERROR();



}





//////////////////////////////////////////////////
/// \brief vpeB
void GLGTMouseCursor::clear(void) {
    position.set(0,0);
    hotSpot.set(0,0);
    cursorColor.set(255,255,255,255);

    created = false;


}



