//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************
#include "GLGTScene.h"

//////////////////////////////////////////////////
//RXgN^
GLGTScene::GLGTScene(void) : eventFilter(GLGTEVENT_SIZE), eventHook(GLGTEVENT_SIZE) {
    sceneIndex = OWNSCENE;
    eventHook.clear();
    eventFilter.setAllFlag(true);
    activeScene = OWNSCENE;
    sceneDone = false;
    //childScene.reserve(MAXCHILDSCENESIZE/2);
    childScene.reserve(4);
}

//////////////////////////////////////////////////
// fXgN^
GLGTScene::~GLGTScene() {
    while(popChildScene() != 0) {} //SĂ̎qV[jB
    while(popForm() != 0) {} //SẴtH[j
}

//////////////////////////////////////////////////
//  popChildScene
unsigned int GLGTScene::popChildScene(void) {
    if(childScene.size() == 0) {
        return 0;
    }
    childScene.back()->onDestroyScene();
    //SceneIuWFNgfXgNg
    delete childScene.back();
    //GLGTchildScene폜
    childScene.pop_back();
    //childSceneɂȂ玩SceneANeBu
    if(activeScene >= childScene.size()) {
        activateScene();
    }


    return (unsigned int)childScene.size();
}



//////////////////////////////////////////////////
// activateScene
void GLGTScene::activateScene(unsigned int in_activescene) {
    GLGTASSERT((in_activescene == OWNSCENE)||(in_activescene < childScene.size()));

    unsigned int last_scene = activeScene;
    //LeaveSceneCxg𑗂
    assignLeaveSceneEvent(in_activescene);

    activeScene = in_activescene;

    //EnterSceneCxg𑗂
    assignEnterSceneEvent(last_scene);
}

//////////////////////////////////////////////////
void GLGTScene::activateScene(GLGTScene* in_activescene_ptr) {
    activateScene(in_activescene_ptr->getSceneIndex());
}



//////////////////////////////////////////////////
unsigned int GLGTScene::popForm(void) {
    if(forms.size() == 0) {
        return 0;
    }
    forms.back()->onDestroyForm();
    delete forms.back();
    forms.pop_back();
    return (unsigned int)forms.size();
}


//////////////////////////////////////////////////
void GLGTScene::changeMouseCursorVisible(GLGTEnum in_flag) {
    bool next_flag; // ύX̃tO

    //next_flagZbg
    //GLGT_TOGGLȄꍇGLGTMAINWINDOWFLAG_MOUSECURSORVISIBLE̋t̒lin_flagɑ
    if     (in_flag == GLGT_ENABLE) {next_flag = true;}
    else if(in_flag == GLGT_DISABLE) {next_flag = false;}
    else if(in_flag == GLGT_TOGGLE) {
        if((windowProperty.ptr->mainWindowFlag)[GLGTMAINWINDOWFLAG_MOUSECURSORVISIBLE] == true) {next_flag = false;}
        else {next_flag = true;}
    }
    else {return;}

    //GLGTMAINWINDOWFLAG_MOUSECURSORVISIBLEnext_flag̒lꍇ͉ȂB
    if((windowProperty.ptr->mainWindowFlag)[GLGTMAINWINDOWFLAG_MOUSECURSORVISIBLE] == next_flag) {
        return;
    }


    if(next_flag == true) {
        ShowCursor(TRUE);
        (windowProperty.ptr->mainWindowFlag)[GLGTMAINWINDOWFLAG_MOUSECURSORVISIBLE] = true;
    }
    else {
        ShowCursor(FALSE);
        (windowProperty.ptr->mainWindowFlag)[GLGTMAINWINDOWFLAG_MOUSECURSORVISIBLE] = false;
    }

}

//////////////////////////////////////////////////
void GLGTScene::changeCustomMouseCursor(GLGTEnum in_flag) {
    bool next_flag; // ύX̃tO

    //next_flagZbg
    //GLGT_TOGGLȄꍇGLGTMAINWINDOWFLAG_CUSTOMMOUSECURSOR̋t̒lin_flagɑ
    if     (in_flag == GLGT_ENABLE) {next_flag = true;}
    else if(in_flag == GLGT_DISABLE) {next_flag = false;}
    else if(in_flag == GLGT_TOGGLE) {
        if((windowProperty.ptr->mainWindowFlag)[GLGTMAINWINDOWFLAG_CUSTOMMOUSECURSOR] == true) {next_flag = false;}
        else {next_flag = true;}
    }
    else {return;}

    //GLGTMAINWINDOWFLAG_CUSTOMMOUSECURSORnext_flag̒lꍇ͉ȂB
    if((windowProperty.ptr->mainWindowFlag)[GLGTMAINWINDOWFLAG_CUSTOMMOUSECURSOR] == next_flag) {
        return;
    }

    if(next_flag == true) {
        ShowCursor(FALSE);
        (windowProperty.ptr->mainWindowFlag)[GLGTMAINWINDOWFLAG_CUSTOMMOUSECURSOR] = true;
    }
    else {
        ShowCursor(TRUE);
        (windowProperty.ptr->mainWindowFlag)[GLGTMAINWINDOWFLAG_CUSTOMMOUSECURSOR] = false;
    }








}

//////////////////////////////////////////////////
void GLGTScene::resizeWindow(int width, int height){
    //NCAg̈̃TCYvZ
    RECT rect;
    rect.left = windowProperty.ptr->windowRect.position.x;
    rect.top = windowProperty.ptr->windowRect.position.y;
    rect.right = rect.left + width;
    rect.bottom = rect.top + height;
    AdjustWindowRect(&rect, windowProperty.ptr->windowStyle, FALSE);
    //TCY
    MoveWindow(windowProperty.ptr->hWnd, windowProperty.ptr->windowRect.position.x, windowProperty.ptr->windowRect.position.y,
        rect.right - rect.left, height, TRUE);
    windowProperty.ptr->windowRect.dimension.x = width;
    windowProperty.ptr->windowRect.dimension.y = height;
}

//////////////////////////////////////////////////
// moveWindow
void GLGTScene::moveWindow(int x, int y){
    //NCAg̈̃TCYvZ
    RECT rect;
    rect.left = windowProperty.ptr->windowRect.position.x;
    rect.top = windowProperty.ptr->windowRect.position.y;
    rect.right = rect.left + windowProperty.ptr->windowRect.dimension.x;
    rect.bottom = rect.top + windowProperty.ptr->windowRect.dimension.y;
    //AdjustWindowRect(&rect, WS_OVERLAPPEDWINDOW, FALSE);
    AdjustWindowRect(&rect, windowProperty.ptr->windowStyle, FALSE);
    //ړ
    MoveWindow(windowProperty.ptr->hWnd, x, y, rect.right - rect.left, rect.bottom - rect.top, TRUE);    
    windowProperty.ptr->windowRect.position.x = x;
    windowProperty.ptr->windowRect.position.y = y;
}



