//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************
#include "GLGTStringBox.h"



//////////////////////////////////////////////////
GLGTStringBox::GLGTStringBox(const GLGTRectEXT* in_rect)
: ptrStringBoxRect(in_rect), GLGTRectBox(in_rect), stringBoxFlag(STRINGBOXFLAG_LAST), stringBoxMode(STRINGBOXMODE_LAST) {
    scale = 1;

    margin = 0;

    stringBoxMode.clear();
    stringBoxFlag.clear();

    defaultStringColor.set(255,255,255,255);

    clearString();
}

//////////////////////////////////////////////////
GLGTStringBox::~GLGTStringBox() {

}


//////////////////////////////////////////////////
void GLGTStringBox::clearString(void) {
    fontString.stringBuffer = (std::string)"";
    fontString.fontColor.clear();
}


//////////////////////////////////////////////////
void GLGTStringBox::printFmt(char* fmt, ...) {
    char buff[STRINGBOX_MAXPRINTFMT];
    va_list  vlist;
    va_start(vlist, fmt);
    vsprintf(buff, fmt, vlist);
    va_end(vlist);


    fontString.stringBuffer += buff;
    recalcStringPosition();

}

//////////////////////////////////////////////////
void GLGTStringBox::setStringColor(GLGTColor4<unsigned char>& in_color) {
    GLGTFontColor temp;
    temp.color = in_color;
    temp.column = (unsigned int)fontString.stringBuffer.size();

    //Ō̐F񂪍ǉFƈʒuꍇAuB
    if((fontString.fontColor.size() > 0)&&(fontString.fontColor.back().column == temp.column)) {
        fontString.fontColor.back().color = temp.color;
    }
    else {// Fǉ
        fontString.fontColor.push_back(temp);
    }


}
//////////////////////////////////////////////////
void GLGTStringBox::setStringColor(unsigned char r, unsigned char g, unsigned char b, unsigned char a) {
    GLGTFontColor temp;
    temp.color.set(r,g,b,a);
    temp.column = (unsigned int)fontString.stringBuffer.size();

    //Ō̐F񂪍ǉFƈʒuꍇAuB
    if((fontString.fontColor.size() > 0)&&(fontString.fontColor.back().column == temp.column)) {
        fontString.fontColor.back().color = temp.color;
    }
    else {// Fǉ
        fontString.fontColor.push_back(temp);
    }

}

//////////////////////////////////////////////////
void GLGTStringBox::drawStringBox(unsigned int projectionwidth, unsigned int projectionheight) {

    //O
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
    glOrtho(0.0, projectionwidth, projectionheight, 0.0, -1.0, 1.0);
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();  
    glPushAttrib(GL_TEXTURE_BIT|GL_ENABLE_BIT);

    glDisable(GL_LIGHTING);
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_CULL_FACE);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);


    // oEfBO{bNX`
    if(stringBoxMode[GLGTSTRINGBOXMODE_BOUNDINGBOX]) {
        GLGTRectBox::drawRect(projectionwidth, projectionheight);
    }


    glColor4ubv(&defaultStringColor[0]);
    GLGTFontRenderer.drawStringForGLGTStringBox(fontString,scale,stringPosition.x,stringPosition.y);



    //㏈
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();
    glPopAttrib();

}

//////////////////////////////////////////////////
void GLGTStringBox::recalcStringPosition(void) {
    stringPosition.y = ptrStringBoxRect->position.y
        +(ptrStringBoxRect->dimension.y-GLGTFontRenderer.getFontHeight()*scale)/2;
    if(stringBoxFlag[STRINGBOXFLAG_CENTERING] == true) {
        stringPosition.x = ptrStringBoxRect->position.x
            +(ptrStringBoxRect->dimension.x-GLGTFontRenderer.getFontWidth()*scale*fontString.stringBuffer.size())/2;
    }
    else if(stringBoxFlag[STRINGBOXFLAG_RIGHTADJUST] == true) {
        stringPosition.x = ptrStringBoxRect->position.x+ptrStringBoxRect->dimension.x
            -GLGTFontRenderer.getFontWidth()*scale*fontString.stringBuffer.size()-margin;
    }
    else {
        stringPosition.x = ptrStringBoxRect->position.x+margin;
    }

}

