//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************
#include "GLGTTextBox.h"



//////////////////////////////////////////////////
/// \brief RXgN^
GLGTTextBox::GLGTTextBox(const GLGTRectEXT* in_rect)
: ptrTextBoxRect(in_rect), GLGTRectBox(in_rect), textBoxMode(SIZE_GLGTTEXTBOXMODE) {
    textBoxMode.clear();
    scrollCount = 0;
    scale = 1;
    clearText();
    margin = 0;
    maxLineCount = 128;
    defaultTextColor.set(255,255,255,255);
}

//////////////////////////////////////////////////
/// \brief fXgN^
GLGTTextBox::~GLGTTextBox() {
}


//////////////////////////////////////////////////
void GLGTTextBox::clearText(void) {
    text.clear();
    text.push_back(GLGTFontString());
    text[0].stringBuffer = (std::string)"";

}

//////////////////////////////////////////////////
void GLGTTextBox::deleteTopLine(void) {
    if(text.size() > 1) {
        //폜sɐF񂪂ꍇA̍s̐擪ɒǉB
        if(text[0].fontColor.size() > 0) {
            //̍s̐擪ɐF񂪂ꍇ͒uBȂꍇ͒ǉ
            if(text[1].fontColor[0].column == 0) {
                text[1].fontColor[0].color = text[0].fontColor.back().color;
            }
            else {
                text[1].fontColor.push_front(text[0].fontColor.back());
                text[1].fontColor[0].column = 0;
            }
        }
        //s폜
        text.pop_front();
    }
    else {
        clearText();
    }
}

//////////////////////////////////////////////////
void GLGTTextBox::deleteBottomLine(void) {
    if(text.size() > 1) {
        text.pop_back();
    }
    else {
        clearText();
    }
}

//////////////////////////////////////////////////
void GLGTTextBox::deleteLastChar(void) {
    size_t line_size = text.back().stringBuffer.size();
    if(line_size == 0) { // Ō̍s̏ꍇ
        if(text.size() < 2) {return;}// 擪̍s̏ꍇ͏I
        deleteBottomLine();
        line_size = text.back().stringBuffer.size();
    }
    //Ō̈ꕶ폜
    text.back().stringBuffer.erase(line_size-1,1);
    //폜ꂽ̌ɃZbgĂF폜
    if(text.back().fontColor.back().column == line_size) {
        text.back().fontColor.pop_back();
    }
}


//////////////////////////////////////////////////
void GLGTTextBox::printFmt(char* fmt, ...) {
    char buff[TEXTBOX_MAXPRINTFMT];
    va_list  vlist;
    va_start(vlist, fmt);
    vsprintf(buff, fmt, vlist);
    va_end(vlist);


    text.back().stringBuffer += buff;
    arrangeBottomLine();

}

//////////////////////////////////////////////////
void GLGTTextBox::setTextColor(unsigned char r, unsigned char g, unsigned char b, unsigned char a) {
    GLGTFontColor temp;
    temp.color.set(r,g,b,a);
    temp.column = (unsigned int)text.back().stringBuffer.size();

    //Ō̐F񂪍ǉFƈʒuꍇAuB
    if((text.back().fontColor.size() > 0)&&(text.back().fontColor.back().column == temp.column)) {
        text.back().fontColor.back().color = temp.color;
    }
    else {// Fǉ
        text.back().fontColor.push_back(temp);
    }

}

//////////////////////////////////////////////////
void GLGTTextBox::setTextColor(const GLGTColor4<unsigned char>& in_color) {
    GLGTFontColor temp;
    temp.color = in_color;
    temp.column = (unsigned int)text.back().stringBuffer.size();

    //Ō̐F񂪍ǉFƈʒuꍇAuB
    if((text.back().fontColor.size() > 0)&&(text.back().fontColor.back().column == temp.column)) {
        text.back().fontColor.back().color = temp.color;
    }
    else {// Fǉ
        text.back().fontColor.push_back(temp);
    }

}

//////////////////////////////////////////////////
void GLGTTextBox::drawTextBox(unsigned int projectionwidth, unsigned int projectionheight) {

    //O
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
    glOrtho(0.0, projectionwidth, projectionheight, 0.0, -1.0, 1.0);
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();  
    glPushAttrib(GL_TEXTURE_BIT|GL_ENABLE_BIT);

    glDisable(GL_LIGHTING);
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_CULL_FACE);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);


    // oEfBO{bNX`
    if(textBoxMode[GLGTTEXTBOXMODE_BOUNDINGBOX]) {
        GLGTRectBox::drawRect(projectionwidth, projectionheight);
    }

    //ŏ̐FKp
    glColor4ubv(&defaultTextColor[0]);
    //XN[Ăꍇ́ÂڂĐF񂪂邩ׂB
    if(scrollCount != 0) {
        for(unsigned int i = scrollCount; i > 0; i--) {
            if(text[i-1].fontColor.size() > 0) { //F񔭌I
                glColor4ubv(&(text[i-1].fontColor.back().color[0]));
                break;
            }
        }
    }

    if(scrollCount >= text.size()) {return;}
    unsigned int end;
    if(text.size() > maxRow+scrollCount) {
        end = maxRow+scrollCount;
    }
    else {
        end = (unsigned int)text.size();
    }


    GLGTFontRenderer.drawTextForGLGTTextBox(text,scale,scrollCount,end,textPosition.x,textPosition.y);




    //㏈
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();
    glPopAttrib();


}

//////////////////////////////////////////////////
void GLGTTextBox::arrangeText(void) {
    unsigned int bottom_index = (unsigned int)text.size()-1;
    // sɂ܂Ƃ߂B
    while(bottom_index != 0) {
        //FO̍sɕtB
        for(unsigned int i = 0; i < text[bottom_index].fontColor.size(); i++) {
            text[bottom_index].fontColor[i].column += (unsigned int)text[bottom_index-1].stringBuffer.size();
            text[bottom_index-1].fontColor.push_back(text[bottom_index].fontColor[i]);
        }

        //eLXgsO̍sɕtB
        text[bottom_index-1].stringBuffer += text[bottom_index].stringBuffer;

        text.pop_back();

        bottom_index--;

    }
    // `B
    arrangeBottomLine();
}

//////////////////////////////////////////////////
void GLGTTextBox::arrangeBottomLine(void) {
    unsigned int char_index = 0;
    while(text.back().stringBuffer.size() > char_index) {
        if(text.back().stringBuffer[char_index] == '\n') { // \nꍇ
            GLGTFontString temp_line; //textɒǉB
            temp_line.stringBuffer = text.back().stringBuffer.substr(char_index+1);// \nȍ~s̍Ōɒǉ
            text.back().stringBuffer.erase(char_index+1);// \nȍ~폜(\n͎c)

            // ǉsɑׂF񂪂ꍇAǉsɕtB
            if(text.back().fontColor.size() > 0) {
                while(text.back().fontColor.back().column >= text.back().stringBuffer.size()) {
                    text.back().fontColor.back().column -= (unsigned int)text.back().stringBuffer.size();
                    temp_line.fontColor.push_front(text.back().fontColor.back());
                    text.back().fontColor.pop_back();
                    if(text.back().fontColor.size() == 0) {break;}
                }
            }

            text.push_back(temp_line);

            char_index = 0;
        }
        else if(maxColumn <= char_index) { // s̍ő咷𒴂ꍇ
            GLGTFontString temp_line; //textɒǉB
            temp_line.stringBuffer = text.back().stringBuffer.substr(char_index);// s̍Ōɒǉ
            text.back().stringBuffer.erase(char_index);// 폜

            // ǉsɑׂF񂪂ꍇAǉsɕtB
            if(text.back().fontColor.size() > 0) {
                while(text.back().fontColor.back().column >= text.back().stringBuffer.size()) {
                    text.back().fontColor.back().column -= (unsigned int)text.back().stringBuffer.size(); // ǉs̗ԍɕύX
                    temp_line.fontColor.push_front(text.back().fontColor.back()); // ǉsɒǉ
                    text.back().fontColor.pop_back(); //̍s폜
                    if(text.back().fontColor.size() == 0) {break;}
                }
            }
            text.push_back(temp_line);

            char_index = 0;
        }
        else {
            char_index++;
        }


    }

    //sősȉɂȂ܂Ő擪̍sĂ
    if(maxLineCount != 0) {
        while(maxLineCount < getLineCount()) {deleteTopLine();}
    }

}



