//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************
#include "GLGTTime.h"



//////////////////////////////////////////////////
// RXgN^
GLGTTime_Singleton::GLGTTime_Singleton(void) {
    clear();
    timeBeginPeriod(precision);

}

//////////////////////////////////////////////////
// fXgN^
GLGTTime_Singleton::~GLGTTime_Singleton(){
    timeEndPeriod(precision);
    destroy();

}

//////////////////////////////////////////////////
// destroy
void GLGTTime_Singleton::destroy(void){
    clear();
}

//////////////////////////////////////////////////
// clear
void GLGTTime_Singleton::clear(void){
    initTime = getTime();
    precision = 10;
}

//////////////////////////////////////////////////
// getPrecision
unsigned int GLGTTime_Singleton::getPrecision(void){
    return precision;
}

//////////////////////////////////////////////////
// set
unsigned int GLGTTime_Singleton::setPrecision(unsigned int in_precision){
    TIMECAPS timecaps;
    timeGetDevCaps(&timecaps, sizeof(timecaps));
    if(in_precision < timecaps.wPeriodMin) {
        in_precision = timecaps.wPeriodMin;
    }
    else if(in_precision > timecaps.wPeriodMax) {
        in_precision = timecaps.wPeriodMax;
    }

    //ŏ^C}\Ăݒ肷B
    timeEndPeriod(precision);
    timeBeginPeriod(in_precision);
    precision = in_precision;
    return precision;
}












