/***************************************************
* 
* 
* 
* 
* 
***************************************************/

#include <iostream>
#include "GLGT.h"
#include "GLGTTextBoxForm.h"
#include "GLGTPushButtonForm.h"
#include "GLGTConsoleScene.h"
#include "GLGTBackgroundForm.h"

using namespace std;


/***************************************************
* 
* 
* 
*/
class test_MainWin : public GLGTMainWindow{
protected:
    GLGTConsoleScene* testconsole;
    GLGTBackgroundForm* texBg;
    GLGTPushButtonForm* pushbtn1;
    GLGTTextBoxForm* msgBox;
public:
    void onCreateScene(void);
    void onEnterScene(unsigned int lastscene);
    void onLeaveScene(unsigned int nextscene);
    void onResizeWindow(unsigned int width, unsigned int height);
    void onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar);
    void onIdle(void);

};


void test_MainWin::onCreateScene(void) {
    windowProperty.getMainWindowMode()[GLGTMAINWINDOWMODE_AUTOSWAPBUFFERS] = true;
    windowProperty.getMainWindowMode()[GLGTMAINWINDOWMODE_AUTODRAWALLFORM] = true;
    changeCustomMouseCursor(GLGT_ENABLE);

    //R\[ǉ
    testconsole = pushChildScene<GLGTConsoleScene>();
    testconsole->setTriggerKeyToLeaveScene(KEY_TAB);
    testconsole->consoleMode[GLGTCONSOLEBOXMODE_AUTOINSERTION] = true;

    //BackgroundtH[ǉ
    texBg = pushForm<GLGTBackgroundForm>();
    texBg->setRectTexture((string)"back.TGA");
    texBg->setRectTextureCoord(0,10,0,10);

    //eLXg{bNXǉ
    msgBox = pushForm<GLGTTextBoxForm>();
    msgBox->textBoxMode[GLGTTEXTBOXMODE_BOUNDINGBOX] = true;
    msgBox->setRectColor(191,191,191,191);
    msgBox->moveForm(200,300);
    msgBox->resizeForm(400,250);
    msgBox->printFmt("Push TAB key , then open/close console.\n");

    //eLXg{bNXǉ
    pushbtn1 = pushForm<GLGTPushButtonForm>();
    pushbtn1->moveForm(200,280);
    pushbtn1->resizeForm(100,20);
    pushbtn1->setString((std::string)"open console");


    //OpenGL
    glClearColor(0.0, 0.0, 0.0, 0.0);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
    glDisable(GL_TEXTURE_2D);
    glShadeModel(GL_SMOOTH);
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
    gluLookAt(0, 0, 0, 0, 0, -1000, 0.0, 1.0, 0.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    swapBuffers();

}
void test_MainWin::onEnterScene(unsigned int lastscene) {
}

void test_MainWin::onLeaveScene(unsigned int nextscene) {
}

void test_MainWin::onResizeWindow(unsigned int width, unsigned int height){
    glViewport(0, 0, width, height);
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    gluPerspective(45, (double)width/(double)height, 1, 1000);
    glMatrixMode( GL_MODELVIEW );
}

void test_MainWin::onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar) {
    switch(keycode) {
        case KEY_ESCAPE:
            leaveScene();//V[𔲂(I)
            break;
        case KEY_F4:
            if(GLGTKey.getKeyState(KEY_ALT) == GLGT_KEYDOWN) {leaveScene();}//V[𔲂(I)
            break;
        case KEY_TAB:
            activateScene(testconsole);
            break;
        default:
            break;
    }
}

void test_MainWin::onIdle(void) {

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();

    if(pushbtn1->isPushedAndReleased() == true) {
        msgBox->printFmt("push button 1 is pushed.\n");
        activateScene(testconsole);
    }

    if(isActiveScene(testconsole) == true) {
        static std::string consolestr;
        if(testconsole->getInputtedString(consolestr) == true) {
            std::string temp = "inputted from \"test_console\"";
            testconsole->insertLineToLogText(temp,GLGTColor4<unsigned char>(63,191,63,255));
            msgBox->printFmt("[%s]\n",consolestr.c_str());
            msgBox->pageReset();
        }
    }


}

















/***************************************************
* 
* 
* 
*/
int main(void) {

    GLGTInit();
    test_MainWin mainwin;
    mainwin.create();
    mainwin.run();

    GLGTQuit();

    return 0;
}





