/***************************************************
* 
* 
* 
* 
* 
***************************************************/

#include <iostream>
#include "GLGT.h"
#include "GLGTTextBoxForm.h"
#include "GLGTRectForm.h"
#include "GLGTBackgroundForm.h"
#include "GLGTPushButtonForm.h"

using namespace std;


/***************************************************
* 
* 
* 
*/
class test_form : public GLGTMainWindow{
protected:
    GLGTBackgroundForm* texBg;
    GLGTRectForm* texRect;
    GLGTRectForm* colorRect;
    GLGTTextBoxForm* msgBox;
    GLGTPushButtonForm* pushbtn1;
    GLGTPushButtonForm* pushbtn2;
    GLGTPushButtonForm* pushbtn3;


public:
    void drawBackGround(void);

    void onCreateScene(void);
    void onResizeWindow(unsigned int width, unsigned int height);
    void onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar);
    void onIdle(void);

};


void test_form::onCreateScene(void) {
    windowProperty.getMainWindowMode()[GLGTMAINWINDOWMODE_AUTOSWAPBUFFERS] = true;
    windowProperty.getMainWindowMode()[GLGTMAINWINDOWMODE_AUTODRAWALLFORM] = true;
    GLGTProfiler.profilerMode[GLGTPROFILERMODE_ENABLE] =true;
    changeCustomMouseCursor(GLGT_ENABLE);



    //BackgroundtH[ǉ
    texBg = pushForm<GLGTBackgroundForm>();
    texBg->setRectTexture((string)"background.TGA");
    texBg->setRectTextureCoord(0,5,0,4);

    //RecttH[ǉ
    texRect = pushForm<GLGTRectForm>();
    texRect->moveForm(10,300);
    texRect->resizeForm(300,200);
    texRect->setRectTexture((string)"texrect.TGA");

    //RecttH[ǉ
    colorRect = pushForm<GLGTRectForm>();
    colorRect->moveForm(300,10);
    colorRect->resizeForm(100,100);
    colorRect->setRectColor(255,0,255,127);
    //eLXg{bNXǉ
    msgBox = pushForm<GLGTTextBoxForm>();
    GLGTASSERT(msgBox != NULL);
    msgBox->textBoxMode[GLGTTEXTBOXMODE_BOUNDINGBOX] = true;
    msgBox->setRectColor(63,63,63,127);
    msgBox->moveForm(400,300);
    msgBox->resizeForm(300,200);
    msgBox->printFmt("GLGTTextBox\n");

    //vbV{^ǉ
    pushbtn1 = pushForm<GLGTPushButtonForm>();
    pushbtn1->setString((std::string)"Profiler");
    pushbtn1->moveForm(400,280);
    pushbtn1->resizeForm(100,20);
    pushbtn2 = pushForm<GLGTPushButtonForm>();
    pushbtn2->setString((std::string)"scale x2");
    pushbtn2->moveForm(500,280);
    pushbtn2->resizeForm(100,20);
    pushbtn3 = pushForm<GLGTPushButtonForm>();
    pushbtn3->setString((std::string)"scale x1");
    pushbtn3->moveForm(600,280);
    pushbtn3->resizeForm(100,20);

    //OpenGL
    glClearColor(0.0, 0.0, 0.0, 0.0);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
    glShadeModel(GL_SMOOTH);
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
    gluLookAt(0, 0, 0, 0, 0, -1000, 0.0, 1.0, 0.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

}

void test_form::onResizeWindow(unsigned int width, unsigned int height){
    glViewport(0, 0, width, height);
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    gluPerspective(45, (double)width/(double)height, 1, 1000);
    glMatrixMode( GL_MODELVIEW );
}

void test_form::onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar) {
    switch(keycode) {
        case KEY_ESCAPE:
            leaveScene();//V[𔲂(I)
            break;
        case KEY_F4:
            if(GLGTKey.getKeyState(KEY_ALT) == GLGT_KEYDOWN) {leaveScene();}//V[𔲂(I)
            break;
        case KEY_TAB:
            break;
        default:
            break;
    }
}

void test_form::onIdle(void) {

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();

    if(pushbtn1->isPushedAndReleased() == true) {
        if(GLGTProfiler.profilerMode[GLGTPROFILERMODE_ENABLE] == true) {
            GLGTProfiler.profilerMode[GLGTPROFILERMODE_ENABLE] =false;
        }
        else {
            GLGTProfiler.profilerMode[GLGTPROFILERMODE_ENABLE] =true;
        }
        msgBox->printFmt("Profiler\n");
    }
    if(pushbtn2->isPushedAndReleased() == true) {
        msgBox->printFmt("scale x2\n");
        msgBox->setScale(2);
    }
    if(pushbtn3->isPushedAndReleased() == true) {
        msgBox->printFmt("scale x1\n");
        msgBox->setScale(1);
    }

}

















/***************************************************
* 
* 
* 
*/
int main(void) {

    GLGTInit();
    test_form mainwin;
    mainwin.create();
    mainwin.run();

    GLGTQuit();

    return 0;
}





