#include <iostream>
#include "GLGT.h"

using namespace std;

class testmainwin : public GLGTMainWindow {
    void onEnterScene(void);
    void onResizeWindow(unsigned int width, unsigned int height);
    void onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar);
    void onMouseDown(GLGTMouseButton button, int x, int y, int last_x, int last_y);
    void onIdle(void);


};


void testmainwin::onEnterScene() {
    glClearColor(0.0, 0.0, 0.0, 0.0);
    glShadeModel(GL_SMOOTH);
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
    gluLookAt(0, 0, 0, 0, 0, -1000, 0.0, 1.0, 0.0);

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);



}

void testmainwin::onResizeWindow(unsigned int width, unsigned int height){
    glViewport(0, 0, width, height);
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    gluPerspective(45, (double)width/(double)height, 1, 1000);
    glMatrixMode( GL_MODELVIEW );
}

void testmainwin::onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar) {
    switch(keycode) {
        case KEY_ESCAPE:
            leaveScene();//V[𔲂(I)
            break;
        case KEY_F4:
            if(GLGTKey.getKeyState(KEY_ALT) == GLGT_KEYDOWN) {leaveScene();}//V[𔲂(I)
            break;
        default:
            cout << GLGTKey.getKeyName(keycode).c_str() << "L[܂B";
            if(keychar != NULL) {
                cout << " \'" << keychar << "\'" << endl;
            }
            else {
                cout <<endl;
            }
            break;
    }
}

void testmainwin::onMouseDown(GLGTMouseButton button, int x, int y, int last_x, int last_y) {
    cout << GLGTMouse.getMouseButtonName(button).c_str() << "{^܂ ("
        << last_x << "," << last_y << ") -> ("<< x << "," << y << ")"<< endl;
}

void testmainwin::onIdle() {
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();

    static float rollx = 0;
    static float rollz = 0;
    if(rollx > 360) {rollx -= 360;}
    if(rollz > 360) {rollz -= 360;}
    rollx += 0.5f;
    rollz += 1.0f;

    glTranslatef(0, 0, -5);
    glRotatef(rollx, 1, 0, 0);
    glRotatef(rollz, 0, 0, 1);

    glBegin(GL_QUADS);
    glNormal3f(0.0,0.0,1.0);
    glColor4f(1.0,1.0,1.0,1.0);
    glVertex3f( 1.0, 1.0, 0.0);
    glColor4f(1.0,0.0,0.0,1.0);
    glVertex3f(-1.0, 1.0, 0.0);
    glColor4f(0.0,1.0,0.0,1.0);
    glVertex3f(-1.0,-1.0, 0.0);
    glColor4f(0.0,0.0,1.0,1.0);
    glVertex3f( 1.0,-1.0, 0.0);
    glEnd();

    swapBuffers();
    GLGTCHECKGLERROR();

}

int main(void){
    GLGTInit();
    testmainwin testmw;
    testmw.create();
    testmw.run();
    GLGTQuit();
    return 0;
}

