/***************************************************
* 
* 
* 
* 
* 
***************************************************/

#include <iostream>
#include "GLGT.h"
#include "GLGTTextBoxForm.h"

using namespace std;


/***************************************************
* 
* 
* 
*/
class mainwin_testmodel : public GLGTMainWindow{
protected:
    GLGTTextBoxForm* msgBox;
    GLGTModel<>* model;

public:

    void onCreateScene(void);
    void onResizeWindow(unsigned int width, unsigned int height);
    void onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar);
    void onIdle(void);

};


void mainwin_testmodel::onCreateScene(void) {
    //eLXg{bNXǉ
    msgBox = pushForm<GLGTTextBoxForm>();
    GLGTASSERT(msgBox != NULL);
    msgBox->textBoxMode[GLGTTEXTBOXMODE_BOUNDINGBOX] = true;
    msgBox->setRectColor(63,63,63,127);
    msgBox->moveForm(400,300);
    msgBox->resizeForm(300,200);
    msgBox->printFmt("test_mqo");

    //fǂݍ
    model = GLGTModelManager.pushModel("modeldata/test_model01.mqo",MODEL_MQO);

    //OpenGL
    glClearColor(0.0, 0.0, 0.0, 0.0);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
    glShadeModel(GL_SMOOTH);
    glDepthFunc(GL_LEQUAL);
    glEnable(GL_DEPTH_TEST);
    glCullFace(GL_BACK); 
    glEnable(GL_CULL_FACE);
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
    gluLookAt(0, 0, 0, 0, 0, -1000, 0.0, 1.0, 0.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    swapBuffers();

}

void mainwin_testmodel::onResizeWindow(unsigned int width, unsigned int height){
    glViewport(0, 0, width, height);
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    gluPerspective(45, (double)width/(double)height, 1, 1000);
    glMatrixMode( GL_MODELVIEW );
}

void mainwin_testmodel::onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar) {
    switch(keycode) {
        case KEY_ESCAPE:
            leaveScene();//V[𔲂(I)
            break;
        case KEY_F4:
            if(GLGTKey.getKeyState(KEY_ALT) == GLGT_KEYDOWN) {leaveScene();}//V[𔲂(I)
            break;
        default:
            break;
    }
}

void mainwin_testmodel::onIdle(void) {

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();



    model->drawModel();
    drawAllForm();

    swapBuffers();
}







int main(void){
    GLGTInit();

    mainwin_testmodel mw_tm;
    mw_tm.create();
    mw_tm.run();
    GLGTQuit();
    return 0;
}

