
#include "GLGT.h"
#include "GLGTTextBoxForm.h"
#include "GLGTPushButtonForm.h"






class test_cursor : public GLGTMainWindow{
protected:
    GLGTTexture big_cursor;
    GLGTPushButtonForm* pushbtn_mousevisible;
    GLGTPushButtonForm* pushbtn_custommouse;
    GLGTPushButtonForm* pushbtn_cursortype;


public:
    void onCreateScene(void);
    void onResizeWindow(unsigned int width, unsigned int height);
    void onIdle(void);



};



void test_cursor::onCreateScene(void) {
    // C[vɓ钼Ȍ
    windowProperty.getMainWindowMode()[GLGTMAINWINDOWMODE_AUTOSWAPBUFFERS] = true;
    windowProperty.getMainWindowMode()[GLGTMAINWINDOWMODE_AUTODRAWALLFORM] = true;
    changeCustomMouseCursor(GLGT_ENABLE);


    //eNX`ǉ
    big_cursor = GLGTTextureManager.addTexture((std::string)"big_cursor.tga");


    //vbV{^ǉ
    pushbtn_mousevisible = pushForm<GLGTPushButtonForm>();
    pushbtn_mousevisible->setString((std::string)"Toggle mouse visible");
    pushbtn_mousevisible->setScale(2);
    pushbtn_mousevisible->moveForm(240,270);
    pushbtn_mousevisible->resizeForm(320,30);

    pushbtn_custommouse = pushForm<GLGTPushButtonForm>();
    pushbtn_custommouse->setString((std::string)"Toggle custom mouse cursor");
    pushbtn_custommouse->setScale(2);
    pushbtn_custommouse->moveForm(240,300);
    pushbtn_custommouse->resizeForm(320,30);

    pushbtn_cursortype = pushForm<GLGTPushButtonForm>();
    pushbtn_cursortype->setString((std::string)"Toggle cursor type");
    pushbtn_cursortype->setScale(2);
    pushbtn_cursortype->moveForm(240,330);
    pushbtn_cursortype->resizeForm(320,30);




    //OpenGL
    glClearColor(0.0, 0.0, 0.0, 0.0);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
    glShadeModel(GL_SMOOTH);
    glDepthFunc(GL_LEQUAL);
    glEnable(GL_DEPTH_TEST);
    glCullFace(GL_BACK); 
    glEnable(GL_CULL_FACE);
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
    gluLookAt(0, 0, 0, 0, 0, -1000, 0.0, 1.0, 0.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);


}

void test_cursor::onResizeWindow(unsigned int width, unsigned int height) {
    // EBhẼTCYύXꂽ̏
    glViewport(0, 0, width, height);
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    gluPerspective(45, (double)width/(double)height, 1, 1000);
    glMatrixMode( GL_MODELVIEW );

}


void test_cursor::onIdle(void) {
    // ACh̏
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    if(pushbtn_mousevisible->isPushedAndReleased() == true) {
        changeMouseCursorVisible(GLGT_TOGGLE);
    }
    if(pushbtn_custommouse->isPushedAndReleased() == true) {
        changeCustomMouseCursor(GLGT_TOGGLE);

    }
    if(pushbtn_cursortype->isPushedAndReleased() == true) {
        static bool cursor_big = false;
        if(cursor_big == true) {
            windowProperty.getMouseCursor().setDefaultCursorTexture();
            cursor_big = false;
        }
        else {
            windowProperty.getMouseCursor().setCursorTexture(big_cursor);
            cursor_big = true;
        }

    }










}


int main(void) {

    GLGTInit();
    test_cursor mainwin;
    mainwin.create();
    mainwin.run();

    GLGTQuit();










return 0;
}

