/***************************************************
* 
* 
* 
* 
* 
***************************************************/

#include <iostream>
#include "GLGT.h"
#include "GLGTTextBoxForm.h"
#include "GLGTBackgroundForm.h"

using namespace std;


/***************************************************
* 
* 
* 
*/
class test_AnotherScene : public GLGTScene{  

    //SceneCxg
    void onIdle(void);
    void onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar);
};

void test_AnotherScene::onIdle(void) {
    static float r = 0;
    glColor4ub(255,127,127,127);
    glRotatef(r*10,0,0,1);
    glTranslatef(5,0,-50);
    glRotatef(r*100,1,1,1);
    GLGTShapes.drawCube(10);
    swapBuffers();
    r+=1;

}
void test_AnotherScene::onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar) {
    switch(keycode) {
        case KEY_1:
            leaveScene();
            break;
        default:
            break;
    }
}

/***************************************************
* 
* 
* 
*/
class test_MainWin : public GLGTMainWindow{
protected:
    test_AnotherScene* anotherScene;
    
    GLGTBackgroundForm* background;
    GLGTTextBoxForm* msgBox;
public:
    void drawBackGround(void);

    void onCreateScene(void);
    void onEnterScene(unsigned int lastscene);
    void onLeaveScene(unsigned int nextscene);
    void onResizeWindow(unsigned int width, unsigned int height);
    void onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar);
    void onIdle(void);

};


void test_MainWin::onCreateScene(void) {
    //obNOEhǉ
    background = pushForm<GLGTBackgroundForm>();
    background->setRectColor(GLGTColor4<unsigned char>(32,32,255,255));
    //V[ǉ
    anotherScene = pushChildScene<test_AnotherScene>();
    anotherScene->eventHook[GLGTEVENT_IDLE] = true;
    GLGTASSERT(anotherScene != NULL);
    //eLXg{bNXǉ
    msgBox = pushForm<GLGTTextBoxForm>();
    GLGTASSERT(msgBox != NULL);
    msgBox->textBoxMode[GLGTTEXTBOXMODE_BOUNDINGBOX] = true;
    msgBox->setRectColor(GLGTColor4<unsigned char>(63,63,63,127));
    msgBox->moveForm(10,10);
    msgBox->resizeForm(300,200);
    msgBox->printFmt("hello.\n1 - enter main scene.\n2- enter another scene.\n\n");

    //OpenGL
    glClearColor(0.0, 0.0, 0.0, 0.0);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
    glDisable(GL_TEXTURE_2D);
    glShadeModel(GL_SMOOTH);
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
    gluLookAt(0, 0, 0, 0, 0, -1000, 0.0, 1.0, 0.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    swapBuffers();

}
void test_MainWin::onEnterScene(unsigned int lastscene) {
    msgBox->setTextColor(127,127,255,255);
    msgBox->printFmt("enter main scene.\n");
}

void test_MainWin::onLeaveScene(unsigned int nextscene) {
    msgBox->setTextColor(127,255,127,255);
    msgBox->printFmt("leave main scene.\n");
}

void test_MainWin::onResizeWindow(unsigned int width, unsigned int height){
    glViewport(0, 0, width, height);
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    gluPerspective(45, (double)width/(double)height, 1, 1000);
    glMatrixMode( GL_MODELVIEW );
}

void test_MainWin::onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar) {
    switch(keycode) {
        case KEY_ESCAPE:
            leaveScene();//V[𔲂(I)
            break;
        case KEY_F4:
            if(GLGTKey.getKeyState(KEY_ALT) == GLGT_KEYDOWN) {leaveScene();}//V[𔲂(I)
            break;
        case KEY_2:
            activateScene(anotherScene);
            break;
        default:
            break;
    }
}

void test_MainWin::onIdle(void) {

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();


    drawAllForm();

    if(isActive()) {swapBuffers();}
}

















/***************************************************
* 
* 
* 
*/
int main(void) {

    GLGTInit();
    test_MainWin mainwin;
    mainwin.create();
    mainwin.run();

    GLGTQuit();

    return 0;
}





