#include <iostream>
#include "GLGT.h"
#include "GLGTTextBoxForm.h"

using namespace std;

class test_textbox : public GLGTMainWindow {

    GLGTTextBoxForm* textBox01;
    //unsigned int textBoxIndex;

    void onCreateScene(void);
    void onEnterScene(void);
    void onResizeWindow(unsigned int width, unsigned int height);
    void onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar);
    void onMouseDown(GLGTMouseButton button, int x, int y, int last_x, int last_y);
    void onIdle(void);


};


void test_textbox::onCreateScene() {
    windowProperty.getMainWindowMode()[GLGTMAINWINDOWMODE_AUTOSWAPBUFFERS] = true;
    windowProperty.getMainWindowMode()[GLGTMAINWINDOWMODE_AUTODRAWALLFORM] = true;
    changeCustomMouseCursor(GLGT_ENABLE);

    textBox01 = pushForm<GLGTTextBoxForm>();
    textBox01->textBoxMode[GLGTTEXTBOXMODE_BOUNDINGBOX] = true;
    textBox01->setRectColor(GLGTColor4<unsigned char>(127,127,127,127));
    textBox01->setMargin(2);
    textBox01->resizeForm(250,34);

    glClearColor(0.0, 0.0, 0.0, 0.0);
    glShadeModel(GL_SMOOTH);
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
    gluLookAt(0, 0, 0, 0, 0, -1000, 0.0, 1.0, 0.0);

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

}

void test_textbox::onEnterScene() {
}

void test_textbox::onResizeWindow(unsigned int width, unsigned int height){
    glViewport(0, 0, width, height);
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    gluPerspective(45, (double)width/(double)height, 1, 1000);
    glMatrixMode( GL_MODELVIEW );
}

void test_textbox::onKeyDown(GLGTKeyCode keycode, bool repeat, char keychar) {
    switch(keycode) {
        case KEY_ESCAPE:
            leaveScene();//V[𔲂(I)
            break;
        case KEY_F4:
            if(GLGTKey.getKeyState(KEY_ALT) == GLGT_KEYDOWN) {leaveScene();}//V[𔲂(I)
            break;
        default:
            textBox01->setTextColor(0,255,255,255);
            if(keychar != NULL) {
                textBox01->printFmt("%s key pushed. (\'%c\')\n",GLGTKey.getKeyName(keycode).c_str(),keychar);
            }
            else {
                textBox01->printFmt("%s key pushed.\n",GLGTKey.getKeyName(keycode).c_str());
            }
            break;
    }
}

void test_textbox::onMouseDown(GLGTMouseButton button, int x, int y, int last_x, int last_y) {
    if(button == MOUSE_WHEELUP) {
        textBox01->pageUp();
    }
    else if(button == MOUSE_WHEELDOWN) {
        textBox01->pageDown();
    }
    else {
        textBox01->setTextColor(255,255,0,255);
        textBox01->printFmt("%s pushed. (%d,%d)->(%d,%d)\n",GLGTMouse.getMouseButtonName(button).c_str(),last_x,last_y,x,y);
    }
}
void test_textbox::onIdle() {
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();

    static float rollx = 0;
    static float rollz = 0;
    if(rollx > 360) {rollx -= 360;}
    if(rollz > 360) {rollz -= 360;}
    rollx += 0.5f;
    rollz += 1.0f;

    glDisable(GL_CULL_FACE);
    glDisable(GL_TEXTURE_2D);

    glColor4f(1.0f,0.0f,1.0f,1.0f);

    glTranslatef(0, 0, -100);
    glRotatef(rollx, 1, 0, 0);
    glRotatef(rollz, 0, 0, 1);
    glColor4f(1.0f,0.0f,1.0f,1.0f);
    GLGTShapes.drawCube(30);
}

int main(void){
    GLGTInit();
    test_textbox testtb;
    testtb.create();
    testtb.run();
    GLGTQuit();
    return 0;
}

